﻿Imports System.IO
Public Class frmConfig

    Private Sub frmConfig_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        frmMenu.Visible = True
    End Sub

    Private Sub frmConfig_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim Verif As Boolean = True
        Dim filename As String
        Dim Q_Name(24) As String
        Dim Q_EF(24), Q_EC(24), Di_EF(24), Di_EC(24), Y_App(24) As Double
        Try

            filename = Directory.GetCurrentDirectory.ToString() & "\cfg_EF_ECS.ini"
            'Affichage des valeurs en cours
            Call Lecture_fichier_Ini(filename, Verif) 'Q_Name, Q_EF, Q_EC, Di_EF, Di_EC, Y_App, 
            If Verif = False Then Exit Sub
            If Aff.i_data = 1 Then Aff.msgData = Directory.GetCurrentDirectory.ToString() & "\data" 'provisoire :
            If Aff.i_result = 1 Then Aff.msgResult = Directory.GetCurrentDirectory.ToString() & "\Note_de_calcul"
            Call Affichage() 'Q_Name, Q_EF, Q_EC, Di_EF, Di_EC, Y_App)
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du fichier de configuration: " + Environment.NewLine + ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub BtnQuit_Click(sender As Object, e As EventArgs) Handles BtnQuit.Click
        Me.Dispose()
        Me.Close() 'quitte le formulaire
    End Sub
    Private Sub BtnOK_Click(sender As Object, e As EventArgs) Handles BtnOK.Click
        Dim Verif As Boolean = True
        Try
            Call Lecture(Verif)
            If Verif = False Then Exit Sub
            Me.Dispose()
            Me.Close() 'quitte le formulaire
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du formulaire:  " + Environment.NewLine + ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub BtnSauvegarde_Click(sender As System.Object, e As System.EventArgs) Handles BtnSauvegarde.Click
        Dim Verif As Boolean = True
        Dim filename As String
        Dim Q_Name(24) As String
        Dim Q_EF(24), Q_EC(24), Di_EF(24), Di_EC(24), Y_App(24) As Double
        Try
            ' filename = Directory.GetCurrentDirectory.ToString() & "\bin\cfg_EF_ECS.ini"
            filename = Directory.GetCurrentDirectory.ToString() & "\cfg_EF_ECS.ini"
            Call Lecture(Verif)
            If Verif = False Then Exit Sub
            Call Ecriture_fichier_Cfg_Ini(filename) ', Q_Name, Q_EF, Q_EC, Di_EF, Di_EC, Y_App)
            MessageBox.Show("Fichier de configuration modifié avec succés.", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Information)
        Catch ex As Exception
            MessageBox.Show("Erreur lors de l'écriture du fichier: " + Environment.NewLine + ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub BtnReinit_Click(sender As System.Object, e As System.EventArgs) Handles BtnReinit.Click
        Dim reponse As Integer
        reponse = MsgBox("Attention, vous allez modifier vos préférences !!!!" & Environment.NewLine & "Voulez-vous continuer?", MsgBoxStyle.YesNo Or MsgBoxStyle.Exclamation Or MsgBoxStyle.DefaultButton1, "Calculette Métal")
        If reponse = 6 Then
            'Dim Q_Name(24) As String
            'Dim Q_EF(24), Q_EC(24), Di_EF(24), Di_EC(24), Y_App(24) As Double
            Call Variables_generales() 'Q_Name, Q_EF, Q_EC, Di_EF, Di_EC, Y_App) 'appel au modules contenant les variables par defaut, écrites en dur dans le logiciel, se trouve dans le module General.vb
            Call Affichage() 'Q_Name, Q_EF, Q_EC, Di_EF, Di_EC, Y_App)
        End If

    End Sub
    Private Sub Lecture(ByRef Verif As Boolean)
        'Onglet General
        If RbtnDatadefaut.Checked = True Then
            Aff.msgData = Directory.GetCurrentDirectory.ToString() & "\data" ' Directory.GetParent(Directory.GetCurrentDirectory).ToString() : Aff.i_data = 1
        Else
            Aff.msgData = LblData.Text : Aff.i_data = 2
        End If
        If RbtnResultDefaut.Checked = True Then
            Aff.msgResult = Directory.GetCurrentDirectory.ToString() & "\Note_de_calcul" 'Directory.GetParent(Directory.GetCurrentDirectory).ToString() : Aff.i_result = 1
        Else
            Aff.msgResult = LblResult.Text : Aff.i_result = 2
        End If
        Aff.Chantier = TxtChantier.Text
        Aff.Redacteur = TxtRedacteur.Text
        'Onglet Débits-Pression
        With Reseau
            If RbtnEFPr10.Checked = True Then
                .Pr_ES = 10 'en mCE
            ElseIf RbtnEFPr3.Checked = True Then
                .Pr_ES = 3 'en mCE
            Else
                RbtnEFPrAutre.Checked = True
                If gestionderreur(TxtPrEFS) = True Then
                    .Pr_ES = CDbl(TxtPrEFS.Text) : .Pr_ES = .Pr_ES * 10 'transformation bar en mCE
                Else
                    Verif = False
                End If
            End If
            If gestionderreur(TxtVlimIndiv) = True Then .VlimIndiv = CDbl(TxtVlimIndiv.Text) Else Verif = False
        End With


        'onglet Editeur
        If RbtnEditeurInterne.Checked = True Then Aff.Editeur = 1
        If RbtnWordPad.Checked = True Then Aff.Editeur = 2
        If RbtnWord.Checked = True Then Aff.Editeur = 3
    End Sub
    Private Sub Affichage() 'ByVal Q_Name() As String, ByVal Q_EF() As Double, ByVal Q_EC() As Double, ByVal Di_EF() As Double, ByVal Di_EC() As Double, ByVal Y_App() As Double)
        'Onglet général
        TxtChantier.Text = Aff.Chantier
        TxtRedacteur.Text = Aff.Redacteur
        If Aff.i_result = 1 Then RbtnResultDefaut.Checked = True Else RbtnResultPerso.Checked = True
        If Aff.i_data = 1 Then RbtnDatadefaut.Checked = True Else RbtndataPerso.Checked = True
        LblData.Text = Aff.msgData
        LblResult.Text = Aff.msgResult

        'Onglet Débits-Pression
        With Reseau
            If .Pr_ES = 10 Then
                RbtnEFPr10.Checked = True
            ElseIf .Pr_ES = 3 Then
                RbtnEFPr3.Checked = True
            Else
                RbtnEFPrAutre.Checked = True
                TxtPrEFS.Text = (.Pr_ES / 10).ToString("#0.00")
            End If

            TxtVlimIndiv.Text = Reseau.VlimIndiv.ToString("#0.00")
        End With


        With Dgv1
            .RowHeadersVisible = False
            .RowCount = 6 '26 lignes
            .ColumnCount = 5
            .Columns(0).Width = 200 : .Columns(1).Width = 50 : .Columns(2).Width = 50 : .Columns(3).Width = 100 : .Columns(4).Width = 100
            .Columns(0).Name = "Appareils" : .Columns(1).Name = "Débits EF (L/s)" : .Columns(2).Name = "Débits ECS (L/s)"
            .Columns(3).Name = "Diamètre mini interne alimentation (mm)" : .Columns(4).Name = "Coefficient simultanéité individuel"
            Dim b As New Baignoire
            .Item(0, 0).Value = "Baignoire" : .Item(1, 0).Value = b.Q_EF.ToString : .Item(2, 0).Value = b.Q_EC.ToString : .Item(3, 0).Value = (b.Ø_int).ToString("#0.0") : .Item(4, 0).Value = b.Y_app.ToString
            Dim b1 As New Evier
            .Item(0, 1).Value = "Evier - Timbre d'office - Kitchenette" : .Item(1, 1).Value = b1.Q_EF.ToString : .Item(2, 1).Value = b1.Q_EC.ToString : .Item(3, 1).Value = (b1.Ø_int).ToString("#0.0") : .Item(4, 1).Value = b1.Y_app.ToString
            Dim b2 As New Lavabo
            .Item(0, 2).Value = "Lavabo ou vasque" : .Item(1, 2).Value = b2.Q_EF.ToString : .Item(2, 2).Value = b2.Q_EC.ToString : .Item(3, 2).Value = (b2.Ø_int).ToString("#0.0") : .Item(4, 2).Value = b2.Y_app.ToString
            Dim b3 As New Douche
            .Item(0, 3).Value = "Douche" : .Item(1, 3).Value = b3.Q_EF.ToString : .Item(2, 3).Value = b3.Q_EC.ToString : .Item(3, 3).Value = (b3.Ø_int).ToString("#0.0") : .Item(4, 3).Value = b3.Y_app.ToString
            Dim b4 As New WC_Reservoir
            .Item(0, 4).Value = "WC individuel avec réservoir de chasse" : .Item(1, 4).Value = b4.Q_EF.ToString : .Item(2, 4).Value = " - " : .Item(3, 4).Value = (b4.Ø_int).ToString("#0.0") : .Item(4, 4).Value = b4.Y_app.ToString
            Dim b5 As New Lavabo_Collectif
            .Item(0, 5).Value = "Lavabo collectif" : .Item(1, 5).Value = b5.Q_EF.ToString : .Item(2, 5).Value = b5.Q_EC.ToString : .Item(3, 5).Value = (b5.Ø_int).ToString("#0.0") : .Item(4, 5).Value = b5.Y_app.ToString

            '.Item(0, 6).Value = "WC avec robinet de chasse" : .Item(1, 6).Value = "1.5" : .Item(2, 6).Value = "-" : .Item(3, 6).Value = "suivant diamètre robinet"
            '.Item(0, 7).Value = "Lave-main" : .Item(1, 7).Value = "0.10" : .Item(2, 7).Value = "0.10" : .Item(3, 7).Value = "10"
            '.Item(0, 8).Value = "Lave-bassin" : .Item(1, 8).Value = "0.33" : .Item(2, 8).Value = "0.33" : .Item(3, 8).Value = "13"
            '.Item(0, 9).Value = "Lavabo de soin ou auge" : .Item(1, 9).Value = "0.20" : .Item(2, 9).Value = "0.20" : .Item(3, 9).Value = "10"
            '.Item(0, 10).Value = "Vidoir hôpital" : .Item(1, 10).Value = "0.12" : .Item(2, 10).Value = "0.12" : .Item(3, 10).Value = "10"
            '.Item(0, 11).Value = "Vidoir mural" : .Item(1, 11).Value = "0.20" : .Item(2, 11).Value = "0.20" : .Item(3, 11).Value = "10"
            '.Item(0, 12).Value = "Poste dialyse" : .Item(1, 12).Value = "0.20" : .Item(2, 12).Value = "0.20" : .Item(3, 12).Value = "10"
            '.Item(0, 13).Value = "Fontaine réfrigérée" : .Item(1, 13).Value = "0.10" : .Item(2, 13).Value = "-" : .Item(3, 13).Value = "10"
            '.Item(0, 14).Value = "Distributeur de boisson" : .Item(1, 14).Value = "0.10" : .Item(2, 14).Value = "-" : .Item(3, 14).Value = "10"
            '.Item(0, 15).Value = "Lavabo collectif (par jet)" : .Item(1, 15).Value = "0.05" : .Item(2, 15).Value = "0.05" : .Item(3, 15).Value = "suivant nombre de jets"
            '.Item(0, 16).Value = "Bidet" : .Item(1, 16).Value = "0.20" : .Item(2, 16).Value = "0.20" : .Item(3, 16).Value = "10"
            '.Item(0, 17).Value = "Poste d'eau robinet 1/2" : .Item(1, 17).Value = "0.33" : .Item(2, 17).Value = "-" : .Item(3, 17).Value = "12"
            '.Item(0, 18).Value = "Poste d'eau robinet 3/4" : .Item(1, 18).Value = "0.42" : .Item(2, 18).Value = "-" : .Item(3, 18).Value = "13"
            '.Item(0, 19).Value = "Distributeur de boisson" : .Item(1, 19).Value = "0.10" : .Item(2, 19).Value = "-" : .Item(3, 19).Value = "10"
            '.Item(0, 20).Value = "Urinoir avec robinet individuel" : .Item(1, 20).Value = "0.15" : .Item(2, 20).Value = "-" : .Item(3, 20).Value = "10"
            '.Item(0, 21).Value = "Urinoir à action siphonique" : .Item(1, 21).Value = "0.50" : .Item(2, 21).Value = "-" : .Item(3, 21).Value = "suivant diamètre robinet"
            '.Item(0, 22).Value = "Bac à laver" : .Item(1, 22).Value = "0.33" : .Item(2, 22).Value = "-" : .Item(3, 22).Value = "10"
            '.Item(0, 23).Value = "Machine à laver le linge" : .Item(1, 23).Value = "0.20" : .Item(2, 23).Value = "0.20" : .Item(3, 23).Value = "10"
            '.Item(0, 24).Value = "Machine à laver la vaisselle" : .Item(1, 24).Value = "0.10" : .Item(2, 24).Value = "0.10" : .Item(3, 24).Value = "10"
            '.Rows.RemoveAt(7)
        End With

        'Onglet Editeur
        Select Case Aff.Editeur
            Case 1
                RbtnEditeurInterne.Checked = True
            Case 2
                RbtnWordPad.Checked = True
            Case 3
                RbtnWord.Checked = True
        End Select
    End Sub
    Private Function gestionderreur(ByVal e As System.Windows.Forms.TextBox) As Boolean
        If e.Text = "" Then
            EP1.SetError(e, "le champ n'a pas été renseigné!!")
            gestionderreur = False
        ElseIf Not IsNumeric(CDbl(e.Text)) Then
            EP1.SetError(e, "le champ n'est pas une valeur numérique !!")
            gestionderreur = False
        Else
            EP1.SetError(e, "") ' Clear the error.
            gestionderreur = True
        End If
    End Function



    Public Sub Ecriture_fichier_Cfg_Ini(ByVal filename As String) ', ByVal Q_Name() As String, ByVal Q_EF() As Double, ByVal Q_EC() As Double, ByVal Di_EF() As Double, ByVal Di_EC() As Double, ByVal Y_App() As Double)
        Dim myStreamWriter As StreamWriter
        Try
            ' Create a StreamWriter using a Shared (static) File class.
            myStreamWriter = File.CreateText(filename)
            myStreamWriter.WriteLine("Fichier des valeurs par défauts EF_ECS")
            myStreamWriter.WriteLine("formulaire configuration Onglet Général")
            myStreamWriter.WriteLine(Aff.Redacteur)
            myStreamWriter.WriteLine(Aff.Chantier)
            'répertoire
            myStreamWriter.WriteLine(Aff.msgResult)
            myStreamWriter.WriteLine(Aff.msgData)
            myStreamWriter.WriteLine(Aff.i_result & " " & Aff.i_data)
            'Editeur
            myStreamWriter.WriteLine(Aff.Editeur)
            myStreamWriter.WriteLine("formulaire configuration Onglets débits-Pression et boucle ECS")
            myStreamWriter.WriteLine(Reseau.Pr_ES & " " & Reseau.Ycoef & " " & Reseau.ΔT_ECS & " " & Reseau.HMVC & " " & Reseau.HMVrd)
            'Dim Exut As New Baignoire
            'With Exut
            '    myStreamWriter.WriteLine("Baignoire " & .Q_EF & " " & .Q_EC & " " & .Ø_int & " " & .Y_app)
            'End With
            'Exut = Nothing
            'Dim Exut As New Baignoire

            'myStreamWriter.WriteLine(Q_Name(i) & " " & Q_EF(i) & " " & Q_EC(i) & " " & Di_EF(i)) ' & " " & Di_EC(i) = CDbl(titi(3))

            myStreamWriter.Flush() ' Obligatoire - Vide le tampon pour être sûr que tout soit écrit dans le fichier

        Catch exc As Exception
            MsgBox("Le fichier n'a pas pu être ouvert ou écrit" + Environment.NewLine + "Vérifiez que le nom du fichier et son chemin d'accès soient exact" +
                 Environment.NewLine + Environment.NewLine + "Exception: " + exc.Message, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly,
                "Module écriture fichier génération poteau")
        Finally
            ' Close the object if it has been created.
            If Not myStreamWriter Is Nothing Then myStreamWriter.Close()
        End Try
    End Sub

    Private Sub BtnResultModif_Click(sender As System.Object, e As System.EventArgs) Handles BtnResultModif.Click
        Try
            With FolderBrowserDialog1
                'En principe, après avoir créé un FolderBrowserDialog, vous définissez RootFolder à l'emplacement à partir duquel commencer la navigation. 
                'Vous pouvez choisir un emplacement dans la liste des dossiers système spéciaux, notamment Program Files, Programmes, System ou Démarrage, qui contiennent des informations communes.  
                .RootFolder = Environment.SpecialFolder.Personal
                ' Si vous le voulez, vous pouvez aussi définir la propriété Description afin de fournir des instructions supplémentaires à l'utilisateur.
                .Description = "Selectionnez le répertoire ..."
                ' Vous pouvez utiliser la propriété ShowNewFolderButton pour déterminer si l'utilisateur est en mesure de créer des dossiers à l'aide du bouton Nouveau dossier.
                .ShowNewFolderButton = True
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    LblResult.Text = .SelectedPath
                End If

            End With
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation, Me.Text)
        End Try
    End Sub

    Private Sub RbtnResultDefaut_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnResultDefaut.CheckedChanged
        If RbtnResultDefaut.Checked = True Then BtnResultModif.Enabled = False : LblResult.Text = Directory.GetCurrentDirectory.ToString()
    End Sub

    Private Sub RbtnResultPerso_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnResultPerso.CheckedChanged
        If RbtnResultPerso.Checked = True Then BtnResultModif.Enabled = True : BtnResultModif.Focus()
    End Sub

    Private Sub RbtnDatadefaut_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnDatadefaut.CheckedChanged
        If RbtnDatadefaut.Checked = True Then BtnDataModif.Enabled = False : LblData.Text = Directory.GetCurrentDirectory.ToString()
    End Sub

    Private Sub RbtndataPerso_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtndataPerso.CheckedChanged
        If RbtndataPerso.Checked = True Then BtnDataModif.Enabled = True : BtnDataModif.Focus()
    End Sub

    Private Sub BtnDataModif_Click(sender As System.Object, e As System.EventArgs) Handles BtnDataModif.Click
        Try
            With FolderBrowserDialog1
                .RootFolder = Environment.SpecialFolder.Personal
                .Description = "Selectionnez le répertoire ..."
                .ShowNewFolderButton = True
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    LblData.Text = .SelectedPath
                End If

            End With
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation, Me.Text)
        End Try
    End Sub

    Private Sub RbtnCuivre_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnCuivre.CheckedChanged
        Dim i As Integer
        If RbtnCuivre.Checked = True Then
            With Dgv2
                .RowHeadersVisible = False
                .RowCount = Nom_Cu.Length  '26 lignes
                .ColumnCount = 2
                .AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells
                .Columns(0).Name = "Dénomination" : .Columns(1).Name = "Diamètre intérieur (mm)" ': .Columns(2).Name = "Débits ECS (L/s)" : .Columns(3).Name = "Diamètre mini int. alimentation (mm)"
                For i = 0 To Nom_Cu.Length - 1
                    .Item(0, i).Value = Nom_Cu(i) : .Item(1, i).Value = (Di_Cu(i) * 1000).ToString ': .Item(2, 0).Value = "-" : .Item(3, 0).Value = "-"
                Next
            End With
        End If

    End Sub

    Private Sub RbtnAcierGalva_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnAcierGalva.CheckedChanged
        Dim i As Integer
        If RbtnAcierGalva.Checked = True Then
            With Dgv2
                .RowHeadersVisible = False
                .RowCount = Nom_Ag.Length '26 lignes
                .ColumnCount = 2
                .AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells
                .Columns(0).Name = "Dénomination" : .Columns(1).Name = "Diamètre intérieur (mm)" ': .Columns(2).Name = "Débits ECS (L/s)" : .Columns(3).Name = "Diamètre mini int. alimentation (mm)"
                For i = 0 To Nom_Ag.Length - 1
                    .Item(0, i).Value = Nom_Ag(i) : .Item(1, i).Value = (Di_Ag(i) * 1000).ToString ': .Item(2, 0).Value = "-" : .Item(3, 0).Value = "-"
                Next
            End With
        End If
    End Sub

    Private Sub RbtnPER_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnPER.CheckedChanged
        Dim i As Integer
        If RbtnPER.Checked = True Then
            With Dgv2
                .RowHeadersVisible = False
                .RowCount = Nom_PER.Length '26 lignes
                .ColumnCount = 2
                .AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells
                .Columns(0).Name = "Dénomination" : .Columns(1).Name = "Diamètre intérieur (mm)" ': .Columns(2).Name = "Débits ECS (L/s)" : .Columns(3).Name = "Diamètre mini int. alimentation (mm)"
                For i = 0 To Nom_PER.Length - 1
                    .Item(0, i).Value = Nom_PER(i) : .Item(1, i).Value = (Di_PER(i) * 1000).ToString ': .Item(2, 0).Value = "-" : .Item(3, 0).Value = "-"
                Next
            End With
        End If
    End Sub

    Private Sub RbtnMulticouche_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnMulticouche.CheckedChanged
        Dim i As Integer
        If RbtnMulticouche.Checked = True Then
            With Dgv2
                .RowHeadersVisible = False
                .RowCount = Nom_MultiC.Length '26 lignes
                .ColumnCount = 2
                .AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells
                .Columns(0).Name = "Dénomination" : .Columns(1).Name = "Diamètre intérieur (mm)" ': .Columns(2).Name = "Débits ECS (L/s)" : .Columns(3).Name = "Diamètre mini int. alimentation (mm)"
                For i = 0 To Nom_MultiC.Length - 1
                    .Item(0, i).Value = Nom_MultiC(i) : .Item(1, i).Value = (Di_MultiC(i) * 1000).ToString
                Next
            End With
        End If
    End Sub
    Private Sub RbtnPVC_C_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnPVC_C.CheckedChanged
        Dim i As Integer
        If RbtnPVC_C.Checked = True Then
            With Dgv2
                .RowHeadersVisible = False
                .RowCount = Nom_PVC_C.Length '26 lignes
                .ColumnCount = 2
                .AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells
                .Columns(0).Name = "Dénomination" : .Columns(1).Name = "Diamètre intérieur (mm)" ': .Columns(2).Name = "Débits ECS (L/s)" : .Columns(3).Name = "Diamètre mini int. alimentation (mm)"
                For i = 0 To Nom_PVC_C.Length - 1
                    .Item(0, i).Value = Nom_PVC_C(i) : .Item(1, i).Value = (Di_PVC_C(i) * 1000).ToString ': .Item(2, 0).Value = "-" : .Item(3, 0).Value = "-"
                Next
            End With
        End If
    End Sub
    Private Sub RbtnPVC_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnPVC.CheckedChanged
        Dim i As Integer
        If RbtnPVC.Checked = True Then
            Dim PVCi As New PVC
            With Dgv2
                .RowHeadersVisible = False
                .RowCount = PVCi.Nom.Count
                .ColumnCount = 2
                .AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCells
                .Columns(0).Name = "Dénomination" : .Columns(1).Name = "Diamètre intérieur (mm)"
                For i = 0 To PVCi.Nom.Count - 1
                    .Item(0, i).Value = PVCi.Nom(i) : .Item(1, i).Value = (PVCi.Øint(i) * 1000).ToString
                Next
            End With
        End If
    End Sub

#Region "Fichiers d'aide"
    Private Sub BtnHlpVlimTronçonInviduel_Click(sender As System.Object, e As System.EventArgs) Handles BtnHlpVlimTronçonInviduel.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 11
        frm1.Show()
    End Sub




#End Region



End Class