﻿Imports System.Math
Public Class frmDebitVitesse
    Private Function gestionderreur(ByVal e As System.Windows.Forms.TextBox) As Boolean
        If e.Text = "" Then
            EP1.SetError(e, "le champ n'a pas été renseigné!!")
            gestionderreur = False
        ElseIf Not IsNumeric(CDbl(e.Text)) Then
            EP1.SetError(e, "le champ n'est pas une valeur numérique !!")
            gestionderreur = False
        Else
            EP1.SetError(e, "") ' Clear the error.
            gestionderreur = True
        End If
    End Function
    Private Sub TxtVitesse_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtVitesse.KeyPress
        Call Gestion_Keypress(e, TxtVitesse, True, False)
    End Sub

    Private Sub TxtDebit_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtDebit.KeyPress
        Call Gestion_Keypress(e, TxtDebit, True, False)
    End Sub
    Private Sub BtnCalcul_Click(sender As System.Object, e As System.EventArgs) Handles BtnCalcul.Click
        Dim Debit, Vitesse As Double
        If RbtnDebit.Checked = True Then
            If gestionderreur(TxtVitesse) = True Then Vitesse = CDbl(TxtVitesse.Text) 'Else Verif = False
        End If
        If RbtnVitesse.Checked = True Then
            If gestionderreur(TxtDebit) = True Then Debit = CDbl(TxtDebit.Text)
        End If
        Dgv1.Rows.Clear() 'efface toutes les lignes sauf l'entète
        Dgv1.Columns.Clear()
        With Dgv1
            .RowHeadersVisible = False
            .ColumnCount = 2
            .ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
            .Columns(0).Name = "Dénomination"
            .Columns(0).Width = 100
            .Columns(1).Width = 100
            .RowCount = Nom_Cu.Length '26 lignes
            If RbtnDebit.Checked = True Then
                .Columns(1).Name = "Débit" & ControlChars.CrLf & "(L/s)"
                For i = 0 To Nom_Cu.Length - 1
                    .Item(0, i).Value = Nom_Cu(i)
                    Debit = (PI * Di_Cu(i) ^ 2 / 4) * Vitesse * 1000
                    .Item(1, i).Value = Debit.ToString("#,##0.00") '
                Next
            Else
                .Columns(1).Name = "Vitesse d'écoulement" & ControlChars.CrLf & "(m/s)"
                For i = 0 To Nom_Cu.Length - 1
                    .Item(0, i).Value = Nom_Cu(i)
                    Vitesse = Debit / 1000 / (PI * Di_Cu(i) ^ 2 / 4)
                    .Item(1, i).Value = Vitesse.ToString("#0.00") '
                Next
            End If
        End With
        With Dgv2
            .RowHeadersVisible = False
            .ColumnCount = 2
            .ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
            .Columns(0).Name = "Dénomination"
            .Columns(0).Width = 100
            .Columns(1).Width = 100
            .RowCount = Nom_Ag.Length ' 6 lignes
            If RbtnDebit.Checked = True Then
                .Columns(1).Name = "Débit" & ControlChars.CrLf & "(L/s)"
                For i = 0 To Nom_Ag.Length - 1
                    .Item(0, i).Value = Nom_Ag(i)
                    Debit = (PI * Di_Ag(i) ^ 2 / 4) * Vitesse * 1000
                    .Item(1, i).Value = Debit.ToString("#,##0.00") '
                Next
            Else
                .Columns(1).Name = "Vitesse d'écoulement" & ControlChars.CrLf & "(m/s)"
                For i = 0 To Nom_Ag.Length - 1
                    .Item(0, i).Value = Nom_Ag(i)
                    Vitesse = Debit / 1000 / (PI * Di_Ag(i) ^ 2 / 4)
                    .Item(1, i).Value = Vitesse.ToString("#0.00") '
                Next
            End If
        End With
        With Dgv3
            .RowHeadersVisible = False
            .ColumnCount = 2
            .ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
            .Columns(0).Name = "Dénomination"
            .Columns(0).Width = 100
            .Columns(1).Width = 100
            .RowCount = Nom_PER.Length ' 6 lignes
            If RbtnDebit.Checked = True Then
                .Columns(1).Name = "Débit" & ControlChars.CrLf & "(L/s)"
                For i = 0 To Nom_PER.Length - 1
                    .Item(0, i).Value = Nom_PER(i)
                    Debit = (PI * Di_PER(i) ^ 2 / 4) * Vitesse * 1000
                    .Item(1, i).Value = Debit.ToString("#,##0.00") '
                Next
            Else
                .Columns(1).Name = "Vitesse d'écoulement" & ControlChars.CrLf & "(m/s)"
                For i = 0 To Nom_PER.Length - 1
                    .Item(0, i).Value = Nom_PER(i)
                    Vitesse = Debit / 1000 / (PI * Di_PER(i) ^ 2 / 4)
                    .Item(1, i).Value = Vitesse.ToString("#0.00") '
                Next
            End If
        End With
        With Dgv4
            .RowHeadersVisible = False
            .ColumnCount = 2
            .ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
            .Columns(0).Name = "Dénomination"
            .Columns(0).Width = 100
            .Columns(1).Width = 100
            .RowCount = Nom_MultiC.Length ' 6 lignes
            If RbtnDebit.Checked = True Then
                .Columns(1).Name = "Débit" & ControlChars.CrLf & "(L/s)"
                For i = 0 To Nom_MultiC.Length - 1
                    .Item(0, i).Value = Nom_MultiC(i)
                    Debit = (PI * Di_MultiC(i) ^ 2 / 4) * Vitesse * 1000
                    .Item(1, i).Value = Debit.ToString("#,##0.00") '
                Next
            Else
                .Columns(1).Name = "Vitesse d'écoulement" & ControlChars.CrLf & "(m/s)"
                For i = 0 To Nom_MultiC.Length - 1
                    .Item(0, i).Value = Nom_MultiC(i)
                    Vitesse = Debit / 1000 / (PI * Di_MultiC(i) ^ 2 / 4)
                    .Item(1, i).Value = Vitesse.ToString("#0.00") '
                Next
            End If
        End With
        With Dgv5
            .RowHeadersVisible = False
            .ColumnCount = 2
            .ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
            .Columns(0).Name = "Dénomination"
            .Columns(0).Width = 100
            .Columns(1).Width = 100
            .RowCount = Nom_PVC_C.Length ' 7 lignes
            If RbtnDebit.Checked = True Then
                .Columns(1).Name = "Débit" & ControlChars.CrLf & "(L/s)"
                For i = 0 To Nom_PVC_C.Length - 1
                    .Item(0, i).Value = Nom_PVC_C(i)
                    Debit = (PI * Di_PVC_C(i) ^ 2 / 4) * Vitesse * 1000
                    .Item(1, i).Value = Debit.ToString("#,##0.00") '
                Next
            Else
                .Columns(1).Name = "Vitesse d'écoulement" & ControlChars.CrLf & "(m/s)"
                For i = 0 To Nom_PVC_C.Length - 1
                    .Item(0, i).Value = Nom_PVC_C(i)
                    Vitesse = Debit / 1000 / (PI * Di_PVC_C(i) ^ 2 / 4)
                    .Item(1, i).Value = Vitesse.ToString("#0.00") '
                Next
            End If
        End With
    End Sub

    Private Sub RbtnDebit_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnDebit.CheckedChanged
        If RbtnDebit.Checked = True Then
            TxtVitesse.Enabled = True : TxtVitesse.Focus()
        Else
            TxtVitesse.Text = "" : TxtVitesse.Enabled = False

        End If
    End Sub

    Private Sub RbtnVitesse_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnVitesse.CheckedChanged
        If RbtnVitesse.Checked = True Then
            TxtDebit.Enabled = True : TxtDebit.Focus()
        Else
            TxtDebit.Text = "" : TxtDebit.Enabled = False

        End If
    End Sub

End Class