﻿Public Class frmProdECS
    Private Sub BtnCalcul_Click(sender As Object, e As EventArgs) Handles BtnCalcul.Click
        Dim Tef, Tprod, Q, Sup, P As Double
        Dim Verif As Boolean = True
        Call Lecture_données(Verif, Tef, Tprod, Q, Sup)
        If Verif = False Then Exit Sub
        P = Sup * 1.163 * Q * (Tprod - Tef) / 1000 'pour unité en kW
        LblResult.Text = "L'échangeur à plaque devra avoir une puissance de " & P.ToString("#,##0.0") & " kW pour un débit de " & Q.ToString("#,##0.0") & " L/h."
    End Sub
    Private Sub Lecture_données(ByRef Verif As Boolean, ByRef Tef As Double, ByRef Tprod As Double, ByRef Q As Double, ByRef Sup As Double)
        If gestionderreur(TxtEF) = True Then Tef = CDbl(TxtEF.Text) Else Verif = False
        If gestionderreur(txtTprod) = True Then Tprod = CDbl(txtTprod.Text) Else Verif = False
        If gestionderreur(txtQ) = True Then Q = CDbl(txtQ.Text) Else Verif = False
        If gestionderreur(TxtSurprod) = True Then Sup = CDbl(TxtSurprod.Text) Else Verif = False
    End Sub
    Private Function gestionderreur(ByVal e As System.Windows.Forms.TextBox) As Boolean
        If e.Text = "" Then
            EP1.SetError(e, "le champ n'a pas été renseigné!!")
            gestionderreur = False
        ElseIf Not IsNumeric(CDbl(e.Text)) Then
            EP1.SetError(e, "le champ n'est pas une valeur numérique !!")
            gestionderreur = False
        ElseIf CDbl(e.Text) <= 0 Then
            EP1.SetError(e, "la valeur ne peut pas nulle ou négative!")
            gestionderreur = False
        Else
            EP1.SetError(e, "") ' Clear the error.
            gestionderreur = True
        End If
    End Function

    Private Sub frmProdECS_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        LblResult.Text = ""
        txtTprod.Focus()
    End Sub
End Class