﻿Imports System.IO
Public Class frmReseau_EF_ECS
    Private Fichier_NotedeCalcul As String = String.Empty

#Region "Onglet Exutoire"
    Private Sub BtnExutMoins_Click(sender As Object, e As EventArgs) Handles BtnExutMoins.Click
        Dim ntype As Integer
        Dim Exut As New Exutoire
        Dim Verif As Boolean = True
        Call Lecture_Exutoire(Exut, Verif)
        If Verif = False Then Exit Sub
        ntype = CInt(LblExut.Text)
        If Exutoires.Count < ntype Then
            Exutoires.Add(Exut) 'cet exutoire n'a pas encore été renseigné
        Else
            'remplacement de l'exutoire existant
            Exutoires.Item(ntype - 1)._Baignoire_Nb = Exut._Baignoire_Nb
            Exutoires.Item(ntype - 1)._Bidet_nb = Exut._Bidet_nb
            Exutoires.Item(ntype - 1)._douche_nb = Exut._douche_nb
            Exutoires.Item(ntype - 1)._Evier_nb = Exut._Evier_nb
            Exutoires.Item(ntype - 1)._lavabo_nb = Exut._lavabo_nb
            Exutoires.Item(ntype - 1)._Lave_Linge_nb = Exut._Lave_Linge_nb
            Exutoires.Item(ntype - 1)._lavemain_nb = Exut._lavemain_nb
            Exutoires.Item(ntype - 1)._Lave_vaisselle_nb = Exut._Lave_vaisselle_nb
            Exutoires.Item(ntype - 1)._WC_Reservoir_nb = Exut._WC_Reservoir_nb
            Exutoires.Item(ntype - 1)._WC_Reservoir_coll_nb = Exut._WC_Reservoir_coll_nb
            Exutoires.Item(ntype - 1)._Timbre_Office_nb = Exut._Timbre_Office_nb
            Exutoires.Item(ntype - 1)._Bac_a_Laver_nb = Exut._Bac_a_Laver_nb
            Exutoires.Item(ntype - 1)._Urinoir_nb = Exut._Urinoir_nb
            Exutoires.Item(ntype - 1)._Poste_eau_nb = Exut._Poste_eau_nb
            Exutoires.Item(ntype - 1)._lavabo_Coll_nb = Exut._lavabo_Coll_nb
        End If
        ntype -= 1
        If ntype = 1 Then BtnExutMoins.Hide()
        LblExut.Text = ntype.ToString
        Call Affichage_Exutoire_NON_vierge(ntype)
        Exut = Nothing
        lblNbExut.Text = "Nombre total d'exutoire(s) renseigné(s): " & Exutoires.Count
    End Sub
    Private Sub BtnExutPlus_Click(sender As Object, e As EventArgs) Handles BtnExutPlus.Click
        Dim ntype As Integer
        Dim Exut As New Exutoire
        Dim Verif As Boolean = True
        Call Lecture_Exutoire(Exut, Verif)
        If Verif = False Then Exit Sub
        ntype = CInt(LblExut.Text)
        If Exutoires.Count < ntype Then
            Exutoires.Add(Exut) 'cet exutoire n'a pas encore été renseigné
            ntype += 1
            LblExut.Text = ntype.ToString
            Call Affichage_Exutoire_vierge()

        Else
            'remplacement de l'exutoire existant
            Exutoires.Item(ntype - 1)._Baignoire_Nb = Exut._Baignoire_Nb
            Exutoires.Item(ntype - 1)._Bidet_nb = Exut._Bidet_nb
            Exutoires.Item(ntype - 1)._douche_nb = Exut._douche_nb
            Exutoires.Item(ntype - 1)._Evier_nb = Exut._Evier_nb
            Exutoires.Item(ntype - 1)._lavabo_nb = Exut._lavabo_nb
            Exutoires.Item(ntype - 1)._Lave_Linge_nb = Exut._Lave_Linge_nb
            Exutoires.Item(ntype - 1)._lavemain_nb = Exut._lavemain_nb
            Exutoires.Item(ntype - 1)._Lave_vaisselle_nb = Exut._Lave_vaisselle_nb
            Exutoires.Item(ntype - 1)._WC_Reservoir_nb = Exut._WC_Reservoir_nb
            Exutoires.Item(ntype - 1)._WC_Reservoir_coll_nb = Exut._WC_Reservoir_coll_nb
            Exutoires.Item(ntype - 1)._Timbre_Office_nb = Exut._Timbre_Office_nb
            Exutoires.Item(ntype - 1)._Bac_a_Laver_nb = Exut._Bac_a_Laver_nb
            Exutoires.Item(ntype - 1)._Urinoir_nb = Exut._Urinoir_nb
            Exutoires.Item(ntype - 1)._Poste_eau_nb = Exut._Poste_eau_nb
            Exutoires.Item(ntype - 1)._lavabo_Coll_nb = Exut._lavabo_Coll_nb
            ntype += 1
            LblExut.Text = ntype.ToString
            If ntype <= Exutoires.Count Then Call Affichage_Exutoire_NON_vierge(ntype) Else Call Affichage_Exutoire_vierge()

        End If
        BtnExutMoins.Visible = True
        Exut = Nothing
        lblNbExut.Text = "Nombre total d'exutoire(s) renseigné(s): " & Exutoires.Count
    End Sub
    Private Sub Lecture_Exutoire(ByRef exut As Exutoire, ByRef Verif As Boolean)
        Verif = True
        If Cb1App.SelectedIndex > -1 Then
            Select Case Cb1App.SelectedIndex
                Case 0  'Baignoire
                    exut._Baignoire_Nb = CInt(Nud1.Value)
                Case 1  ' Bidet
                    exut._Bidet_nb = CInt(Nud1.Value)
                Case 2 '        Douche
                    exut._douche_nb = CInt(Nud1.Value)
                Case 3 '        Evier
                    exut._Evier_nb = CInt(Nud1.Value)
                Case 4 'lavabo
                    exut._lavabo_nb = CInt(Nud1.Value)
                Case 5 '        Lave-Linge
                    exut._Lave_Linge_nb = CInt(Nud1.Value)
                Case 6 'Lave-main
                    exut._lavemain_nb = CInt(Nud1.Value)
                Case 7 'Lave-vaisselle
                    exut._Lave_vaisselle_nb = CInt(Nud1.Value)
                Case 8 'WC avec réservoir de chasse
                    exut._WC_Reservoir_nb = CInt(Nud1.Value)
                Case 9 'WC avec réservoir de chasse collectif
                    exut._WC_Reservoir_coll_nb = CInt(Nud1.Value)
                Case 10 'Timbre d'office
                    exut._Timbre_Office_nb = CInt(Nud1.Value)
                Case 11 'Bac à laver
                    exut._Bac_a_Laver_nb = CInt(Nud1.Value)
                Case 12 'urinoirs avec robinet individuel
                    exut._Urinoir_nb = CInt(Nud1.Value)
                Case 13 'poste d'eau 1/2
                    exut._Poste_eau_nb = CInt(Nud1.Value)
                Case 14 ' lavabo collectif
                    exut._lavabo_Coll_nb = CInt(Nud1.Value)
            End Select
            EP1.SetError(Cb1App, "") ' Clear the error.
        Else  'visible mais rien n'a été sélectionné
            Verif = False
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des appareils pour la dernière ligne.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            EP1.SetError(Cb1App, "le champ n'a pas été sélectionné!!")
            Exit Sub
        End If
        If Cb2App.SelectedIndex > -1 Then
            Select Case Cb2App.SelectedIndex
                Case 0  'Baignoire
                    exut._Baignoire_Nb += CInt(Nud2.Value)
                Case 1  ' Bidet
                    exut._Bidet_nb += CInt(Nud2.Value)
                Case 2 '        Douche
                    exut._douche_nb += CInt(Nud2.Value)
                Case 3 '        Evier
                    exut._Evier_nb += CInt(Nud2.Value)
                Case 4 'lavabo
                    exut._lavabo_nb += CInt(Nud2.Value)
                Case 5 '        Lave-Linge
                    exut._Lave_Linge_nb += CInt(Nud2.Value)
                Case 6 'Lave-main
                    exut._lavemain_nb += CInt(Nud2.Value)
                Case 7 'Lave-vaisselle
                    exut._Lave_vaisselle_nb += CInt(Nud2.Value)
                Case 8 'WC avec réservoir de chasse
                    exut._WC_Reservoir_nb += CInt(Nud2.Value)
                Case 9 'WC avec réservoir de chasse collectif
                    exut._WC_Reservoir_coll_nb = CInt(Nud2.Value)
                Case 10 'Timbre d'office
                    exut._Timbre_Office_nb = CInt(Nud2.Value)
                Case 11 'Bac à laver
                    exut._Bac_a_Laver_nb = CInt(Nud2.Value)
                Case 12 'urinoirs avec robinet individuel
                    exut._Urinoir_nb = CInt(Nud2.Value)
                Case 13 'poste d'eau 1/2
                    exut._Poste_eau_nb = CInt(Nud2.Value)
                Case 14 ' lavabo collectif
                    exut._lavabo_Coll_nb = CInt(Nud2.Value)
            End Select
            EP1.SetError(Cb2App, "") ' Clear the error.
        ElseIf Cb2App.Visible = True Then    'visible mais rien n'a été sélectionné
            Verif = False
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des appareils pour la dernière ligne.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            EP1.SetError(Cb2App, "le champ n'a pas été sélectionné!!")
            Exit Sub
        End If
        If Cb3App.SelectedIndex > -1 Then
            Select Case Cb3App.SelectedIndex
                Case 0  'Baignoire
                    exut._Baignoire_Nb += CInt(Nud3.Value)
                Case 1  ' Bidet
                    exut._Bidet_nb += CInt(Nud3.Value)
                Case 2 '        Douche
                    exut._douche_nb += CInt(Nud3.Value)
                Case 3 '        Evier
                    exut._Evier_nb += CInt(Nud3.Value)
                Case 4 'lavabo
                    exut._lavabo_nb += CInt(Nud3.Value)
                Case 5 '        Lave-Linge
                    exut._Lave_Linge_nb += CInt(Nud3.Value)
                Case 6 'Lave-main
                    exut._lavemain_nb += CInt(Nud3.Value)
                Case 7 'Lave-vaisselle
                    exut._Lave_vaisselle_nb += CInt(Nud3.Value)
                Case 8 'WC avec réservoir de chasse
                    exut._WC_Reservoir_nb += CInt(Nud3.Value)
                Case 9 'WC avec réservoir de chasse collectif
                    exut._WC_Reservoir_coll_nb = CInt(Nud3.Value)
                Case 10 'Timbre d'office
                    exut._Timbre_Office_nb = CInt(Nud3.Value)
                Case 11 'Bac à laver
                    exut._Bac_a_Laver_nb = CInt(Nud3.Value)
                Case 12 'urinoirs avec robinet individuel
                    exut._Urinoir_nb = CInt(Nud3.Value)
                Case 13 'poste d'eau 1/2
                    exut._Poste_eau_nb = CInt(Nud3.Value)
                Case 14 ' lavabo collectif
                    exut._lavabo_Coll_nb = CInt(Nud3.Value)
            End Select
            EP1.SetError(Cb3App, "") ' Clear the error.
        ElseIf Cb3App.Visible = True Then
            Verif = False
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des appareils pour la dernière ligne.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            EP1.SetError(Cb3App, "le champ n'a pas été sélectionné!!")
            Exit Sub
        End If
        If Cb4App.SelectedIndex > -1 Then
            Select Case Cb4App.SelectedIndex
                Case 0  'Baignoire
                    exut._Baignoire_Nb += CInt(Nud4.Value)
                Case 1  ' Bidet
                    exut._Bidet_nb += CInt(Nud4.Value)
                Case 2 '        Douche
                    exut._douche_nb += CInt(Nud4.Value)
                Case 3 '        Evier
                    exut._Evier_nb += CInt(Nud4.Value)
                Case 4 'lavabo
                    exut._lavabo_nb += CInt(Nud4.Value)
                Case 5 '        Lave-Linge
                    exut._Lave_Linge_nb += CInt(Nud4.Value)
                Case 6 'Lave-main
                    exut._lavemain_nb += CInt(Nud4.Value)
                Case 7 'Lave-vaisselle
                    exut._Lave_vaisselle_nb += CInt(Nud4.Value)
                Case 8 'WC avec réservoir de chasse
                    exut._WC_Reservoir_nb += CInt(Nud4.Value)
                Case 9 'WC avec réservoir de chasse collectif
                    exut._WC_Reservoir_coll_nb = CInt(Nud4.Value)
                Case 10 'Timbre d'office
                    exut._Timbre_Office_nb = CInt(Nud4.Value)
                Case 11 'Bac à laver
                    exut._Bac_a_Laver_nb = CInt(Nud4.Value)
                Case 12 'urinoirs avec robinet individuel
                    exut._Urinoir_nb = CInt(Nud4.Value)
                Case 13 'poste d'eau 1/2
                    exut._Poste_eau_nb = CInt(Nud4.Value)
                Case 14 ' lavabo collectif
                    exut._lavabo_Coll_nb = CInt(Nud4.Value)
            End Select
            EP1.SetError(Cb4App, "") ' Clear the error.
        ElseIf Cb4App.Visible = True Then
            Verif = False
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des appareils pour la dernière ligne.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            EP1.SetError(Cb4App, "le champ n'a pas été sélectionné!!")
            Exit Sub
        End If
        If Cb5App.SelectedIndex > -1 Then
            Select Case Cb5App.SelectedIndex
                Case 0  'Baignoire
                    exut._Baignoire_Nb += CInt(Nud5.Value)
                Case 1  ' Bidet
                    exut._Bidet_nb += CInt(Nud5.Value)
                Case 2 '        Douche
                    exut._douche_nb += CInt(Nud5.Value)
                Case 3 '        Evier
                    exut._Evier_nb += CInt(Nud5.Value)
                Case 4 'lavabo
                    exut._lavabo_nb += CInt(Nud5.Value)
                Case 5 '        Lave-Linge
                    exut._Lave_Linge_nb += CInt(Nud5.Value)
                Case 6 'Lave-main
                    exut._lavemain_nb += CInt(Nud5.Value)
                Case 7 'Lave-vaisselle
                    exut._Lave_vaisselle_nb += CInt(Nud5.Value)
                Case 8 'WC avec réservoir de chasse
                    exut._WC_Reservoir_nb += CInt(Nud5.Value)
                Case 9 'WC avec réservoir de chasse collectif
                    exut._WC_Reservoir_coll_nb = CInt(Nud5.Value)
                Case 10 'Timbre d'office
                    exut._Timbre_Office_nb = CInt(Nud5.Value)
                Case 11 'Bac à laver
                    exut._Bac_a_Laver_nb = CInt(Nud5.Value)
                Case 12 'urinoirs avec robinet individuel
                    exut._Urinoir_nb = CInt(Nud5.Value)
                Case 13 'poste d'eau 1/2
                    exut._Poste_eau_nb = CInt(Nud5.Value)
                Case 14 ' lavabo collectif
                    exut._lavabo_Coll_nb = CInt(Nud5.Value)
            End Select
            EP1.SetError(Cb5App, "") ' Clear the error.
        ElseIf Cb5App.Visible = True Then
            Verif = False
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des appareils pour la dernière ligne.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            EP1.SetError(Cb5App, "le champ n'a pas été sélectionné!!")
            Exit Sub
        End If
        If Cb6App.SelectedIndex > -1 Then
            Select Case Cb6App.SelectedIndex
                Case 0  'Baignoire
                    exut._Baignoire_Nb += CInt(Nud6.Value)
                Case 1  ' Bidet
                    exut._Bidet_nb += CInt(Nud6.Value)
                Case 2 '        Douche
                    exut._douche_nb += CInt(Nud6.Value)
                Case 3 '        Evier
                    exut._Evier_nb += CInt(Nud6.Value)
                Case 4 'lavabo
                    exut._lavabo_nb += CInt(Nud6.Value)
                Case 5 '        Lave-Linge
                    exut._Lave_Linge_nb += CInt(Nud6.Value)
                Case 6 'Lave-main
                    exut._lavemain_nb += CInt(Nud6.Value)
                Case 7 'Lave-vaisselle
                    exut._Lave_vaisselle_nb += CInt(Nud6.Value)
                Case 8 'WC avec réservoir de chasse
                    exut._WC_Reservoir_nb += CInt(Nud6.Value)
                Case 9 'WC avec réservoir de chasse collectif
                    exut._WC_Reservoir_coll_nb = CInt(Nud6.Value)
                Case 10 'Timbre d'office
                    exut._Timbre_Office_nb = CInt(Nud6.Value)
                Case 11 'Bac à laver
                    exut._Bac_a_Laver_nb = CInt(Nud6.Value)
                Case 12 'urinoirs avec robinet individuel
                    exut._Urinoir_nb = CInt(Nud6.Value)
                Case 13 'poste d'eau 1/2
                    exut._Poste_eau_nb = CInt(Nud6.Value)
                Case 14 ' lavabo collectif
                    exut._lavabo_Coll_nb = CInt(Nud6.Value)
            End Select
            EP1.SetError(Cb6App, "") ' Clear the error.
        ElseIf Cb6App.Visible = True Then
            Verif = False
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des appareils pour la dernière ligne.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            EP1.SetError(Cb6App, "le champ n'a pas été sélectionné!!")
            Exit Sub
        End If
        If Cb7App.SelectedIndex > -1 Then
            Select Case Cb7App.SelectedIndex
                Case 0  'Baignoire
                    exut._Baignoire_Nb += CInt(Nud7.Value)
                Case 1  ' Bidet
                    exut._Bidet_nb += CInt(Nud7.Value)
                Case 2 '        Douche
                    exut._douche_nb += CInt(Nud7.Value)
                Case 3 '        Evier
                    exut._Evier_nb += CInt(Nud7.Value)
                Case 4 'lavabo
                    exut._lavabo_nb += CInt(Nud7.Value)
                Case 5 '        Lave-Linge
                    exut._Lave_Linge_nb += CInt(Nud7.Value)
                Case 6 'Lave-main
                    exut._lavemain_nb += CInt(Nud7.Value)
                Case 7 'Lave-vaisselle
                    exut._Lave_vaisselle_nb += CInt(Nud7.Value)
                Case 8 'WC avec réservoir de chasse
                    exut._WC_Reservoir_nb += CInt(Nud7.Value)
                Case 9 'WC avec réservoir de chasse collectif
                    exut._WC_Reservoir_coll_nb = CInt(Nud7.Value)
                Case 10 'Timbre d'office
                    exut._Timbre_Office_nb = CInt(Nud7.Value)
                Case 11 'Bac à laver
                    exut._Bac_a_Laver_nb = CInt(Nud7.Value)
                Case 12 'urinoirs avec robinet individuel
                    exut._Urinoir_nb = CInt(Nud7.Value)
                Case 13 'poste d'eau 1/2
                    exut._Poste_eau_nb = CInt(Nud7.Value)
                Case 14 ' lavabo collectif
                    exut._lavabo_Coll_nb = CInt(Nud7.Value)
            End Select
            EP1.SetError(Cb7App, "") ' Clear the error.
        ElseIf Cb7App.Visible = True Then
            Verif = False
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des appareils pour la dernière ligne.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            EP1.SetError(Cb7App, "le champ n'a pas été sélectionné!!")
            Exit Sub
        End If
        If Cb8App.SelectedIndex > -1 Then
            Select Case Cb8App.SelectedIndex
                Case 0  'Baignoire
                    exut._Baignoire_Nb += CInt(Nud8.Value)
                Case 1  ' Bidet
                    exut._Bidet_nb += CInt(Nud8.Value)
                Case 2 '        Douche
                    exut._douche_nb += CInt(Nud8.Value)
                Case 3 '        Evier
                    exut._Evier_nb += CInt(Nud8.Value)
                Case 4 'lavabo
                    exut._lavabo_nb += CInt(Nud8.Value)
                Case 5 '        Lave-Linge
                    exut._Lave_Linge_nb += CInt(Nud8.Value)
                Case 6 'Lave-main
                    exut._lavemain_nb += CInt(Nud8.Value)
                Case 7 'Lave-vaisselle
                    exut._Lave_vaisselle_nb += CInt(Nud8.Value)
                Case 8 'WC avec réservoir de chasse
                    exut._WC_Reservoir_nb += CInt(Nud8.Value)
                Case 9 'WC avec réservoir de chasse collectif
                    exut._WC_Reservoir_coll_nb = CInt(Nud8.Value)
                Case 10 'Timbre d'office
                    exut._Timbre_Office_nb = CInt(Nud8.Value)
                Case 11 'Bac à laver
                    exut._Bac_a_Laver_nb = CInt(Nud8.Value)
                Case 12 'urinoirs avec robinet individuel
                    exut._Urinoir_nb = CInt(Nud8.Value)
                Case 13 'poste d'eau 1/2
                    exut._Poste_eau_nb = CInt(Nud8.Value)
                Case 14 ' lavabo collectif
                    exut._lavabo_Coll_nb = CInt(Nud8.Value)
            End Select
            EP1.SetError(Cb5App, "") ' Clear the error.
        ElseIf Cb8App.Visible = True Then
            Verif = False
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des appareils pour la dernière ligne.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            EP1.SetError(Cb8App, "le champ n'a pas été sélectionné!!")
            Exit Sub
        End If
        'Gestion du tube alimentant l'exutoire
        Select Case RbtnExutMat_Non_Identique.Checked
            Case True
                exut.Mat = 0
            Case False
                Select Case CbExutMat.SelectedIndex
                    Case -1
                        Verif = False
                        MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des appareils pour la dernière ligne.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        EP1.SetError(Cb8App, "le champ n'a pas été sélectionné!!")
                    Case 0  'Tube en cuivre 
                        exut.Mat = 1
                    Case 1  ' Tube en acier galvanisé 
                        exut.Mat = 2
                    Case 2 ' Tube en PER      
                        exut.Mat = 3
                    Case 3 ' Tube multicouche     
                        exut.Mat = 4
                    Case 4 'Tube en PVC-C 
                        exut.Mat = 5
                End Select
        End Select
    End Sub
    ''' <summary>
    '''Affichage vierge de l'onglet Exutoire sans éléments pré-remplis
    ''' </summary>
    Private Sub Affichage_Exutoire_vierge()
        Nud1.Value = 1
        Nud1.Value = 1 : Cb1App.SelectedIndex = -1 'Cb1App.Text = String.Empty :
        Btn2Moins.Hide() : Btn2Plus.Hide() : Lbl2.Hide() : lblnb2.Hide() : Cb2App.SelectedIndex = -1 : Cb2App.Hide() : Nud2.Hide()
        Btn3Moins.Hide() : Btn3Plus.Hide() : lbl3.Hide() : lblnb3.Hide() : Cb3App.SelectedIndex = -1 : Cb3App.Hide() : Nud3.Hide()
        Btn4Moins.Hide() : Btn4Plus.Hide() : Lbl4.Hide() : lblnb4.Hide() : Cb4App.SelectedIndex = -1 : Cb4App.Hide() : Nud4.Hide()
        Btn5Moins.Hide() : Btn5Plus.Hide() : Lbl5.Hide() : lblnb5.Hide() : Cb5App.SelectedIndex = -1 : Cb5App.Hide() : Nud5.Hide()
        Btn6Moins.Hide() : Btn6Plus.Hide() : Lbl6.Hide() : lblnb6.Hide() : Cb6App.SelectedIndex = -1 : Cb6App.Hide() : Nud6.Hide()
        Btn7Moins.Hide() : Btn7Plus.Hide() : Lbl7.Hide() : lblnb7.Hide() : Cb7App.SelectedIndex = -1 : Cb7App.Hide() : Nud7.Hide()
        Btn8Moins.Hide() : Lbl8.Hide() : lblnb8.Hide() : Cb8App.SelectedIndex = -1 : Cb8App.Hide() : Nud8.Hide()
    End Sub
    ''' <summary>
    '''Affichage de l'onglet Exutoire avec éléments pré-remplis
    ''' </summary>
    Private Sub Affichage_Exutoire_NON_vierge(ByVal i As Integer)
        Dim j As Integer = 1
        Call Affichage_Exutoire_vierge() 'pour remettre à 0 le formulaire.
        i = i - 1 'base 0
        If Exutoires.Item(i)._Baignoire_Nb > 0.1 Then
            Cb1App.Text = Cb1App.Items(0).ToString() : Nud1.Value = Exutoires.Item(i)._Baignoire_Nb : j += 1
        End If
        If Exutoires.Item(i)._Bidet_nb > 0.1 Then
            If j = 2 Then
                Btn2Moins.Visible = True : Btn2Plus.Visible = True : Lbl2.Visible = True : lblnb2.Visible = True : Cb2App.Visible = True : Nud2.Visible = True
                Cb2App.Text = Cb2App.Items(1).ToString() : Nud2.Value = Exutoires.Item(i)._Bidet_nb : j += 1
            Else
                Cb1App.Text = Cb1App.Items(1).ToString() : Nud1.Value = Exutoires.Item(i)._Bidet_nb : j += 1
            End If
        End If
        If Exutoires.Item(i)._douche_nb > 0.1 Then
            Select Case j
                Case 1
                    Cb1App.Text = Cb1App.Items(2).ToString() : Nud1.Value = Exutoires.Item(i)._douche_nb : j += 1
                Case 2
                    Btn2Moins.Visible = True : Btn2Plus.Visible = True : Lbl2.Visible = True : lblnb2.Visible = True : Cb2App.Visible = True : Nud2.Visible = True
                    Cb2App.Text = Cb2App.Items(2).ToString() : Nud2.Value = Exutoires.Item(i)._douche_nb : j += 1
                Case 3
                    Btn3Moins.Visible = True : Btn3Plus.Visible = True : lbl3.Visible = True : lblnb3.Visible = True : Cb3App.Visible = True : Nud3.Visible = True
                    Cb3App.Text = Cb3App.Items(2).ToString() : Nud3.Value = Exutoires.Item(i)._douche_nb : j += 1
            End Select
        End If
        If Exutoires.Item(i)._Evier_nb > 0.1 Then
            Select Case j
                Case 1
                    Cb1App.Text = Cb1App.Items(3).ToString() : Nud1.Value = Exutoires.Item(i)._Evier_nb : j += 1
                Case 2
                    Btn2Moins.Visible = True : Btn2Plus.Visible = True : Lbl2.Visible = True : lblnb2.Visible = True : Cb2App.Visible = True : Nud2.Visible = True
                    Cb2App.Text = Cb2App.Items(3).ToString() : Nud2.Value = Exutoires.Item(i)._Evier_nb : j += 1
                Case 3
                    Btn3Moins.Visible = True : Btn3Plus.Visible = True : lbl3.Visible = True : lblnb3.Visible = True : Cb3App.Visible = True : Nud3.Visible = True
                    Cb3App.Text = Cb3App.Items(3).ToString() : Nud3.Value = Exutoires.Item(i)._Evier_nb : j += 1
                Case 4
                    Btn4Moins.Visible = True : Btn4Plus.Visible = True : Lbl4.Visible = True : lblnb4.Visible = True : Cb4App.Visible = True : Nud4.Visible = True
                    Cb4App.Text = Cb4App.Items(3).ToString() : Nud4.Value = Exutoires.Item(i)._Evier_nb : j += 1
            End Select
        End If
        If Exutoires.Item(i)._lavabo_nb > 0.1 Then
            Select Case j
                Case 1
                    Cb1App.Text = Cb1App.Items(4).ToString() : Nud1.Value = Exutoires.Item(i)._lavabo_nb : j += 1
                Case 2
                    Btn2Moins.Visible = True : Btn2Plus.Visible = True : Lbl2.Visible = True : lblnb2.Visible = True : Cb2App.Visible = True : Nud2.Visible = True
                    Cb2App.Text = Cb2App.Items(4).ToString() : Nud2.Value = Exutoires.Item(i)._lavabo_nb : j += 1
                Case 3
                    Btn3Moins.Visible = True : Btn3Plus.Visible = True : lbl3.Visible = True : lblnb3.Visible = True : Cb3App.Visible = True : Nud3.Visible = True
                    Cb3App.Text = Cb3App.Items(4).ToString() : Nud3.Value = Exutoires.Item(i)._lavabo_nb : j += 1
                Case 4
                    Btn4Moins.Visible = True : Btn4Plus.Visible = True : Lbl4.Visible = True : lblnb4.Visible = True : Cb4App.Visible = True : Nud4.Visible = True
                    Cb4App.Text = Cb4App.Items(4).ToString() : Nud4.Value = Exutoires.Item(i)._lavabo_nb : j += 1
                Case 5
                    Btn5Moins.Visible = True : Btn5Plus.Visible = True : Lbl5.Visible = True : lblnb5.Visible = True : Cb5App.Visible = True : Nud5.Visible = True
                    Cb5App.Text = Cb5App.Items(4).ToString() : Nud5.Value = Exutoires.Item(i)._lavabo_nb : j += 1
            End Select
        End If
        If Exutoires.Item(i)._Lave_Linge_nb > 0.1 Then
            Select Case j
                Case 1
                    Cb1App.Text = Cb1App.Items(5).ToString() : Nud1.Value = Exutoires.Item(i)._Lave_Linge_nb : j += 1
                Case 2
                    Btn2Moins.Visible = True : Btn2Plus.Visible = True : Lbl2.Visible = True : lblnb2.Visible = True : Cb2App.Visible = True : Nud2.Visible = True
                    Cb2App.Text = Cb2App.Items(5).ToString() : Nud2.Value = Exutoires.Item(i)._Lave_Linge_nb : j += 1
                Case 3
                    Btn3Moins.Visible = True : Btn3Plus.Visible = True : lbl3.Visible = True : lblnb3.Visible = True : Cb3App.Visible = True : Nud3.Visible = True
                    Cb3App.Text = Cb3App.Items(5).ToString() : Nud3.Value = Exutoires.Item(i)._Lave_Linge_nb : j += 1
                Case 4
                    Btn4Moins.Visible = True : Btn4Plus.Visible = True : Lbl4.Visible = True : lblnb4.Visible = True : Cb4App.Visible = True : Nud4.Visible = True
                    Cb4App.Text = Cb4App.Items(5).ToString() : Nud4.Value = Exutoires.Item(i)._Lave_Linge_nb : j += 1
                Case 5
                    Btn5Moins.Visible = True : Btn5Plus.Visible = True : Lbl5.Visible = True : lblnb5.Visible = True : Cb5App.Visible = True : Nud5.Visible = True
                    Cb5App.Text = Cb5App.Items(5).ToString() : Nud5.Value = Exutoires.Item(i)._Lave_Linge_nb : j += 1
                Case 6
                    Btn6Moins.Visible = True : Btn6Plus.Visible = True : Lbl6.Visible = True : lblnb6.Visible = True : Cb6App.Visible = True : Nud6.Visible = True
                    Cb6App.Text = Cb6App.Items(5).ToString() : Nud6.Value = Exutoires.Item(i)._Lave_Linge_nb : j += 1
            End Select
        End If
        If Exutoires.Item(i)._lavemain_nb > 0.1 Then
            Select Case j
                Case 1
                    Cb1App.Text = Cb1App.Items(6).ToString() : Nud1.Value = Exutoires.Item(i)._lavemain_nb : j += 1
                Case 2
                    Btn2Moins.Visible = True : Btn2Plus.Visible = True : Lbl2.Visible = True : lblnb2.Visible = True : Cb2App.Visible = True : Nud2.Visible = True
                    Cb2App.Text = Cb2App.Items(6).ToString() : Nud2.Value = Exutoires.Item(i)._lavemain_nb : j += 1
                Case 3
                    Btn3Moins.Visible = True : Btn3Plus.Visible = True : lbl3.Visible = True : lblnb3.Visible = True : Cb3App.Visible = True : Nud3.Visible = True
                    Cb3App.Text = Cb3App.Items(6).ToString() : Nud3.Value = Exutoires.Item(i)._lavemain_nb : j += 1
                Case 4
                    Btn4Moins.Visible = True : Btn4Plus.Visible = True : Lbl4.Visible = True : lblnb4.Visible = True : Cb4App.Visible = True : Nud4.Visible = True
                    Cb4App.Text = Cb4App.Items(6).ToString() : Nud4.Value = Exutoires.Item(i)._lavemain_nb : j += 1
                Case 5
                    Btn5Moins.Visible = True : Btn5Plus.Visible = True : Lbl5.Visible = True : lblnb5.Visible = True : Cb5App.Visible = True : Nud5.Visible = True
                    Cb5App.Text = Cb5App.Items(6).ToString() : Nud5.Value = Exutoires.Item(i)._lavemain_nb : j += 1
                Case 6
                    Btn6Moins.Visible = True : Btn6Plus.Visible = True : Lbl6.Visible = True : lblnb6.Visible = True : Cb6App.Visible = True : Nud6.Visible = True
                    Cb6App.Text = Cb6App.Items(6).ToString() : Nud6.Value = Exutoires.Item(i)._lavemain_nb : j += 1
                Case 7
                    Btn7Moins.Visible = True : Btn7Plus.Visible = True : Lbl7.Visible = True : lblnb7.Visible = True : Cb7App.Visible = True : Nud7.Visible = True
                    Cb7App.Text = Cb7App.Items(6).ToString() : Nud7.Value = Exutoires.Item(i)._lavemain_nb : j += 1
            End Select
        End If
        If Exutoires.Item(i)._Lave_vaisselle_nb > 0.1 Then
            Select Case j
                Case 1
                    Cb1App.Text = Cb1App.Items(7).ToString() : Nud1.Value = Exutoires.Item(i)._Lave_vaisselle_nb : j += 1
                Case 2
                    Btn2Moins.Visible = True : Btn2Plus.Visible = True : Lbl2.Visible = True : lblnb2.Visible = True : Cb2App.Visible = True : Nud2.Visible = True
                    Cb2App.Text = Cb2App.Items(7).ToString() : Nud2.Value = Exutoires.Item(i)._Lave_vaisselle_nb : j += 1
                Case 3
                    Btn3Moins.Visible = True : Btn3Plus.Visible = True : lbl3.Visible = True : lblnb3.Visible = True : Cb3App.Visible = True : Nud3.Visible = True
                    Cb3App.Text = Cb3App.Items(7).ToString() : Nud3.Value = Exutoires.Item(i)._Lave_vaisselle_nb : j += 1
                Case 4
                    Btn4Moins.Visible = True : Btn4Plus.Visible = True : Lbl4.Visible = True : lblnb4.Visible = True : Cb4App.Visible = True : Nud4.Visible = True
                    Cb4App.Text = Cb4App.Items(7).ToString() : Nud4.Value = Exutoires.Item(i)._Lave_vaisselle_nb : j += 1
                Case 5
                    Btn5Moins.Visible = True : Btn5Plus.Visible = True : Lbl5.Visible = True : lblnb5.Visible = True : Cb5App.Visible = True : Nud5.Visible = True
                    Cb5App.Text = Cb5App.Items(7).ToString() : Nud5.Value = Exutoires.Item(i)._Lave_vaisselle_nb : j += 1
                Case 6
                    Btn6Moins.Visible = True : Btn6Plus.Visible = True : Lbl6.Visible = True : lblnb6.Visible = True : Cb6App.Visible = True : Nud6.Visible = True
                    Cb6App.Text = Cb6App.Items(7).ToString() : Nud6.Value = Exutoires.Item(i)._Lave_vaisselle_nb : j += 1
                Case 7
                    Btn7Moins.Visible = True : Btn7Plus.Visible = True : Lbl7.Visible = True : lblnb7.Visible = True : Cb7App.Visible = True : Nud7.Visible = True
                    Cb7App.Text = Cb7App.Items(7).ToString() : Nud7.Value = Exutoires.Item(i)._Lave_vaisselle_nb : j += 1
                Case 8
                    Btn8Moins.Visible = True : Lbl8.Visible = True : lblnb8.Visible = True : Cb8App.Visible = True : Nud8.Visible = True
                    Cb8App.Text = Cb8App.Items(7).ToString() : Nud8.Value = Exutoires.Item(i)._Lave_vaisselle_nb : j += 1
            End Select
        End If
        If Exutoires.Item(i)._WC_Reservoir_nb > 0.1 Then
            Select Case j
                Case 1
                    Cb1App.Text = Cb1App.Items(8).ToString() : Nud1.Value = Exutoires.Item(i)._WC_Reservoir_nb : j += 1
                Case 2
                    Btn2Moins.Visible = True : Btn2Plus.Visible = True : Lbl2.Visible = True : lblnb2.Visible = True : Cb2App.Visible = True : Nud2.Visible = True
                    Cb2App.Text = Cb2App.Items(8).ToString() : Nud2.Value = Exutoires.Item(i)._WC_Reservoir_nb : j += 1
                Case 3
                    Btn3Moins.Visible = True : Btn3Plus.Visible = True : lbl3.Visible = True : lblnb3.Visible = True : Cb3App.Visible = True : Nud3.Visible = True
                    Cb3App.Text = Cb3App.Items(8).ToString() : Nud3.Value = Exutoires.Item(i)._WC_Reservoir_nb : j += 1
                Case 4
                    Btn4Moins.Visible = True : Btn4Plus.Visible = True : Lbl4.Visible = True : lblnb4.Visible = True : Cb4App.Visible = True : Nud4.Visible = True
                    Cb4App.Text = Cb4App.Items(8).ToString() : Nud4.Value = Exutoires.Item(i)._WC_Reservoir_nb : j += 1
                Case 5
                    Btn5Moins.Visible = True : Btn5Plus.Visible = True : Lbl5.Visible = True : lblnb5.Visible = True : Cb5App.Visible = True : Nud5.Visible = True
                    Cb5App.Text = Cb5App.Items(8).ToString() : Nud5.Value = Exutoires.Item(i)._WC_Reservoir_nb : j += 1
                Case 6
                    Btn6Moins.Visible = True : Btn6Plus.Visible = True : Lbl6.Visible = True : lblnb6.Visible = True : Cb6App.Visible = True : Nud6.Visible = True
                    Cb6App.Text = Cb6App.Items(8).ToString() : Nud6.Value = Exutoires.Item(i)._WC_Reservoir_nb : j += 1
                Case 7
                    Btn7Moins.Visible = True : Btn7Plus.Visible = True : Lbl7.Visible = True : lblnb7.Visible = True : Cb7App.Visible = True : Nud7.Visible = True
                    Cb7App.Text = Cb7App.Items(8).ToString() : Nud7.Value = Exutoires.Item(i)._WC_Reservoir_nb : j += 1
                Case 8
                    Btn8Moins.Visible = True : Lbl8.Visible = True : lblnb8.Visible = True : Cb8App.Visible = True : Nud8.Visible = True
                    Cb8App.Text = Cb8App.Items(8).ToString() : Nud8.Value = Exutoires.Item(i)._WC_Reservoir_nb : j += 1
                Case Else
                    MessageBox.Show("8 appareils ont déjà été renseignés. Créez un exutoire supplémentaire afin d'intégrer cet appareil.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Select
        End If
        If Exutoires.Item(i)._WC_Reservoir_coll_nb > 0.1 Then
            Select Case j
                Case 1
                    Cb1App.Text = Cb1App.Items(9).ToString() : Nud1.Value = Exutoires.Item(i)._WC_Reservoir_coll_nb : j += 1
                Case 2
                    Btn2Moins.Visible = True : Btn2Plus.Visible = True : Lbl2.Visible = True : lblnb2.Visible = True : Cb2App.Visible = True : Nud2.Visible = True
                    Cb2App.Text = Cb2App.Items(9).ToString() : Nud2.Value = Exutoires.Item(i)._WC_Reservoir_coll_nb : j += 1
                Case 3
                    Btn3Moins.Visible = True : Btn3Plus.Visible = True : lbl3.Visible = True : lblnb3.Visible = True : Cb3App.Visible = True : Nud3.Visible = True
                    Cb3App.Text = Cb3App.Items(9).ToString() : Nud3.Value = Exutoires.Item(i)._WC_Reservoir_coll_nb : j += 1
                Case 4
                    Btn4Moins.Visible = True : Btn4Plus.Visible = True : Lbl4.Visible = True : lblnb4.Visible = True : Cb4App.Visible = True : Nud4.Visible = True
                    Cb4App.Text = Cb4App.Items(9).ToString() : Nud4.Value = Exutoires.Item(i)._WC_Reservoir_coll_nb : j += 1
                Case 5
                    Btn5Moins.Visible = True : Btn5Plus.Visible = True : Lbl5.Visible = True : lblnb5.Visible = True : Cb5App.Visible = True : Nud5.Visible = True
                    Cb5App.Text = Cb5App.Items(9).ToString() : Nud5.Value = Exutoires.Item(i)._WC_Reservoir_coll_nb : j += 1
                Case 6
                    Btn6Moins.Visible = True : Btn6Plus.Visible = True : Lbl6.Visible = True : lblnb6.Visible = True : Cb6App.Visible = True : Nud6.Visible = True
                    Cb6App.Text = Cb6App.Items(9).ToString() : Nud6.Value = Exutoires.Item(i)._WC_Reservoir_coll_nb : j += 1
                Case 7
                    Btn7Moins.Visible = True : Btn7Plus.Visible = True : Lbl7.Visible = True : lblnb7.Visible = True : Cb7App.Visible = True : Nud7.Visible = True
                    Cb7App.Text = Cb7App.Items(9).ToString() : Nud7.Value = Exutoires.Item(i)._WC_Reservoir_coll_nb : j += 1
                Case 8
                    Btn8Moins.Visible = True : Lbl8.Visible = True : lblnb8.Visible = True : Cb8App.Visible = True : Nud8.Visible = True
                    Cb8App.Text = Cb8App.Items(9).ToString() : Nud8.Value = Exutoires.Item(i)._WC_Reservoir_coll_nb : j += 1
                Case Else
                    MessageBox.Show("8 appareils ont déjà été renseignés. Créez un exutoire supplémentaire afin d'intégrer cet appareil.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Select
        End If
        If Exutoires.Item(i)._Timbre_Office_nb > 0.1 Then
            Select Case j
                Case 1
                    Cb1App.Text = Cb1App.Items(10).ToString() : Nud1.Value = Exutoires.Item(i)._Timbre_Office_nb : j += 1
                Case 2
                    Btn2Moins.Visible = True : Btn2Plus.Visible = True : Lbl2.Visible = True : lblnb2.Visible = True : Cb2App.Visible = True : Nud2.Visible = True
                    Cb2App.Text = Cb2App.Items(10).ToString() : Nud2.Value = Exutoires.Item(i)._Timbre_Office_nb : j += 1
                Case 3
                    Btn3Moins.Visible = True : Btn3Plus.Visible = True : lbl3.Visible = True : lblnb3.Visible = True : Cb3App.Visible = True : Nud3.Visible = True
                    Cb3App.Text = Cb3App.Items(10).ToString() : Nud3.Value = Exutoires.Item(i)._Timbre_Office_nb : j += 1
                Case 4
                    Btn4Moins.Visible = True : Btn4Plus.Visible = True : Lbl4.Visible = True : lblnb4.Visible = True : Cb4App.Visible = True : Nud4.Visible = True
                    Cb4App.Text = Cb4App.Items(10).ToString() : Nud4.Value = Exutoires.Item(i)._Timbre_Office_nb : j += 1
                Case 5
                    Btn5Moins.Visible = True : Btn5Plus.Visible = True : Lbl5.Visible = True : lblnb5.Visible = True : Cb5App.Visible = True : Nud5.Visible = True
                    Cb5App.Text = Cb5App.Items(10).ToString() : Nud5.Value = Exutoires.Item(i)._Timbre_Office_nb : j += 1
                Case 6
                    Btn6Moins.Visible = True : Btn6Plus.Visible = True : Lbl6.Visible = True : lblnb6.Visible = True : Cb6App.Visible = True : Nud6.Visible = True
                    Cb6App.Text = Cb6App.Items(10).ToString() : Nud6.Value = Exutoires.Item(i)._Timbre_Office_nb : j += 1
                Case 7
                    Btn7Moins.Visible = True : Btn7Plus.Visible = True : Lbl7.Visible = True : lblnb7.Visible = True : Cb7App.Visible = True : Nud7.Visible = True
                    Cb7App.Text = Cb7App.Items(10).ToString() : Nud7.Value = Exutoires.Item(i)._Timbre_Office_nb : j += 1
                Case 8
                    Btn8Moins.Visible = True : Lbl8.Visible = True : lblnb8.Visible = True : Cb8App.Visible = True : Nud8.Visible = True
                    Cb8App.Text = Cb8App.Items(10).ToString() : Nud8.Value = Exutoires.Item(i)._Timbre_Office_nb : j += 1
                Case Else
                    MessageBox.Show("8 appareils ont déjà été renseignés. Créez un exutoire supplémentaire afin d'intégrer cet appareil.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Select
        End If
        If Exutoires.Item(i)._Bac_a_Laver_nb > 0.1 Then
            Select Case j
                Case 1
                    Cb1App.Text = Cb1App.Items(11).ToString() : Nud1.Value = Exutoires.Item(i)._Bac_a_Laver_nb : j += 1
                Case 2
                    Btn2Moins.Visible = True : Btn2Plus.Visible = True : Lbl2.Visible = True : lblnb2.Visible = True : Cb2App.Visible = True : Nud2.Visible = True
                    Cb2App.Text = Cb2App.Items(11).ToString() : Nud2.Value = Exutoires.Item(i)._Bac_a_Laver_nb : j += 1
                Case 3
                    Btn3Moins.Visible = True : Btn3Plus.Visible = True : lbl3.Visible = True : lblnb3.Visible = True : Cb3App.Visible = True : Nud3.Visible = True
                    Cb3App.Text = Cb3App.Items(11).ToString() : Nud3.Value = Exutoires.Item(i)._Bac_a_Laver_nb : j += 1
                Case 4
                    Btn4Moins.Visible = True : Btn4Plus.Visible = True : Lbl4.Visible = True : lblnb4.Visible = True : Cb4App.Visible = True : Nud4.Visible = True
                    Cb4App.Text = Cb4App.Items(11).ToString() : Nud4.Value = Exutoires.Item(i)._Bac_a_Laver_nb : j += 1
                Case 5
                    Btn5Moins.Visible = True : Btn5Plus.Visible = True : Lbl5.Visible = True : lblnb5.Visible = True : Cb5App.Visible = True : Nud5.Visible = True
                    Cb5App.Text = Cb5App.Items(11).ToString() : Nud5.Value = Exutoires.Item(i)._Bac_a_Laver_nb : j += 1
                Case 6
                    Btn6Moins.Visible = True : Btn6Plus.Visible = True : Lbl6.Visible = True : lblnb6.Visible = True : Cb6App.Visible = True : Nud6.Visible = True
                    Cb6App.Text = Cb6App.Items(11).ToString() : Nud6.Value = Exutoires.Item(i)._Bac_a_Laver_nb : j += 1
                Case 7
                    Btn7Moins.Visible = True : Btn7Plus.Visible = True : Lbl7.Visible = True : lblnb7.Visible = True : Cb7App.Visible = True : Nud7.Visible = True
                    Cb7App.Text = Cb7App.Items(11).ToString() : Nud7.Value = Exutoires.Item(i)._Bac_a_Laver_nb : j += 1
                Case 8
                    Btn8Moins.Visible = True : Lbl8.Visible = True : lblnb8.Visible = True : Cb8App.Visible = True : Nud8.Visible = True
                    Cb8App.Text = Cb8App.Items(11).ToString() : Nud8.Value = Exutoires.Item(i)._Bac_a_Laver_nb : j += 1
                Case Else
                    MessageBox.Show("8 appareils ont déjà été renseignés. Créez un exutoire supplémentaire afin d'intégrer cet appareil.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Select
        End If
        If Exutoires.Item(i)._Urinoir_nb > 0.1 Then
            Select Case j
                Case 1
                    Cb1App.Text = Cb1App.Items(12).ToString() : Nud1.Value = Exutoires.Item(i)._Urinoir_nb : j += 1
                Case 2
                    Btn2Moins.Visible = True : Btn2Plus.Visible = True : Lbl2.Visible = True : lblnb2.Visible = True : Cb2App.Visible = True : Nud2.Visible = True
                    Cb2App.Text = Cb2App.Items(12).ToString() : Nud2.Value = Exutoires.Item(i)._Urinoir_nb : j += 1
                Case 3
                    Btn3Moins.Visible = True : Btn3Plus.Visible = True : lbl3.Visible = True : lblnb3.Visible = True : Cb3App.Visible = True : Nud3.Visible = True
                    Cb3App.Text = Cb3App.Items(12).ToString() : Nud3.Value = Exutoires.Item(i)._Urinoir_nb : j += 1
                Case 4
                    Btn4Moins.Visible = True : Btn4Plus.Visible = True : Lbl4.Visible = True : lblnb4.Visible = True : Cb4App.Visible = True : Nud4.Visible = True
                    Cb4App.Text = Cb4App.Items(12).ToString() : Nud4.Value = Exutoires.Item(i)._Urinoir_nb : j += 1
                Case 5
                    Btn5Moins.Visible = True : Btn5Plus.Visible = True : Lbl5.Visible = True : lblnb5.Visible = True : Cb5App.Visible = True : Nud5.Visible = True
                    Cb5App.Text = Cb5App.Items(12).ToString() : Nud5.Value = Exutoires.Item(i)._Urinoir_nb : j += 1
                Case 6
                    Btn6Moins.Visible = True : Btn6Plus.Visible = True : Lbl6.Visible = True : lblnb6.Visible = True : Cb6App.Visible = True : Nud6.Visible = True
                    Cb6App.Text = Cb6App.Items(12).ToString() : Nud6.Value = Exutoires.Item(i)._Urinoir_nb : j += 1
                Case 7
                    Btn7Moins.Visible = True : Btn7Plus.Visible = True : Lbl7.Visible = True : lblnb7.Visible = True : Cb7App.Visible = True : Nud7.Visible = True
                    Cb7App.Text = Cb7App.Items(12).ToString() : Nud7.Value = Exutoires.Item(i)._Urinoir_nb : j += 1
                Case 8
                    Btn8Moins.Visible = True : Lbl8.Visible = True : lblnb8.Visible = True : Cb8App.Visible = True : Nud8.Visible = True
                    Cb8App.Text = Cb8App.Items(12).ToString() : Nud8.Value = Exutoires.Item(i)._Urinoir_nb : j += 1
                Case Else
                    MessageBox.Show("8 appareils ont déjà été renseignés. Créez un exutoire supplémentaire afin d'intégrer cet appareil.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Select
        End If
        If Exutoires.Item(i)._Poste_eau_nb > 0.1 Then
            Select Case j
                Case 1
                    Cb1App.Text = Cb1App.Items(13).ToString() : Nud1.Value = Exutoires.Item(i)._Poste_eau_nb : j += 1
                Case 2
                    Btn2Moins.Visible = True : Btn2Plus.Visible = True : Lbl2.Visible = True : lblnb2.Visible = True : Cb2App.Visible = True : Nud2.Visible = True
                    Cb2App.Text = Cb2App.Items(13).ToString() : Nud2.Value = Exutoires.Item(i)._Poste_eau_nb : j += 1
                Case 3
                    Btn3Moins.Visible = True : Btn3Plus.Visible = True : lbl3.Visible = True : lblnb3.Visible = True : Cb3App.Visible = True : Nud3.Visible = True
                    Cb3App.Text = Cb3App.Items(13).ToString() : Nud3.Value = Exutoires.Item(i)._Poste_eau_nb : j += 1
                Case 4
                    Btn4Moins.Visible = True : Btn4Plus.Visible = True : Lbl4.Visible = True : lblnb4.Visible = True : Cb4App.Visible = True : Nud4.Visible = True
                    Cb4App.Text = Cb4App.Items(13).ToString() : Nud4.Value = Exutoires.Item(i)._Poste_eau_nb : j += 1
                Case 5
                    Btn5Moins.Visible = True : Btn5Plus.Visible = True : Lbl5.Visible = True : lblnb5.Visible = True : Cb5App.Visible = True : Nud5.Visible = True
                    Cb5App.Text = Cb5App.Items(13).ToString() : Nud5.Value = Exutoires.Item(i)._Poste_eau_nb : j += 1
                Case 6
                    Btn6Moins.Visible = True : Btn6Plus.Visible = True : Lbl6.Visible = True : lblnb6.Visible = True : Cb6App.Visible = True : Nud6.Visible = True
                    Cb6App.Text = Cb6App.Items(13).ToString() : Nud6.Value = Exutoires.Item(i)._Poste_eau_nb : j += 1
                Case 7
                    Btn7Moins.Visible = True : Btn7Plus.Visible = True : Lbl7.Visible = True : lblnb7.Visible = True : Cb7App.Visible = True : Nud7.Visible = True
                    Cb7App.Text = Cb7App.Items(13).ToString() : Nud7.Value = Exutoires.Item(i)._Poste_eau_nb : j += 1
                Case 8
                    Btn8Moins.Visible = True : Lbl8.Visible = True : lblnb8.Visible = True : Cb8App.Visible = True : Nud8.Visible = True
                    Cb8App.Text = Cb8App.Items(13).ToString() : Nud8.Value = Exutoires.Item(i)._Poste_eau_nb : j += 1
                Case Else
                    MessageBox.Show("8 appareils ont déjà été renseignés. Créez un exutoire supplémentaire afin d'intégrer cet appareil.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Select
        End If
        If Exutoires.Item(i)._lavabo_Coll_nb > 0.1 Then
            Select Case j
                Case 1
                    Cb1App.Text = Cb1App.Items(14).ToString() : Nud1.Value = Exutoires.Item(i)._lavabo_Coll_nb : j += 1
                Case 2
                    Btn2Moins.Visible = True : Btn2Plus.Visible = True : Lbl2.Visible = True : lblnb2.Visible = True : Cb2App.Visible = True : Nud2.Visible = True
                    Cb2App.Text = Cb2App.Items(14).ToString() : Nud2.Value = Exutoires.Item(i)._lavabo_Coll_nb : j += 1
                Case 3
                    Btn3Moins.Visible = True : Btn3Plus.Visible = True : lbl3.Visible = True : lblnb3.Visible = True : Cb3App.Visible = True : Nud3.Visible = True
                    Cb3App.Text = Cb3App.Items(14).ToString() : Nud3.Value = Exutoires.Item(i)._lavabo_Coll_nb : j += 1
                Case 4
                    Btn4Moins.Visible = True : Btn4Plus.Visible = True : Lbl4.Visible = True : lblnb4.Visible = True : Cb4App.Visible = True : Nud4.Visible = True
                    Cb4App.Text = Cb4App.Items(14).ToString() : Nud4.Value = Exutoires.Item(i)._lavabo_Coll_nb : j += 1
                Case 5
                    Btn5Moins.Visible = True : Btn5Plus.Visible = True : Lbl5.Visible = True : lblnb5.Visible = True : Cb5App.Visible = True : Nud5.Visible = True
                    Cb5App.Text = Cb5App.Items(14).ToString() : Nud5.Value = Exutoires.Item(i)._lavabo_Coll_nb : j += 1
                Case 6
                    Btn6Moins.Visible = True : Btn6Plus.Visible = True : Lbl6.Visible = True : lblnb6.Visible = True : Cb6App.Visible = True : Nud6.Visible = True
                    Cb6App.Text = Cb6App.Items(14).ToString() : Nud6.Value = Exutoires.Item(i)._lavabo_Coll_nb : j += 1
                Case 7
                    Btn7Moins.Visible = True : Btn7Plus.Visible = True : Lbl7.Visible = True : lblnb7.Visible = True : Cb7App.Visible = True : Nud7.Visible = True
                    Cb7App.Text = Cb7App.Items(14).ToString() : Nud7.Value = Exutoires.Item(i)._lavabo_Coll_nb : j += 1
                Case 8
                    Btn8Moins.Visible = True : Lbl8.Visible = True : lblnb8.Visible = True : Cb8App.Visible = True : Nud8.Visible = True
                    Cb8App.Text = Cb8App.Items(14).ToString() : Nud8.Value = Exutoires.Item(i)._lavabo_Coll_nb : j += 1
                Case Else
                    MessageBox.Show("8 appareils ont déjà été renseignés. Créez un exutoire supplémentaire afin d'intégrer cet appareil.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Select
        End If
        lblNbExut.Text = "Nombre total d'exutoire(s) renseigné(s): " & Exutoires.Count
    End Sub

#Region "Btn Plus Moins - Onglet Exutoire"
    Private Sub Btn1Plus_Click(sender As Object, e As EventArgs) Handles Btn1Plus.Click
        If Cb1App.SelectedIndex = -1 Then
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des appareils.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        ElseIf Cb2App.Visible = False Then
            Btn2Moins.Visible = True : Btn2Plus.Visible = True : Lbl2.Visible = True : lblnb2.Visible = True
            Cb2App.Visible = True
            Nud2.Visible = True : Nud2.Value = 1
        End If
    End Sub
    Private Sub Btn2Moins_Click(sender As Object, e As EventArgs) Handles Btn2Moins.Click
        Btn2Moins.Hide() : Btn2Plus.Hide() : Lbl2.Hide() : lblnb2.Hide() : Cb2App.Hide() : Nud2.Hide()
    End Sub
    Private Sub Btn2Plus_Click(sender As Object, e As EventArgs) Handles Btn2Plus.Click
        If Cb2App.SelectedIndex = -1 Then
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des appareils.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        ElseIf Cb3App.Visible = False Then
            Btn3Moins.Visible = True : Btn3Plus.Visible = True : lbl3.Visible = True : lblnb3.Visible = True
            Cb3App.Visible = True
            Nud3.Visible = True : Nud3.Value = 1
        End If
    End Sub
    Private Sub Btn3Moins_Click(sender As Object, e As EventArgs) Handles Btn3Moins.Click
        Btn3Moins.Hide() : Btn3Plus.Hide() : lbl3.Hide() : lblnb3.Hide() : Cb3App.Hide() : Nud3.Hide()
    End Sub
    Private Sub Btn3Plus_Click(sender As Object, e As EventArgs) Handles Btn3Plus.Click
        If Cb3App.SelectedIndex = -1 Then
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des appareils.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        ElseIf Cb4App.Visible = False Then
            Btn4Moins.Visible = True : Btn4Plus.Visible = True : Lbl4.Visible = True : lblnb4.Visible = True
            Cb4App.Visible = True
            Nud4.Visible = True : Nud4.Value = 1
        End If
    End Sub
    Private Sub Btn4Moins_Click(sender As Object, e As EventArgs) Handles Btn4Moins.Click
        Btn4Moins.Hide() : Btn4Plus.Hide() : Lbl4.Hide() : lblnb4.Hide() : Cb4App.Hide() : Nud4.Hide()
    End Sub
    Private Sub Btn4Plus_Click(sender As Object, e As EventArgs) Handles Btn4Plus.Click
        If Cb4App.SelectedIndex = -1 Then
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des appareils.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        ElseIf Cb5App.Visible = False Then
            Btn5Moins.Visible = True : Btn5Plus.Visible = True : Lbl5.Visible = True : lblnb5.Visible = True
            Cb5App.Visible = True
            Nud5.Visible = True : Nud5.Value = 1
        End If
    End Sub
    Private Sub Btn5Moins_Click(sender As Object, e As EventArgs) Handles Btn5Moins.Click
        Btn5Moins.Hide() : Btn5Plus.Hide() : Lbl5.Hide() : lblnb5.Hide() : Cb5App.Hide() : Nud5.Hide()
    End Sub
    Private Sub Btn5Plus_Click(sender As Object, e As EventArgs) Handles Btn5Plus.Click
        If Cb5App.SelectedIndex = -1 Then
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des appareils.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        ElseIf Cb6App.Visible = False Then
            Btn6Moins.Visible = True : Btn6Plus.Visible = True : Lbl6.Visible = True : lblnb6.Visible = True
            Cb6App.Visible = True : Cb6App.Items(0).ToString()
            Nud6.Visible = True : Nud6.Value = 1
        End If
    End Sub
    Private Sub Btn6Moins_Click(sender As Object, e As EventArgs) Handles Btn6Moins.Click
        Btn6Moins.Hide() : Btn6Plus.Hide() : Lbl6.Hide() : lblnb6.Hide() : Cb6App.Hide() : Nud6.Hide()
    End Sub
    Private Sub Btn6Plus_Click(sender As Object, e As EventArgs) Handles Btn6Plus.Click
        If Cb6App.SelectedIndex = -1 Then
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des appareils.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        ElseIf Cb7App.Visible = False Then
            Btn7Moins.Visible = True : Btn7Plus.Visible = True : Lbl7.Visible = True : lblnb7.Visible = True
            Cb7App.Visible = True
            Nud7.Visible = True : Nud7.Value = 1
        End If
    End Sub
    Private Sub Btn7Moins_Click(sender As Object, e As EventArgs) Handles Btn7Moins.Click
        Btn7Moins.Hide() : Btn7Plus.Hide() : Lbl7.Hide() : lblnb7.Hide() : Cb7App.Hide() : Nud7.Hide()
    End Sub
    Private Sub Btn7Plus_Click(sender As Object, e As EventArgs) Handles Btn7Plus.Click
        If Cb7App.SelectedIndex = -1 Then
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des appareils.", "Onglet Exutoire", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        ElseIf Cb8App.Visible = False Then
            Btn8Moins.Visible = True : Lbl8.Visible = True : lblnb8.Visible = True
            Cb8App.Visible = True : Cb8App.Items(0).ToString() : Nud8.Visible = True : Nud8.Value = 1
        End If
    End Sub
    Private Sub Btn8Moins_Click(sender As Object, e As EventArgs) Handles Btn8Moins.Click
        Btn8Moins.Hide() : Lbl8.Hide() : lblnb8.Hide() : Cb8App.Hide() : Nud8.Hide()
    End Sub
#End Region
    Private Sub BtnSuppressionExutoire_Click(sender As Object, e As EventArgs) Handles BtnSuppExutoire.Click
        Dim ntype As Integer
        ntype = CInt(LblExut.Text)
        If ntype <= Exutoires.Count Then
            Exutoires.RemoveAt(ntype - 1)
            LblExut.Text = (ntype - 1).ToString
            If ntype > 1 Then Call Affichage_Exutoire_NON_vierge(ntype - 1) Else Call Affichage_Exutoire_NON_vierge(1)
        Else
            'dernier élément entré et non encore renseigné 
            LblExut.Text = (ntype - 1).ToString
            If (ntype - 1) = 1 Then BtnExutMoins.Hide()
            Call Affichage_Exutoire_NON_vierge(ntype - 1)
        End If

    End Sub
    Private Sub RbtnExutMat_Non_Identique_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnExutMat_Non_Identique.CheckedChanged
        If RbtnExutMat_Non_Identique.Checked = True Then
            CbExutMat.SelectedIndex = -1 : CbExutMat.Enabled = False
        Else
            CbExutMat.Enabled = True
        End If
    End Sub
#End Region
    Private Sub Tc1_Enter(sender As Object, e As EventArgs) Handles Tc1.SelectedIndexChanged
        Select Case Tc1.SelectedIndex
            Case 0 '
                If Exutoires.Count <> 0 Then LblExut.Text = "1" : Call Affichage_Exutoire_NON_vierge(1)
            Case 1
                LblTronçon.Text = "1"
                If Reseau._Tuyau.Count <> 0 Then
                    Affichage_Tronçon_NON_Vierge(1)
                Else
                    RbtnInstal_Indiv_Aucune.Checked = True
                    Call Affichage_Tronçon_Vierge(1)
                End If
            Case 2
                Call Affichage_CarReseau() 'identique pour les 2 cas: avec ou sans réseau connu
            Case 3
                Call Affichage_PdcCommun() 'identique pour les 2 cas: avec ou sans réseau connu

        End Select
    End Sub

    Private Sub TabControl1_Deselecting(sender As Object, e As TabControlCancelEventArgs) Handles Tc1.Deselecting

        'Dim messageBoxVB As New System.Text.StringBuilder()
        'messageBoxVB.AppendFormat("{0} = {1}", "TabPage", e.TabPage)
        'messageBoxVB.AppendLine()
        'messageBoxVB.AppendFormat("{0} = {1}", "TabPageIndex", e.TabPageIndex)
        'messageBoxVB.AppendLine()
        'messageBoxVB.AppendFormat("{0} = {1}", "Action", e.Action)
        'messageBoxVB.AppendLine()
        'messageBoxVB.AppendFormat("{0} = {1}", "Cancel", e.Cancel)
        'messageBoxVB.AppendLine()
        'MessageBox.Show(messageBoxVB.ToString(), "Deselecting Event")
        Dim Verif As Boolean = True
        Select Case e.TabPageIndex
            Case 0 'A faire avant de quitter l'onglet Exutoire
                Try
                    Dim ntype As Integer
                    Dim Exut As New Exutoire
                    Call Lecture_Exutoire(Exut, Verif)
                    If Verif = False Then
                        Me.Tc1.SelectTab(0)
                        Exit Sub
                    End If
                    ntype = CInt(LblExut.Text)
                    If Exutoires.Count < ntype Then
                        Exutoires.Add(Exut) 'cet exutoire n'a pas encore été renseigné

                    Else
                        'remplacement de l'exutoire existant
                        Exutoires.Item(ntype - 1)._Baignoire_Nb = Exut._Baignoire_Nb
                        Exutoires.Item(ntype - 1)._Bidet_nb = Exut._Bidet_nb
                        Exutoires.Item(ntype - 1)._douche_nb = Exut._douche_nb
                        Exutoires.Item(ntype - 1)._Evier_nb = Exut._Evier_nb
                        Exutoires.Item(ntype - 1)._lavabo_nb = Exut._lavabo_nb
                        Exutoires.Item(ntype - 1)._Lave_Linge_nb = Exut._Lave_Linge_nb
                        Exutoires.Item(ntype - 1)._lavemain_nb = Exut._lavemain_nb
                        Exutoires.Item(ntype - 1)._Lave_vaisselle_nb = Exut._Lave_vaisselle_nb
                        Exutoires.Item(ntype - 1)._WC_Reservoir_nb = Exut._WC_Reservoir_nb
                        Exutoires.Item(ntype - 1)._WC_Reservoir_coll_nb = Exut._WC_Reservoir_coll_nb
                        Exutoires.Item(ntype - 1)._Timbre_Office_nb = Exut._Timbre_Office_nb
                        Exutoires.Item(ntype - 1)._Bac_a_Laver_nb = Exut._Bac_a_Laver_nb
                        Exutoires.Item(ntype - 1)._Urinoir_nb = Exut._Urinoir_nb
                    End If
                Catch ex As Exception
                    MessageBox.Show("Erreur: " + Environment.NewLine + ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Me.Tc1.SelectTab(0)
                End Try

            Case 1 'A faire avant de quitter l'onglet Géométrie Réseau
                'RAS - aucune influence sur les autres onglets
            Case 2 'A faire avant de quitter l'onglet caractéristiques Réseau
                Try
                    Lecture_Car_Reseau(Verif)
                    If Verif = False Then
                        Me.Tc1.SelectTab(2)
                        Exit Sub
                    End If
                Catch ex As Exception
                    MessageBox.Show("Erreur: " + Environment.NewLine + ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)

                End Try

            Case 3 'A faire avant de quitter l'onglet Pdc Réseau
                Try
                    Lecture_PdcCommun(Verif)
                    If Verif = False Then
                        Me.Tc1.SelectTab(3)
                        Exit Sub
                    End If
                Catch ex As Exception
                    MessageBox.Show("Erreur: " + Environment.NewLine + ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Me.Tc1.SelectTab(3)
                End Try

        End Select
    End Sub

#Region "Onglet Tronçons"

    Private Sub BtnTrMoins_Click(sender As Object, e As EventArgs) Handles BtnTrMoins.Click
        Dim ntronçon As Integer
        Dim Tuy As New Tuyau
        Dim Verif As Boolean = True
        Call Lecture_Reseau_Geom(Tuy, Verif)
        If Verif = False Then Exit Sub
        DgvExut.Rows.Clear()
        ntronçon = CInt(LblTronçon.Text)
        With Reseau
            If ._Tuyau.Count < ntronçon Then
                ._Tuyau.Add(Tuy) 'cet exutoire n'a pas encore été renseigné
            Else
                'remplacement de l'exutoire existant
                ._Tuyau.Item(ntronçon - 1).Hp = Tuy.Hp
                ._Tuyau.Item(ntronçon - 1).L = Tuy.L
                ._Tuyau.Item(ntronçon - 1).Mat = Tuy.Mat
                ._Tuyau.Item(ntronçon - 1).Vlimit = Tuy.Vlimit
                ._Tuyau.Item(ntronçon - 1).Øimposée = Tuy.Øimposée
                If Tuy.Øimposée = True Then
                    ._Tuyau.Item(ntronçon - 1).Nom = Tuy.Nom
                    ._Tuyau.Item(ntronçon - 1).Øimp = Tuy.Øimp
                Else
                    ._Tuyau.Item(ntronçon - 1).Nom = String.Empty
                    ._Tuyau.Item(ntronçon - 1).Øimp = 0
                End If
                ._Tuyau.Item(ntronçon - 1).Qimposée = Tuy.Qimposée
                If Tuy.Qimposée = True Then
                    ._Tuyau.Item(ntronçon - 1).Qimp = Tuy.Qimp
                Else
                    ._Tuyau.Item(ntronçon - 1).Qimp = 0
                End If
                ._Tuyau.Item(ntronçon - 1).Tronçon_Amont.Clear()
                ._Tuyau.Item(ntronçon - 1).Tronçon_Amont = Tuy.Tronçon_Amont
                ._Tuyau.Item(ntronçon - 1).Exut_nbType.Clear() : ._Tuyau.Item(ntronçon - 1).Exut_Type.Clear() : ._Tuyau.Item(ntronçon - 1).Exut_Mat.Clear()
                For i = 0 To Tuy.Exut_nbType.Count - 1
                    ._Tuyau.Item(ntronçon - 1).Exut_nbType.Add(Tuy.Exut_nbType.Item(i)) : ._Tuyau.Item(ntronçon - 1).Exut_Type.Add(Tuy.Exut_Type.Item(i)) : ._Tuyau.Item(ntronçon - 1).Exut_Mat.Add(Tuy.Exut_Mat.Item(i))
                Next
            End If
            ntronçon -= 1
            If ntronçon = 1 Then BtnTrMoins.Hide()
            LblTronçon.Text = ntronçon.ToString
            Call Affichage_Tronçon_NON_Vierge(ntronçon)
        End With
        If ntronçon > 1 Then TxtTrAmont.Focus() Else TxtL.Focus()
        Tuy = Nothing
        lblnbTronçon.Text = "Nombre de tronçons renseignés: " & Reseau._Tuyau.Count
    End Sub
    Private Sub BtnTrPlus_Click(sender As Object, e As EventArgs) Handles BtnTrPlus.Click
        Dim ntronçon As Integer
        Dim Tuy As New Tuyau
        Dim Verif As Boolean = True
        Call Lecture_Reseau_Geom(Tuy, Verif)
        If Verif = False Then Exit Sub
        DgvExut.Rows.Clear()
        ntronçon = CInt(LblTronçon.Text)
        With Reseau
            If ._Tuyau.Count < ntronçon Then
                ._Tuyau.Add(Tuy) 'cet exutoire n'a pas encore été renseigné
                ntronçon += 1
                LblTronçon.Text = ntronçon.ToString
                Call Affichage_Tronçon_Vierge(ntronçon)

            Else
                'remplacement de l'exutoire existant
                ._Tuyau.Item(ntronçon - 1).Hp = Tuy.Hp
                ._Tuyau.Item(ntronçon - 1).L = Tuy.L
                ._Tuyau.Item(ntronçon - 1).Mat = Tuy.Mat
                ._Tuyau.Item(ntronçon - 1).Vlimit = Tuy.Vlimit
                ._Tuyau.Item(ntronçon - 1).Øimposée = Tuy.Øimposée
                If Tuy.Øimposée = True Then
                    ._Tuyau.Item(ntronçon - 1).Nom = Tuy.Nom
                    ._Tuyau.Item(ntronçon - 1).Øimp = Tuy.Øimp
                Else
                    ._Tuyau.Item(ntronçon - 1).Nom = String.Empty
                    ._Tuyau.Item(ntronçon - 1).Øimp = 0
                End If
                ._Tuyau.Item(ntronçon - 1).Qimposée = Tuy.Qimposée
                If Tuy.Qimposée = True Then
                    ._Tuyau.Item(ntronçon - 1).Qimp = Tuy.Qimp
                Else
                    ._Tuyau.Item(ntronçon - 1).Qimp = 0
                End If
                ._Tuyau.Item(ntronçon - 1).Tronçon_Amont.Clear()
                ._Tuyau.Item(ntronçon - 1).Tronçon_Amont = Tuy.Tronçon_Amont
                ._Tuyau.Item(ntronçon - 1).Exut_nbType.Clear() : ._Tuyau.Item(ntronçon - 1).Exut_Type.Clear() : ._Tuyau.Item(ntronçon - 1).Exut_Mat.Clear()
                If RbtnInstal_Indiv_Plusieurs.Checked = True Then
                    For i = 0 To Tuy.Exut_nbType.Count - 1
                        ._Tuyau.Item(ntronçon - 1).Exut_nbType.Add(Tuy.Exut_nbType.Item(i)) : ._Tuyau.Item(ntronçon - 1).Exut_Type.Add(Tuy.Exut_Type.Item(i)) : ._Tuyau.Item(ntronçon - 1).Exut_Mat.Add(Tuy.Exut_Mat.Item(i))
                    Next
                End If
                ntronçon += 1
                LblTronçon.Text = ntronçon.ToString
                If ntronçon > ._Tuyau.Count Then
                    Call Affichage_Tronçon_Vierge(ntronçon)
                Else
                    Call Affichage_Tronçon_NON_Vierge(ntronçon)
                End If


            End If
        End With
        BtnTrMoins.Visible = True
        TxtTrAmont.Focus()
        Tuy = Nothing
        lblnbTronçon.Text = "Nombre de tronçons renseignés: " & Reseau._Tuyau.Count
    End Sub
    Private Sub Lecture_Reseau_Geom(ByRef Tuy As Tuyau, ByRef Verif As Boolean)
        Dim j, j1, k As Integer 'i,
        Dim ntronçon As Integer
        ntronçon = CInt(LblTronçon.Text)
        If ntronçon > 1 Then
            If gestionderreur(TxtTrAmont) = True Then
                Tuy.Tronçon_Amont.Clear()
                Tuy.Tronçon_Amont.Add(CInt(TxtTrAmont.Text))
            Else
                Verif = False
            End If
        End If
        If gestionderreur(TxtL) = True Then Tuy.L = CDbl(TxtL.Text) Else Verif = False
        If gestionderreur(TxtHp) = True Then Tuy.Hp = CDbl(TxtHp.Text) Else Verif = False
        If gestionderreur(TxtPdcLocal) = True Then Tuy.PdcLoc = CDbl(TxtPdcLocal.Text) Else Verif = False
        If CbVlim.SelectedIndex > -1 Then
            Select Case CbVlim.SelectedIndex
                Case 0   '1,5m/s
                    Tuy.Vlimit = 1.5
                Case 1  ' 2m/s
                    Tuy.Vlimit = 2
                Case 2 ' Pas de limite   
                    Tuy.Vlimit = 1000
            End Select
            EP1.SetError(CbVlim, "") ' Clear the error.
        Else
            Verif = False
            MessageBox.Show("Aucun élément n'a été sélectionné comme vitesse.", "Onglet Géométrie Réseau", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            EP1.SetError(CbVlim, "le champ n'a pas été sélectionné!!")
            Exit Sub
        End If
        If CbMatière.SelectedIndex > -1 Then
            Select Case CbMatière.SelectedIndex
                Case 0  'Tube en cuivre 
                    Tuy.Mat = 1
                Case 1  ' Tube en acier galvanisé 
                    Tuy.Mat = 2
                Case 2 ' Tube en PER      
                    Tuy.Mat = 3
                Case 3 ' Tube multicouche     
                    Tuy.Mat = 4
                Case 4 'Tube en PVC-C 
                    Tuy.Mat = 5
            End Select
            EP1.SetError(CbMatière, "") ' Clear the error.
        Else
            Verif = False
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste du matériau composant la tuyauterie.", "Onglet Géométrie Réseau", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            EP1.SetError(CbMatière, "le champ n'a pas été sélectionné!!")
            Exit Sub
        End If
        Tuy.Øimposée = False
        If ChkbDiam_Impose.Checked = True And CbMatière.SelectedIndex > -1 Then
            If CbTuyauterie.SelectedIndex > -1 Then
                Tuy.Øimposée = True
                Select Case CbMatière.SelectedIndex
                    Case 0  'Tube en cuivre 
                        Dim tub As New Cuivre
                        Tuy.Øimp = tub.Øint.Item(CbTuyauterie.SelectedIndex)
                        Tuy.Nom = libel_diametre(Tuy.Øimp, 1)
                    Case 1  ' Tube en acier galvanisé 
                        Dim tub As New AG
                        Tuy.Øimp = tub.Øint.Item(CbTuyauterie.SelectedIndex)
                        Tuy.Nom = libel_diametre(Tuy.Øimp, 2)
                    Case 2 ' Tube en PER      
                        Dim tub As New PER
                        Tuy.Øimp = tub.Øint.Item(CbTuyauterie.SelectedIndex)
                        Tuy.Nom = libel_diametre(Tuy.Øimp, 3)
                    Case 3 ' Tube multicouche     
                        Dim tub As New Multi_Couche
                        Tuy.Øimp = tub.Øint.Item(CbTuyauterie.SelectedIndex)
                        Tuy.Nom = libel_diametre(Tuy.Øimp, 4)
                    Case 4 'Tube en PVC-C 
                        Dim tub As New PVC_C
                        Tuy.Øimp = tub.Øint.Item(CbTuyauterie.SelectedIndex)
                        Tuy.Nom = libel_diametre(Tuy.Øimp, 5)
                End Select
            Else
                Verif = False
                MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des dimensions de tuyauterie.", "Onglet Géométrie Réseau", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                EP1.SetError(CbTuyauterie, "le champ n'a pas été sélectionné!!")
                Exit Sub
            End If
        ElseIf ChkbDiam_Impose.Checked = True And CbMatière.SelectedIndex = -1 Then
            Verif = False
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste du matériau composant la tuyauterie.", "Onglet Géométrie Réseau", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            EP1.SetError(CbMatière, "le champ n'a pas été sélectionné!!")
            Exit Sub

        End If
        Tuy.Qimposée = False
        If ChkbDebit.Checked = True Then
            Tuy.Qimposée = True
            If gestionderreur(TxtDebit) = True Then Tuy.Qimp = (CDbl(TxtDebit.Text) / 1000) Else Verif = False
        End If
        If RbtnInstal_Indiv_Plusieurs.Checked = True Then
            Tuy.Exut_Type.Clear() : Tuy.Exut_nbType.Clear() : Tuy.Exut_Mat.Clear()
            For j = 0 To DgvExut.Rows.Count - 2
                For k = 0 To 2 'colonnes
                    With DgvExut
                        Select Case k
                            Case 0 'type d'exutoire
                                For j1 = 1 To Exutoires.Count
                                    If CStr(.Item(k, j).Value) = "Exutoire n°" & j1.ToString Then Exit For
                                Next
                                Tuy.Exut_Type.Add(j1)
                            Case 1 'nombre d'exutoire
                                Tuy.Exut_nbType.Add(CInt(.Item(k, j).Value))
                            Case 2 ' matière du tuyau d'alimentation - 1 = cuivre/ 2 = Acier galvanisé/ 3 = PER/ 4 = Multicouche/ 5 = PVC-C
                                Tuy.Exut_Mat.Add(1) 'par défaut
                                Select Case CStr(.Item(k, j).Value)
                                    Case "Tube en cuivre"
                                        Tuy.Exut_Mat.Add(1)
                                    Case "Tube en acier galvanisé"
                                        Tuy.Exut_Mat.Add(2)
                                    Case "Tube en PER"
                                        Tuy.Exut_Mat.Add(3)
                                    Case "Tube multicouche"
                                        Tuy.Exut_Mat.Add(4)
                                    Case "Tube en PVC-C"
                                        Tuy.Exut_Mat.Add(5)
                                End Select
                        End Select
                    End With
                Next
            Next
        Else
            If ntronçon > 1 Then 'pas d'exutoire pour le tronçon n°1
                If Reseau._Tuyau.Count >= ntronçon Then
                    With Reseau._Tuyau.Item(ntronçon - 1)
                        If .Exut_nbType.Count >= 1 Then
                            For i = 0 To .Exut_nbType.Count - 1
                                .Exut_nbType.Remove(i) : .Exut_Type.Remove(i) : .Exut_Mat.Remove(i)
                            Next
                        End If
                    End With
                End If
            Else
                Tuy.Exut_Type.Clear() : Tuy.Exut_nbType.Clear() : Tuy.Exut_Mat.Clear()
            End If
        End If

    End Sub
    Private Function libel_diametre(ByVal Diam As Double, ByVal Matiere_Tube As Integer) As String
        Dim i As Integer
        Select Case Matiere_Tube
            Case 1 'Cuivre
                For i = 0 To T_Cu.Øint.Count - 1
                    If Diam <= T_Cu.Øint(i) Then Exit For
                Next
                libel_diametre = T_Cu.Nom(i).ToString
            Case 2 'tube galva
                For i = 0 To T_AG.Øint.Count - 1
                    If Diam <= T_AG.Øint(i) Then Exit For
                Next
                libel_diametre = T_AG.Nom(i).ToString
            Case 3 'PER
                For i = 0 To T_PER.Øint.Count - 1
                    If Diam <= T_PER.Øint(i) Then Exit For
                Next
                libel_diametre = T_PER.Nom(i).ToString
            Case 4 'Multicouche
                For i = 0 To T_MultiC.Øint.Count - 1
                    If Diam <= T_MultiC.Øint(i) Then Exit For
                Next
                libel_diametre = T_MultiC.Nom(i).ToString
            Case 5 'PVC-C
                For i = 0 To T_PVC_C.Øint.Count - 1
                    If Diam <= T_PVC_C.Øint(i) Then Exit For
                Next
                libel_diametre = T_PVC_C.Nom(i).ToString
        End Select
    End Function
    Private Sub DgvExut_CellValidating(sender As Object, e As DataGridViewCellValidatingEventArgs) Handles DgvExut.CellValidating
        'Dim ntronçon, j, k As Integer
        'ntronçon = CInt(LblTronçon.Text)
        'j = CInt(e.RowIndex)
        'k = e.ColumnIndex
        'Me.DgvExut.Rows(e.RowIndex).ErrorText = ""
        ''  LblAvertissement.Visible = False
        'Select Case k
        '    Case 0 'type d'exutoire

        '    Case 1 'nombre d'exutoire
        '        Dim toto As Integer
        '        If DgvExut.ColumnCount <= 2 Then Exit Sub
        '        If Not Integer.TryParse(e.FormattedValue.ToString, toto) OrElse toto <= 0 Then
        '            e.Cancel = True
        '            Me.DgvExut.Rows(e.RowIndex).ErrorText = "La valeur doit être entière et supérieure à 0 !" 'Affichage erreur
        '        End If
        '    Case 2 'matière du tube alimentant l'exutoire


        'End Select

    End Sub
    Private Sub DgvExut_DefaultValuesNeeded(sender As Object, e As DataGridViewRowEventArgs) Handles DgvExut.DefaultValuesNeeded
        'Pré-remplissage de cellules
        With e.Row
            .Cells(1).Value = "1" 'nombre d'exutoire
        End With
    End Sub
    ''' <summary>
    ''' Module servant à supprimer une ligne dans le datagridview
    ''' </summary>
    Private Sub DgvExut_Click(sender As Object, e As EventArgs) Handles DgvExut.DoubleClick
        Dim i, j As Integer
        'supprimer la ligne
        i = CInt(DgvExut.SelectedRows(0).Index) '= n° de ligne
        j = CInt(LblTronçon.Text)
        If Reseau._Tuyau.Count >= j Then 'pour pouvoir supprimer la ligne même si elle n'a pas encore été lue.
            With Reseau._Tuyau.Item(j - 1)
                If .Exut_nbType.Count >= (i + 1) Then
                    .Exut_nbType.Remove(i) : .Exut_Type.Remove(i) : .Exut_Mat.Remove(i)
                End If
            End With
        End If
        'supprimer la ligne
        DgvExut.Rows.RemoveAt(DgvExut.SelectedRows(0).Index)
    End Sub
    Private Sub ChkbDiam_Impose_CheckedChanged(sender As Object, e As EventArgs) Handles ChkbDiam_Impose.CheckedChanged
        If ChkbDiam_Impose.Checked = True Then
            CbTuyauterie.Visible = True
            If CbMatière.SelectedIndex > -1 Then
                EP1.SetError(CbMatière, "") ' Clear the error.
                Try
                    If CbTuyauterie.Items.Count >= 1 Then CbTuyauterie.Items.Clear()
                    Select Case CbMatière.SelectedIndex
                        Case 0  'Tube en cuivre 
                            Dim tub As New Cuivre
                            CbTuyauterie.DataSource = tub.Nom
                        Case 1  ' Tube en acier galvanisé 
                            Dim tub As New AG
                            CbTuyauterie.DataSource = tub.Nom
                        Case 2 ' Tube en PER      
                            Dim tub As New PER
                            CbTuyauterie.DataSource = tub.Nom
                        Case 3 ' Tube multicouche     
                            Dim tub As New Multi_Couche
                            CbTuyauterie.DataSource = tub.Nom
                        Case 4 'Tube en PVC-C 
                            Dim tub As New PVC_C
                            CbTuyauterie.DataSource = tub.Nom
                    End Select
                Catch ex As Exception

                End Try

            Else
                MessageBox.Show("Aucun élément n'a été sélectionné dans la liste du matériau composant la tuyauterie.", "Onglet Géométrie Réseau", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                EP1.SetError(CbMatière, "le champ n'a pas été sélectionné!!")
                Exit Sub
            End If
        Else
            CbTuyauterie.Hide()
        End If
    End Sub
    Private Sub ChkbDebit_CheckedChanged(sender As Object, e As EventArgs) Handles ChkbDebit.CheckedChanged
        If ChkbDebit.Checked = True Then
            TxtDebit.Enabled = True : TxtDebit.Focus()
        Else
            TxtDebit.Text = String.Empty : TxtDebit.Enabled = False
        End If
    End Sub
    Private Sub Affichage_Tronçon_Vierge(ByVal i As Integer)
        If i = 1 Then
            LblRaccord_Tronçon_Amont.Hide() : TxtTrAmont.Hide() : GbReseau_Exutoire.Hide()
            BtnTrMoins.Hide()
        Else
            LblRaccord_Tronçon_Amont.Visible = True : TxtTrAmont.Visible = True : TxtTrAmont.Text = String.Empty
            GbReseau_Exutoire.Visible = True
            If RbtnInstal_Indiv_Aucune.Checked = False Then RbtnInstal_Indiv_Aucune.Checked = True
        End If
        TxtL.Text = String.Empty
        TxtHp.Text = String.Empty
        TxtPdcLocal.Text = String.Empty
        ChkbDiam_Impose.Checked = False
        ChkbDebit.Checked = False
        CbVlim.SelectedIndex = -1
        CbMatière.SelectedIndex = -1
    End Sub
    Private Sub Affichage_Tronçon_NON_Vierge(ByVal i As Integer)
        Call Affichage_Tronçon_Vierge(i)
        i = i - 1 'base 0
        With Reseau
            If i = 0 Then
                LblRaccord_Tronçon_Amont.Hide() : TxtTrAmont.Hide()
            Else
                LblRaccord_Tronçon_Amont.Visible = True
                TxtTrAmont.Visible = True
                If ._Tuyau.Item(i).Tronçon_Amont.Count >= 1 Then TxtTrAmont.Text = ._Tuyau.Item(i).Tronçon_Amont(0).ToString
            End If
            TxtL.Text = ._Tuyau.Item(i).L.ToString("#0.00")
            TxtHp.Text = ._Tuyau.Item(i).Hp.ToString("#0.00")
            TxtPdcLocal.Text = ._Tuyau.Item(i).PdcLoc.ToString("#0.00")
            Select Case ._Tuyau.Item(i).Vlimit
                Case 1.5
                    CbVlim.SelectedIndex = 0
                Case 2
                    CbVlim.SelectedIndex = 1
                Case 1000
                    CbVlim.SelectedIndex = 2
                Case Else 'aucune vitesse sélectionnée
                    CbVlim.SelectedIndex = -1
            End Select
            Select Case ._Tuyau.Item(i).Mat
                Case 1  'Tube en cuivre 
                    CbMatière.SelectedIndex = 0
                Case 2  ' Tube en acier galvanisé 
                    CbMatière.SelectedIndex = 1
                Case 3 ' Tube en PER      
                    CbMatière.SelectedIndex = 2
                Case 4 ' Tube multicouche     
                    CbMatière.SelectedIndex = 3
                Case 5 'Tube en PVC-C 
                    CbMatière.SelectedIndex = 4
            End Select
            If ._Tuyau.Item(i).Øimposée = True Then
                ChkbDiam_Impose.Checked = True
                CbTuyauterie.Text = ._Tuyau.Item(i).Nom.ToString()  '  Cb2App.Text = Cb2App.Items(2).ToString()
            Else
                ChkbDiam_Impose.Checked = False
            End If
            If ._Tuyau.Item(i).Qimposée = True Then
                ChkbDebit.Checked = True
                TxtDebit.Text = (._Tuyau.Item(i).Qimp * 1000).ToString("#0.000")
            Else
                ChkbDebit.Checked = False
            End If
            If i > 0 Then 'pas d'exutoire pour le tronçon n°1
                If Reseau._Tuyau.Count >= (i + 1) Then
                    Dim i1, j As Integer
                    With Reseau._Tuyau.Item(i)
                        If .Exut_nbType.Count >= 1 Then
                            If RbtnInstal_Indiv_Aucune.Checked = True Then
                                RbtnInstal_Indiv_Aucune.Checked = False : RbtnInstal_Indiv_Plusieurs.Checked = True
                                'appel implicite à Handles RbtnInstal_Indiv_Aucune.CheckedChanged (voir ci-dessous)

                            Else
                                ' DgvExut.Visible = True
                                'Dim cbc0 As DataGridViewComboBoxColumn
                                'cbc0 = New DataGridViewComboBoxColumn
                                'cbc0.Name = "cboVar"
                                'cbc0.HeaderText = "Type d'exutoire"
                                'cbc0.Width = 120
                                'cbc0.DisplayMember = "Label"
                                'cbc0.ValueMember = "Self"
                                'DgvExut.Columns.Insert(0, cbc0)
                                DgvExut.Rows.Clear()
                            End If
                            Try
                                DgvExut.Rows.Clear()
                                '    DgvExut.RowCount = .Exut_nbType.Count + 1
                                j = -1
                                For i1 = 1 To .Exut_nbType.Count
                                    j = j + 1
                                    Dim toto, titi As String
                                    toto = "Exutoire n°" & .Exut_Type.Item(j).ToString ' DgvExut.Item(0, j).Value = "Exutoire n°" & .Exut_Type.Item(j).ToString
                                    titi = "Tube en cuivre" 'par défaut
                                    Select Case .Exut_Mat.Item(j)
                                        Case 1 'Tube en cuivre
                                            titi = "Tube en cuivre" '  DgvExut.Item(2, j).Value = "Tube en cuivre"
                                        Case 2
                                            titi = "Tube en acier galvanisé" '  DgvExut.Item(2, j).Value = "Tube en acier galvanisé"
                                        Case 3
                                            titi = "Tube en PER"
                                        Case 4
                                            titi = "Tube multicouche"
                                        Case 5
                                            titi = "Tube en PVC-C"
                                    End Select
                                    DgvExut.Rows.Insert(j, toto, .Exut_nbType.Item(j), titi)
                                Next
                            Catch ex As Exception
                                MessageBox.Show("Erreur lors de l'écriture des données du tableau Exutoire:" & Environment.NewLine & ex.Message, "Module Affichage_Tronçon_NON_Vierge", MessageBoxButtons.OK, MessageBoxIcon.Error)
                            End Try
                        End If
                    End With
                End If

            End If
        End With
        lblnbTronçon.Text = "Nombre de tronçons renseignés: " & Reseau._Tuyau.Count
    End Sub
    Private Sub RbtnInstal_Indiv_Aucune_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnInstal_Indiv_Aucune.CheckedChanged ' RbtnInstal_Indiv_Plusieurs.CheckedChanged ', 
        If RbtnInstal_Indiv_Aucune.Checked = False Then
            Try
                Dim i As Integer
                DgvExut.Visible = True
                Dim cbc0 As DataGridViewComboBoxColumn
                cbc0 = New DataGridViewComboBoxColumn
                cbc0.Name = "cboVar"
                cbc0.HeaderText = "Type d'exutoire"
                cbc0.Width = 120
                For i = 1 To Exutoires.Count
                    cbc0.Items.Add("Exutoire n°" & i.ToString)
                Next
                cbc0.DisplayMember = "Label"
                cbc0.ValueMember = "Self"
                ' DgvExut.Item(0, 0).Value = "Exutoire n°1"
                DgvExut.Columns.Insert(0, cbc0)

            Catch ex As Exception

            End Try


        Else
            DgvExut.Hide()
            If DgvExut.Columns(0).Name = "cboVar" Then DgvExut.Columns.RemoveAt(0)
        End If
    End Sub
    Private Sub BtnSupprTronçon_Click(sender As Object, e As EventArgs) Handles BtnSupprTronçon.Click
        Dim ntype As Integer
        ntype = CInt(LblTronçon.Text)
        If ntype <= Reseau._Tuyau.Count Then
            Reseau._Tuyau.RemoveAt(ntype - 1)
            LblTronçon.Text = (ntype - 1).ToString
            If ntype > 1 Then Call Affichage_Tronçon_NON_Vierge(ntype - 1) Else Call Affichage_Tronçon_NON_Vierge(1)
        Else
            'dernier élément entré et non encore renseigné 
            LblTronçon.Text = (ntype - 1).ToString
            If (ntype - 1) = 1 Then BtnTrMoins.Hide()
            Call Affichage_Tronçon_NON_Vierge(ntype - 1)
        End If

    End Sub
#End Region

#Region "Onglet caractéristiques du réseau"
    Private Sub RbtnPresiduelOui_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnPresiduelOui.CheckedChanged
        If RbtnPresiduelOui.Checked = True Then
            TxtPresiduel.Enabled = True : TxtPresiduel.Focus()
        End If
    End Sub
    Private Sub RbtnPresiduelNon_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnPresiduelNon.CheckedChanged
        If RbtnPresiduelNon.Checked = True Then
            TxtPresiduel.Text = "" : TxtPresiduel.Enabled = False
        End If
    End Sub
    Private Sub RbtnCoefSimultDTU_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnCoefSimultDTU.CheckedChanged
        If RbtnCoefSimultDTU.Checked = True Then
            GbCoefSimultDTU.Enabled = True
        Else
            GbCoefSimultDTU.Enabled = False
        End If
    End Sub
    Private Sub RbtnCoefSimultAutre_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnCoefSimultAutre.CheckedChanged
        If RbtnCoefSimultAutre.Checked = True Then
            GbCoefSimultDTU.Enabled = False
        Else
            GbCoefSimultDTU.Enabled = True
        End If
    End Sub
    Private Sub RbtnCoefHabitation_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnCoefHabitation.CheckedChanged
        If RbtnCoefHabitation.Checked = True Then
            Reseau.Ycoef = 1
            TxtCoefCorrectAutre.Text = "" : TxtCoefCorrectAutre.Enabled = False
        End If
    End Sub
    Private Sub RbtnCoefHotel_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnCoefHotel.CheckedChanged
        If RbtnCoefHotel.Checked = True Then
            Reseau.Ycoef = 1.25
            TxtCoefCorrectAutre.Text = "" : TxtCoefCorrectAutre.Enabled = False
        End If
    End Sub
    Private Sub RbtnCoefEcole_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnCoefEcole.CheckedChanged
        If RbtnCoefEcole.Checked = True Then
            TxtCoefCorrectAutre.Enabled = True : TxtCoefCorrectAutre.Focus()
        End If
    End Sub
    Private Sub Lecture_Car_Reseau(ByRef Verif As Boolean)
        With Reseau
            If RbtnCoefSimultDTU.Checked = True Then
                If RbtnCoefHotel.Checked = True Then .Ycoef = 1.25
                If RbtnCoefHabitation.Checked = True Then .Ycoef = 1
                If RbtnCoefSimultAutre.Checked = True Then
                    If gestionderreur(TxtCoefCorrectAutre) = True Then .Ycoef = CDbl(TxtCoefCorrectAutre.Text) Else Verif = False
                End If
            Else

            End If
            If RbtnPresiduelNon.Checked = True Then .Pr_ES = 10 'mCE
            If RbtnPresiduelOui.Checked = True Then
                If gestionderreur(TxtPresiduel) = True Then .Pr_ES = CDbl(TxtPresiduel.Text) Else Verif = False
            End If
        End With
    End Sub
    Private Sub Affichage_CarReseau()
        With Reseau
            If .Pr_ES = 10 Or .Pr_ES = 3 Then
                RbtnPresiduelNon.Checked = True
            Else
                RbtnPresiduelOui.Checked = True : TxtPresiduel.Text = .Pr_ES.ToString("#0.0")
            End If
            RbtnCoefSimultDTU.Checked = True
            Select Case .Ycoef
                Case 1 'habitation, hôpital
                    RbtnCoefHabitation.Checked = True
                Case 1.25 'hotel
                    RbtnCoefHotel.Checked = True
                Case Else
                    RbtnCoefEcole.Checked = True : TxtCoefCorrectAutre.Text = .Ycoef.ToString("#0.00")
            End Select
        End With
    End Sub
#End Region

#Region "Onglet Pdc commun"
    Private Sub Affichage_PdcCommun()
        With Reseau
            TxtPdcVanne.Text = .PdcVanne.ToString("#0.000") : cbPr1.Text = cbPr1.Items(2).ToString
            TxtCompteur.Text = .PdcCompteur.ToString("#0.000") : CbPr2.Text = CbPr2.Items(2).ToString
            TxtDiscon.Text = .PdcDisconnecteur.ToString("#0.000") : CbPr3.Text = CbPr3.Items(2).ToString
            TxtFiltre.Text = .PdcFiltre.ToString("#0.000") : CbPr4.Text = CbPr4.Items(2).ToString
            TxtPrepECS.Text = .PdcPrepECS.ToString("#0.000") : CbPr5.Text = CbPr5.Items(2).ToString
            TxtReduc.Text = .PdcReduc.ToString("#0.000") : CbPr6.Text = CbPr6.Items(2).ToString
            RbtnPrEntreeConnu.Checked = True
            TxtPrEntree.Text = .PrEntree.ToString("#0.0") : CbPr7.Text = CbPr7.Items(2).ToString
        End With


    End Sub
    Private Sub Lecture_PdcCommun(ByRef Verif As Boolean)
        With Reseau
            If gestionderreur(TxtPdcVanne) = True Then .PdcVanne = CDbl(TxtPdcVanne.Text) : Call gestionPression(cbPr1, .PdcVanne) Else Verif = False
            If gestionderreur(TxtCompteur) = True Then .PdcCompteur = CDbl(TxtCompteur.Text) : Call gestionPression(CbPr2, .PdcCompteur) Else Verif = False
            If gestionderreur(TxtDiscon) = True Then .PdcDisconnecteur = CDbl(TxtDiscon.Text) : Call gestionPression(CbPr3, .PdcDisconnecteur) Else Verif = False
            If gestionderreur(TxtFiltre) = True Then .PdcFiltre = CDbl(TxtFiltre.Text) : Call gestionPression(CbPr4, .PdcFiltre) Else Verif = False
            If .Modele_Calcul = 2 Then 'dimensionnement ECS
                If gestionderreur(TxtPrepECS) = True Then .PdcPrepECS = CDbl(TxtPrepECS.Text) : Call gestionPression(CbPr5, .PdcPrepECS) Else Verif = False
            Else
                .PdcPrepECS = 0
            End If
            If gestionderreur(TxtReduc) = True Then .PdcReduc = CDbl(TxtReduc.Text) : Call gestionPression(CbPr6, .PdcReduc) Else Verif = False
            If RbtnPrEntreeConnu.Checked = True Then
                If gestionderreur(TxtPrEntree) = True Then .PrEntree = CDbl(TxtPrEntree.Text) : Call gestionPression(CbPr7, .PrEntree) Else Verif = False
            Else
                .PrEntree = 30 '3 bars sur le réseau public
            End If
        End With

    End Sub
    Private Sub RbtnPrEntreeInconnu_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnPrEntreeInconnu.CheckedChanged
        If RbtnPrEntreeInconnu.Checked = True Then
            TxtPrEntree.Text = "" : TxtPrEntree.Enabled = False
        End If
    End Sub
    Private Sub RbtnPrEntreeConnu_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnPrEntreeConnu.CheckedChanged
        If RbtnPrEntreeConnu.Checked = True Then
            TxtPrEntree.Enabled = True : TxtPrEntree.Focus()
        End If
    End Sub
    Private Sub gestionPression(ByVal e As System.Windows.Forms.ComboBox, ByRef Var1 As Double)
        Select Case e.SelectedIndex
            Case -1, 0 'en dapa - 1mmH²O = 9.81Pa (DTU 60.11)
                Var1 = Var1 / 981 'conversion en mCE
            Case 1 'en bar
                Var1 = Var1 * 10 'conversion en mCE
            Case 2 'en mCE - pas de modification
            Case 3 'en mmCE
                Var1 = Var1 / 1000 'conversion en mCE
        End Select
    End Sub
#End Region
    Private Function gestionderreur(ByVal e As System.Windows.Forms.TextBox) As Boolean
        If e.Text = "" Then
            EP1.SetError(e, "le champ n'a pas été renseigné!!")
            gestionderreur = False
        ElseIf Not IsNumeric(CDbl(e.Text)) Then
            EP1.SetError(e, "le champ n'est pas une valeur numérique !!")
            gestionderreur = False
        Else
            EP1.SetError(e, "") ' Clear the error.
            gestionderreur = True
        End If
    End Function

    Private Sub BtnSauvegarde_Click(sender As Object, e As EventArgs) Handles BtnSauvegarde.Click

        Dim Verif As Boolean = True

        Try
            With SaveFileDialog1
                .Title = "Enregistrer le projet sous ..."
                ' Si l'utilisateur ne spécifie pas d'extension et si la propriété AddExtension a la valeur True, utilise cette extension. La valeur par défaut est "".
                .DefaultExt = "txt"
                ' Ajoute l'extension par défaut si l'utilisateur a omis de la spécifier.
                ' La valeur par défaut est True.
                .AddExtension = True
                ' Vérifie si le chemin de sortie existe. Demande avant de créer un fichier ? Demande avant de remplacer le fichier ? 
                ' La valeur par défaut est True.
                .CheckPathExists = True
                ' La valeur par défaut est False.
                .CreatePrompt = False
                ' La valeur par défaut est True.
                .OverwritePrompt = True
                ' La valeur par défaut est True.
                .ValidateNames = True
                ' La valeur par défaut est False.
                .ShowHelp = True
                .InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
                .Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
                .FilterIndex = 1
                .RestoreDirectory = True
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    If .FileName <> "" Then
                        Call Lecture_Onglet_Exutoire(Verif)
                        If Verif = False Then
                            MessageBox.Show("Erreur lors de la lecture des données dans l'onglet Exutoires", "Module EFS - ECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                            Exit Sub
                        End If
                        Call Lecture_Onglet_Reseau(Verif)
                        If Verif = False Then
                            MessageBox.Show("Erreur lors de la lecture des données dans l'onglet Reseau", "Module EFS - ECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                            Exit Sub
                        End If
                        Lecture_Car_Reseau(Verif)
                        If Verif = False Then
                            MessageBox.Show("Erreur lors de la lecture des données dans l'onglet Pertes de charges communes", "Module EFS - ECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                            Exit Sub
                        End If
                        Lecture_PdcCommun(Verif)
                        If Verif = False Then
                            MessageBox.Show("Erreur lors de la lecture des données dans l'onglet Pertes de charges communes", "Module EFS - ECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                            Exit Sub
                        End If
                        'Provisoire
                        With Reseau
                            ._Tuyau.Item(0).Exut_nbType.Clear() : ._Tuyau.Item(0).Exut_Type.Clear() : ._Tuyau.Item(0).Exut_Mat.Clear()
                        End With
                        Aff.FileName = .FileName
                        Call SerializeData(1) '1 indique que la serialisation concerne un réseau d'eau froide ou d'eau chaude
                    End If
                End If
            End With
            SaveFileDialog1.Dispose() 'pour libérer la mémoire
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la sauvegarde: " + Environment.NewLine + ex.Message & ex.StackTrace, "Module EFS - ECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub Lecture_Onglet_Exutoire(ByRef Verif As Boolean)
        Dim ntype As Integer
        Dim Exut As New Exutoire
        Call Lecture_Exutoire(Exut, Verif)
        If Verif = False Then Exit Sub
        ntype = CInt(LblExut.Text)
        If Exutoires.Count < ntype Then
            Exutoires.Add(Exut) 'cet exutoire n'a pas encore été renseigné
        Else
            'remplacement de l'exutoire existant
            Exutoires.Item(ntype - 1)._Baignoire_Nb = Exut._Baignoire_Nb
            Exutoires.Item(ntype - 1)._Bidet_nb = Exut._Bidet_nb
            Exutoires.Item(ntype - 1)._douche_nb = Exut._douche_nb
            Exutoires.Item(ntype - 1)._Evier_nb = Exut._Evier_nb
            Exutoires.Item(ntype - 1)._lavabo_nb = Exut._lavabo_nb
            Exutoires.Item(ntype - 1)._Lave_Linge_nb = Exut._Lave_Linge_nb
            Exutoires.Item(ntype - 1)._lavemain_nb = Exut._lavemain_nb
            Exutoires.Item(ntype - 1)._Lave_vaisselle_nb = Exut._Lave_vaisselle_nb
            Exutoires.Item(ntype - 1)._WC_Reservoir_nb = Exut._WC_Reservoir_nb
            Exutoires.Item(ntype - 1)._WC_Reservoir_coll_nb = Exut._WC_Reservoir_coll_nb
            Exutoires.Item(ntype - 1)._Timbre_Office_nb = Exut._Timbre_Office_nb
            Exutoires.Item(ntype - 1)._Bac_a_Laver_nb = Exut._Bac_a_Laver_nb
            Exutoires.Item(ntype - 1)._Urinoir_nb = Exut._Urinoir_nb
            Exutoires.Item(ntype - 1)._Poste_eau_nb = Exut._Poste_eau_nb
            Exutoires.Item(ntype - 1)._lavabo_Coll_nb = Exut._lavabo_Coll_nb
        End If
    End Sub
    Private Sub Lecture_Onglet_Reseau(ByRef Verif As Boolean)
        Dim ntronçon As Integer
        Dim Tuy As New Tuyau
        Call Lecture_Reseau_Geom(Tuy, Verif)
        If Verif = False Then Exit Sub
        ntronçon = CInt(LblTronçon.Text)
        With Reseau
            If ._Tuyau.Count < ntronçon Then
                ._Tuyau.Add(Tuy) 'ce tronçon n'a pas encore été renseigné
            Else
                'remplacement de l'exutoire existant
                ._Tuyau.Item(ntronçon - 1).Hp = Tuy.Hp
                ._Tuyau.Item(ntronçon - 1).L = Tuy.L
                ._Tuyau.Item(ntronçon - 1).Mat = Tuy.Mat
                ._Tuyau.Item(ntronçon - 1).Vlimit = Tuy.Vlimit
                ._Tuyau.Item(ntronçon - 1).Øimposée = Tuy.Øimposée
                ._Tuyau.Item(ntronçon - 1).Nom = Tuy.Nom
                ._Tuyau.Item(ntronçon - 1).Øimp = Tuy.Øimp
                ._Tuyau.Item(ntronçon - 1).Qimposée = Tuy.Qimposée
                ._Tuyau.Item(ntronçon - 1).Qimp = Tuy.Qimp
                ._Tuyau.Item(ntronçon - 1).Tronçon_Amont.Clear()
                ._Tuyau.Item(ntronçon - 1).Tronçon_Amont = Tuy.Tronçon_Amont
            End If

        End With
    End Sub
    Private Sub BtnFichier_Click(sender As Object, e As EventArgs) Handles BtnFichier.Click
        Dim Verif As Boolean = True
        'remise à zero générale
        Reseau = New Installation
        Aff = New clsAffaire
        Exutoires.Clear()
        Call Variables_generales()
        'Appel au nouveau fichier
        Try
            With OpenFileDialog1

                If Aff.msgData <> String.Empty Then
                    .InitialDirectory = Aff.msgData 'pour démarrer toujours sur le bon répertoire
                Else
                    .InitialDirectory = My.Computer.FileSystem.SpecialDirectories.MyDocuments
                End If
                .FileName = "" 'pour éviter tout affichage initial dans la boite de dialogue
                .CheckFileExists = True ' Vérifie que le fichier sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .CheckPathExists = True ' Vérifie que le chemin sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .DefaultExt = "txt" ' Obtient ou définit une extension par défaut. N'inclut pas le "." de début.
                ' Retourne le fichier référencé par un lien ? Si la valeur de retour est False, retourne simplement le fichier de liaison
                ' sélectionné. Si elle est True, retourne le fichier lié au fichier LNK.
                .DereferenceLinks = True
                .Title = "Ouvrir le projet"
                ' .InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
                .FilterIndex = 1
                .Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
                .Multiselect = False
                .RestoreDirectory = True
                .ShowHelp = True ' Affiche le bouton Aide et la case à cocher Lecture seule ?
                .ShowReadOnly = False
                ' Commence avec la case à cocher Lecture seule activée ? Ceci n'est justifié que si ShowReadOnly a la valeur True.
                .ReadOnlyChecked = False
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    If .FileName <> "" Then
                        Aff.FileName = OpenFileDialog1.FileName
                        Dim toto As String = Aff.FileName
                        Dim Racine As String = String.Empty
                        Call Lecture_chaine(toto, Racine)
                        Call DeSerializeData(1, Racine, Verif)
                        If Verif = True Then
                            'la deserialization est OK
                            Select Case Reseau.Modele_Calcul
                                Case 1 'dimensionnement réseau Eau Froide sanitaire
                                    Me.Text = "Dimensionnement réseau eau froide sanitaire : " & toto
                                Case 2 'dimensionnement Eau chaude sanitaire
                                    Me.Text = "Dimensionnement réseau eau chaude sanitaire : " & toto
                            End Select
                            'Affichage Onglet Exutoire
                            Tc1.SelectTab(0)
                            Call Affichage_Exutoire_NON_vierge(1)

                        End If
                    End If
                End If
            End With
            OpenFileDialog1.Dispose() 'pour libérer la mémoire
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du fichier: " + Environment.NewLine + ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Asterisk, MessageBoxDefaultButton.Button1)
        End Try

    End Sub
    Private Sub Lecture_chaine(ByRef toto As String, ByRef Racine As String)
        'Traitement de la chaine de caractère pour pouvoir être lu par le logiciel
        Try
            Dim i, i1, position As Integer
            Dim tutu As String = String.Empty
            toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
            i = Len(toto)     'indique la longueur totale de la chaine
            i1 = i
            position = InStrRev(toto, "\")
            i = i - position
            tutu = toto
            i1 = i1 - i
            toto = Microsoft.VisualBasic.Right(toto, i)
            Racine = Microsoft.VisualBasic.Left(tutu, i1)
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du la chaine " & toto.ToString & Environment.NewLine + ex.Message & ex.StackTrace, "Module Lecture_Chaine", MessageBoxButtons.OK, MessageBoxIcon.Asterisk, MessageBoxDefaultButton.Button1)
        End Try

    End Sub
    Private Sub BtnCalcul_Click(sender As Object, e As EventArgs) Handles BtnCalcul.Click
        Dim Verif As Boolean = True
        Try
            'Pour lecture d'une ultime modification
            Select Case Tc1.SelectedIndex
                Case 0
                    Call Lecture_Onglet_Exutoire(Verif)
                    If Verif = False Then
                        MessageBox.Show("Erreur lors de la lecture des données dans l'onglet Exutoires", "Module EFS - ECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        Exit Sub
                    End If
                Case 1
                    Call Lecture_Onglet_Reseau(Verif)
                    If Verif = False Then
                        MessageBox.Show("Erreur lors de la lecture des données dans l'onglet Reseau", "Module EFS - ECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        Exit Sub
                    End If
                Case 2
                    Lecture_Car_Reseau(Verif)
                    If Verif = False Then
                        MessageBox.Show("Erreur lors de la lecture des données dans l'onglet Cractéristiques du réseau", "Module EFS - ECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        Exit Sub
                    End If
                Case 3
                    Lecture_PdcCommun(Verif)
                    If Verif = False Then
                        MessageBox.Show("Erreur lors de la lecture des données dans l'onglet Pertes de charges communes", "Module EFS - ECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        Exit Sub
                    End If
            End Select
            With Reseau
                ._Tuyau.Item(0).Exut_nbType.Clear() : ._Tuyau.Item(0).Exut_Type.Clear() : ._Tuyau.Item(0).Exut_Mat.Clear()
            End With

            'Vérification de la cohérence géométrique du réseau renseigné
            'Call Verification_Coherence_Geometrique(Verif)
            'If Verif = False Then
            '    MessageBox.Show("Incohérence dans la géométrie du réseau renseigné", "Module EFS - ECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            '    Exit Sub
            'End If
            Fichier_NotedeCalcul = String.Empty
            Call Plomberie_EF(Verif, Fichier_NotedeCalcul)
            If Verif = True Then
                ' Call Affichage_Resultat(Total_Comb, Type_Comb, Result)PthBcl ,PthCol,
                Beep() 'signale la fin des calculs
                MessageBox.Show("calcul terminé", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Information)
                ' Me.Tc1.SelectTab(3) 'Affichage de la page de résultats
            End If
        Catch ex As Exception
            MessageBox.Show("Erreur: " + Environment.NewLine + ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub
    Private Sub Verification_Coherence_Geometrique(ByRef Verif As Boolean)
        Reseau.Initialisation_Distribution()
        'Call Definition_Tronçon_Aval()
        'Call Tête_de_colonne()
        'Call affectation_tronçon_colonne()
        'Call affectation_tronçon_collecteur()
    End Sub
    Private Sub BtnEdit_Click(sender As Object, e As EventArgs) Handles BtnEdit.Click
        Try
            Select Case Aff.Editeur
                Case 1 'Editeur Interne
                    Dim frm1 As New Editeur.frmEdit
                    frm1.Affichage_frmEdit(Fichier_NotedeCalcul)
                Case 2 'éditeur WordPad
                    Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'répertoire dans lequel se trouve le logiciel Poutre BA
                    Dim startInfo As New ProcessStartInfo("wordpad.exe") '("word.exe")
                    startInfo.WindowStyle = ProcessWindowStyle.Normal
                    startInfo.Arguments = Fichier_NotedeCalcul
                    Process.Start(startInfo.Arguments)
                Case 3 'éditeur Word
                    Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'répertoire dans lequel se trouve le logiciel Poutre BA
                    Dim startInfo As New ProcessStartInfo("word.exe") '("word.exe")
                    startInfo.WindowStyle = ProcessWindowStyle.Normal
                    startInfo.Arguments = Fichier_NotedeCalcul
                    Process.Start(startInfo.Arguments)
            End Select
        Catch ex As Exception
            Dim msg As String
            msg = "Impossible d'afficher la note de calcul" & Environment.NewLine + "Exception: " + ex.Message & ex.StackTrace
            MessageBox.Show(msg, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub frmReseau_EF_ECS_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Select Case Reseau.Modele_Calcul
            Case 1 'dimensionnement réseau Eau Froide sanitaire
                Me.Text = "Dimensionnement réseau eau froide sanitaire : [aucun fichier chargé ]"
            Case 2 'dimensionnement Eau chaude sanitaire
                Me.Text = "Dimensionnement réseau eau chaude sanitaire : [aucun fichier chargé ]"
        End Select
        'onglet Exutoire
        BtnExutMoins.Hide()
        GbExutMat.Enabled = False 'provisoire
        Call Affichage_Exutoire_vierge()
        'Onglet géométrie réseau
        RbtnInstal_Indiv_Aucune.Checked = True
        Call Affichage_Tronçon_Vierge(1)
        'Onglet caractéristiques du réseau
        Call Affichage_CarReseau()
        'Onglet Pdc commun
        Call Affichage_PdcCommun()
    End Sub
    Private Sub frmReseau_EF_ECS_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        '  frmMenu.Visible = True
    End Sub

#Region "Fichiers d'aide"
    Private Sub BtnHlpOnglet_Exutoire_Click(sender As Object, e As EventArgs) Handles BtnHlpOnglet_Exutoire.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 14
        frm1.Show()
    End Sub
#Region "Onglet Géométrie Réseau"
    Private Sub BtnHlpLongDevelop_Click(sender As Object, e As EventArgs) Handles BtnHlpLongDevelop.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 19
        frm1.Show()
    End Sub
    Private Sub BtnHlpHp_Click(sender As Object, e As EventArgs) Handles BtnHlpHp.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 20
        frm1.Show()
    End Sub
    Private Sub BtnHlpVlimit_Click(sender As Object, e As EventArgs) Handles BtnHlpVlimit.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 15
        frm1.Show()
    End Sub
    Private Sub BtnHlpTuyauterie_Click(sender As Object, e As EventArgs) Handles BtnHlpTuyauterie.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 16
        frm1.Show()
    End Sub
    Private Sub BtnHlpDiamImpose_Click(sender As Object, e As EventArgs) Handles BtnHlpDiamImpose.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 17
        frm1.Show()
    End Sub
    Private Sub BtnHlpDebitImpose_Click(sender As Object, e As EventArgs) Handles BtnHlpDebitImpose.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 18
        frm1.Show()
    End Sub

#End Region

    Private Sub BtnHlpdtu1988CoefCorrecteur_Click(sender As Object, e As EventArgs) Handles BtnHlpdtu1988CoefCorrecteur.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 9
        frm1.Show()
    End Sub
    Private Sub BtnHlpPdcECEF_Click(sender As Object, e As EventArgs) Handles BtnHlpPdcECEF.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 1
        frm1.Show()
    End Sub
#End Region




End Class