﻿Imports System.IO
Public Class frmEcs_Boucle
    Private Fichier_NotedeCalcul As String = String.Empty

#Region "Onglet Reseau Distribution"
    Private Sub BtnTrMoins_Click(sender As Object, e As EventArgs) Handles BtnTrMoins.Click
        Dim ntronçon As Integer
        Dim Tuy As New Tuyau
        Dim Verif As Boolean = True
        Call Lecture_Reseau_Distrib(Tuy, Verif)
        If Verif = False Then Exit Sub
        ntronçon = CInt(LblTronçon.Text)
        With Reseau
            If ._Tuyau.Count < ntronçon Then
                ._Tuyau.Add(Tuy) 'cet exutoire n'a pas encore été renseigné
            Else
                'remplacement de l'exutoire existant
                ._Tuyau.Item(ntronçon - 1).L = Tuy.L
                ._Tuyau.Item(ntronçon - 1).PdcLoc = Tuy.PdcLoc
                ._Tuyau.Item(ntronçon - 1).Mat = Tuy.Mat
                ._Tuyau.Item(ntronçon - 1).Øimp = Tuy.Øimp
                ._Tuyau.Item(ntronçon - 1).Øint = Tuy.Øint
                ._Tuyau.Item(ntronçon - 1).Nom = Tuy.Nom
                ._Tuyau.Item(ntronçon - 1).Tronçon_Amont.Clear()
                ._Tuyau.Item(ntronçon - 1).Tronçon_Amont = Tuy.Tronçon_Amont
                ._Tuyau.Item(ntronçon - 1).Isol_ep = Tuy.Isol_ep
                ._Tuyau.Item(ntronçon - 1).Isol_λ = Tuy.Isol_λ
                ._Tuyau.Item(ntronçon - 1).Isol_T = Tuy.Isol_T
                ._Tuyau.Item(ntronçon - 1).Pth = Tuy.Pth
            End If
            ntronçon -= 1
            If ntronçon = 1 Then BtnTrMoins.Hide()
            LblTronçon.Text = ntronçon.ToString
            Call Affichage_Tronçon_NON_Vierge(ntronçon)
        End With
        If ntronçon > 1 Then TxtTrAmont.Focus() Else TxtL.Focus()
        Tuy = Nothing
        lblNbTronçon.Text = "Nombre de tronçons: " & Reseau._Tuyau.Count
    End Sub
    Private Sub BtnTrPlus_Click(sender As Object, e As EventArgs) Handles BtnTrPlus.Click
        Dim ntronçon As Integer
        Dim Tuy As New Tuyau
        Dim Verif As Boolean = True
        Call Lecture_Reseau_Distrib(Tuy, Verif)
        If Verif = False Then Exit Sub
        ntronçon = CInt(LblTronçon.Text)
        With Reseau
            If ._Tuyau.Count < ntronçon Then
                ._Tuyau.Add(Tuy) 'cet exutoire n'a pas encore été renseigné
                ntronçon += 1
                LblTronçon.Text = ntronçon.ToString
                Call Affichage_Tronçon_Vierge(ntronçon)

            Else
                'remplacement de l'exutoire existant
                ._Tuyau.Item(ntronçon - 1).L = Tuy.L
                ._Tuyau.Item(ntronçon - 1).PdcLoc = Tuy.PdcLoc
                ._Tuyau.Item(ntronçon - 1).Mat = Tuy.Mat
                ._Tuyau.Item(ntronçon - 1).Øimp = Tuy.Øimp
                ._Tuyau.Item(ntronçon - 1).Øint = Tuy.Øint
                ._Tuyau.Item(ntronçon - 1).Nom = Tuy.Nom
                ._Tuyau.Item(ntronçon - 1).Tronçon_Amont.Clear()
                ._Tuyau.Item(ntronçon - 1).Tronçon_Amont = Tuy.Tronçon_Amont
                ._Tuyau.Item(ntronçon - 1).Isol_ep = Tuy.Isol_ep
                ._Tuyau.Item(ntronçon - 1).Isol_λ = Tuy.Isol_λ
                ._Tuyau.Item(ntronçon - 1).Isol_T = Tuy.Isol_T
                ._Tuyau.Item(ntronçon - 1).Pth = Tuy.Pth
                ntronçon += 1
                LblTronçon.Text = ntronçon.ToString
                If ntronçon > ._Tuyau.Count Then
                    Call Affichage_Tronçon_Vierge(ntronçon)
                Else
                    Call Affichage_Tronçon_NON_Vierge(ntronçon)
                End If


            End If
        End With
        BtnTrMoins.Visible = True
        TxtTrAmont.Focus()
        Tuy = Nothing
        lblNbTronçon.Text = "Nombre de tronçons: " & Reseau._Tuyau.Count
    End Sub
    Private Sub Lecture_Reseau_Distrib(ByRef Tuy As Tuyau, ByRef Verif As Boolean)
        Dim ntronçon As Integer
        ntronçon = CInt(LblTronçon.Text)
        If ntronçon > 1 Then
            If gestionderreur(TxtTrAmont) = True Then
                Tuy.Tronçon_Amont.Clear()
                Tuy.Tronçon_Amont.Add(CInt(TxtTrAmont.Text))
            Else
                Verif = False
            End If
        End If
        If gestionderreur(TxtL) = True Then Tuy.L = CDbl(TxtL.Text) Else Verif = False
        If gestionderreur(TxtPdcLocal) = True Then Tuy.PdcLoc = CDbl(TxtPdcLocal.Text) Else Verif = False
        If CbMatière.SelectedIndex > -1 Then
            Select Case CbMatière.SelectedIndex
                Case 0  'Tube en cuivre 
                    Tuy.Mat = 1
                Case 1  ' Tube en acier galvanisé 
                    Tuy.Mat = 2
                Case 2 ' Tube en PER      
                    Tuy.Mat = 3
                Case 3 ' Tube multicouche     
                    Tuy.Mat = 4
                Case 4 'Tube en PVC-C 
                    Tuy.Mat = 5
            End Select
            EP1.SetError(CbMatière, "") ' Clear the error.
        Else
            Verif = False
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste du matériau composant la tuyauterie.", "Onglet Géométrie Réseau", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            EP1.SetError(CbMatière, "le champ n'a pas été sélectionné!!")
            Exit Sub
        End If
        If CbMatière.SelectedIndex > -1 Then
            If CbTuyauterie.SelectedIndex > -1 Then
                Select Case CbMatière.SelectedIndex
                    Case 0  'Tube en cuivre 
                        Dim tub As New Cuivre
                        Tuy.Øimp = tub.Øint.Item(CbTuyauterie.SelectedIndex) : Tuy.Nom = tub.Nom.Item(CbTuyauterie.SelectedIndex)
                    Case 1  ' Tube en acier galvanisé 
                        Dim tub As New AG
                        Tuy.Øimp = tub.Øint.Item(CbTuyauterie.SelectedIndex) : Tuy.Nom = tub.Nom.Item(CbTuyauterie.SelectedIndex)
                    Case 2 ' Tube en PER      
                        Dim tub As New PER
                        Tuy.Øimp = tub.Øint.Item(CbTuyauterie.SelectedIndex) : Tuy.Nom = tub.Nom.Item(CbTuyauterie.SelectedIndex)
                    Case 3 ' Tube multicouche     
                        Dim tub As New Multi_Couche
                        Tuy.Øimp = tub.Øint.Item(CbTuyauterie.SelectedIndex) : Tuy.Nom = tub.Nom.Item(CbTuyauterie.SelectedIndex)
                    Case 4 'Tube en PVC-C 
                        Dim tub As New PVC_C
                        Tuy.Øimp = tub.Øint.Item(CbTuyauterie.SelectedIndex) : Tuy.Nom = tub.Nom.Item(CbTuyauterie.SelectedIndex)
                End Select
                Tuy.Øint = Tuy.Øimp
            Else
                Verif = False
                MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des dimensions de tuyauterie.", "Onglet Géométrie Réseau", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                EP1.SetError(CbTuyauterie, "le champ n'a pas été sélectionné!!")
                Exit Sub
            End If
        Else
            Verif = False
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste du matériau composant la tuyauterie.", "Onglet Géométrie Réseau", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            EP1.SetError(CbMatière, "le champ n'a pas été sélectionné!!")
            Exit Sub
        End If
        If RbtnPthDirectRes.Checked = True Then
            If gestionderreur(TxtPth) = True Then Tuy.Pth = CDbl(TxtPth.Text) Else Verif = False
        ElseIf RbtnPthCalculRes.Checked = True Then
            If gestionderreur(Txtep) = True Then Tuy.Isol_ep = (CDbl(Txtep.Text) / 1000) Else Verif = False
            If gestionderreur(TxtLambda) = True Then Tuy.Isol_λ = CDbl(TxtLambda.Text) Else Verif = False
            If gestionderreur(TxtdT) = True Then Tuy.Isol_T = CDbl(TxtdT.Text) Else Verif = False
        Else
            Verif = False
            MessageBox.Show("Le mode de calcul de la perte thermique du tronçon n'a pas été sélectionné.", "Onglet Géométrie Réseau", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If
    End Sub
    Private Sub Affichage_Tronçon_Vierge(ByVal i As Integer)
        If i = 1 Then
            LblRaccord_Tronçon_Amont.Hide() : TxtTrAmont.Hide() : BtnTrMoins.Hide()
        Else
            LblRaccord_Tronçon_Amont.Visible = True : TxtTrAmont.Visible = True : TxtTrAmont.Text = String.Empty
        End If
        TxtL.Text = String.Empty
        TxtPdcLocal.Text = String.Empty
        CbMatière.SelectedIndex = -1 : CbTuyauterie.SelectedIndex = -1
        RbtnPthCalculRes.Checked = False : RbtnPthDirectRes.Checked = False
    End Sub
    Private Sub Affichage_Tronçon_NON_Vierge(ByVal i As Integer)
        Call Affichage_Tronçon_Vierge(i)
        i = i - 1 'base 0
        With Reseau
            If i = 0 Then
                LblRaccord_Tronçon_Amont.Hide() : TxtTrAmont.Hide()
            Else
                LblRaccord_Tronçon_Amont.Visible = True
                TxtTrAmont.Visible = True : TxtTrAmont.Text = ._Tuyau.Item(i).Tronçon_Amont(0).ToString
            End If
            TxtL.Text = ._Tuyau.Item(i).L.ToString("#0.00")
            TxtPdcLocal.Text = ._Tuyau.Item(i).PdcLoc.ToString("#0.00")
            Select Case ._Tuyau.Item(i).Mat
                Case 1  'Tube en cuivre 
                    CbMatière.SelectedIndex = 0
                Case 2  ' Tube en acier galvanisé 
                    CbMatière.SelectedIndex = 1
                Case 3 ' Tube en PER      
                    CbMatière.SelectedIndex = 2
                Case 4 ' Tube multicouche     
                    CbMatière.SelectedIndex = 3
                Case 5 'Tube en PVC-C 
                    CbMatière.SelectedIndex = 4
            End Select
            'affichage de la nomenclature du tuyau
            CbTuyauterie.Text = ._Tuyau.Item(i).Nom.ToString()  '  Cb2App.Text = Cb2App.Items(2).ToString()
            If ._Tuyau.Item(i).Isol_ep > 0.001 Then
                RbtnPthCalculRes.Checked = True
                Txtep.Text = (._Tuyau.Item(i).Isol_ep * 1000).ToString("#0.0") : TxtLambda.Text = ._Tuyau.Item(i).Isol_λ.ToString("#0.000") : TxtdT.Text = ._Tuyau.Item(i).Isol_T.ToString("#0.0")
            Else
                RbtnPthDirectRes.Checked = True
                TxtPth.Text = ._Tuyau.Item(i).Pth.ToString("#0.00")
            End If
        End With
        lblNbTronçon.Text = "Nombre de tronçons: " & Reseau._Tuyau.Count
    End Sub
    Private Sub RbtnPthDirectRes_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnPthDirectRes.CheckedChanged
        If RbtnPthDirectRes.Checked = True Then
            TxtPth.Enabled = True : TxtPth.Focus()
            Txtep.Enabled = False : Txtep.Text = String.Empty : TxtLambda.Enabled = False : TxtLambda.Text = String.Empty : TxtdT.Enabled = False : TxtdT.Text = String.Empty
        End If
    End Sub
    Private Sub RbtnPthCalculRes_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnPthCalculRes.CheckedChanged
        If RbtnPthCalculRes.Checked = True Then
            TxtPth.Text = String.Empty : TxtPth.Enabled = False
            Txtep.Enabled = True : TxtLambda.Enabled = True : TxtdT.Enabled = True
            Txtep.Focus()
        End If
    End Sub
    Private Sub CbMatière_SelectedIndexChanged(sender As Object, e As EventArgs) Handles CbMatière.SelectedIndexChanged
        If CbMatière.SelectedIndex > -1 Then
            EP1.SetError(CbMatière, "") ' Clear the error.
            '  If CbTuyauterie.Items.Count >= 1 Then CbTuyauterie.Items.Clear()
            Select Case CbMatière.SelectedIndex
                Case 0  'Tube en cuivre 
                    Dim tub As New Cuivre
                    CbTuyauterie.DataSource = tub.Nom
                Case 1  ' Tube en acier galvanisé 
                    Dim tub As New AG
                    CbTuyauterie.DataSource = tub.Nom
                Case 2 ' Tube en PER      
                    Dim tub As New PER
                    CbTuyauterie.DataSource = tub.Nom
                Case 3 ' Tube multicouche     
                    Dim tub As New Multi_Couche
                    CbTuyauterie.DataSource = tub.Nom
                Case 4 'Tube en PVC-C 
                    Dim tub As New PVC_C
                    CbTuyauterie.DataSource = tub.Nom
            End Select
        Else
            'MessageBox.Show("Aucun élément n'a été sélectionné dans la liste du matériau composant la tuyauterie.", "Onglet Géométrie Réseau", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            'EP1.SetError(CbMatière, "le champ n'a pas été sélectionné!!")
            'Exit Sub
        End If

    End Sub
    Private Sub BtnAppelFichierECS_Click(sender As Object, e As EventArgs) Handles BtnAppelFichierECS.Click
        Dim Verif As Boolean = True
        'remise à zero générale
        Reseau = New Installation
        Aff = New clsAffaire
        Exutoires.Clear()
        Call Variables_generales()
        'Appel au nouveau fichier
        Try
            With OpenFileDialog1
                'pour démarrer toujours sur le bon répertoire
                .InitialDirectory = Aff.msgData
                'pour éviter tout affichage initial dans la boite de dialogue
                .FileName = ""
                ' Vérifie que le fichier sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .CheckFileExists = True
                ' Vérifie que le chemin sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .CheckPathExists = True
                ' Obtient ou définit une extension par défaut. N'inclut pas le "." de début.
                .DefaultExt = "txt"
                ' Retourne le fichier référencé par un lien ? Si la valeur de retour est False, retourne simplement le fichier de liaison
                ' sélectionné. Si elle est True, retourne le fichier lié au fichier LNK.
                .DereferenceLinks = True
                .Title = "Ouvrir le projet"
                ' .InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
                .FilterIndex = 1
                .Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
                .Multiselect = False
                .RestoreDirectory = True
                ' Affiche le bouton Aide et la case à cocher Lecture seule ?
                .ShowHelp = True
                .ShowReadOnly = False
                ' Commence avec la case à cocher Lecture seule activée ?
                ' Ceci n'est justifié que si ShowReadOnly a la valeur True.
                .ReadOnlyChecked = False
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    If .FileName <> "" Then
                        Aff.FileName = OpenFileDialog1.FileName
                        Dim toto As String = Aff.FileName
                        Dim Racine As String = String.Empty
                        Call Lecture_chaine(toto, Racine)
                        Call DeSerializeData(1, Racine, Verif)
                        If Verif = True Then
                            'la deserialization est OK
                            LblFichierECS.Text = "Réseau eau chaude sanitaire : " & toto
                            'Affichage Onglet Exutoire
                            Tc1.SelectTab(0)
                            Call Affichage_Tronçon_NON_Vierge(1)

                        End If
                    End If
                End If
            End With
            OpenFileDialog1.Dispose() 'pour libérer la mémoire
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du fichier: " + Environment.NewLine + ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Asterisk, MessageBoxDefaultButton.Button1)
        End Try
    End Sub
    Private Sub BtnSupprTrECS_Click(sender As Object, e As EventArgs) Handles BtnSupprTrECS.Click
        Dim ntype As Integer
        ntype = CInt(LblTronçon.Text)
        If ntype <= Reseau._Tuyau.Count Then
            Reseau._Tuyau.RemoveAt(ntype - 1)
            LblTronçon.Text = (ntype - 1).ToString
            If ntype > 1 Then Call Affichage_Tronçon_NON_Vierge(ntype - 1) Else Call Affichage_Tronçon_NON_Vierge(1)
        Else
            'dernier élément entré et non encore renseigné 
            LblTronçon.Text = (ntype - 1).ToString
            If (ntype - 1) = 1 Then BtnTrMoins.Hide()
            Call Affichage_Tronçon_NON_Vierge(ntype - 1)
        End If
    End Sub
#End Region

    Private Sub Tc1_Enter(sender As Object, e As EventArgs) Handles Tc1.SelectedIndexChanged
        Select Case Tc1.SelectedIndex
            Case 0 '
                If Reseau._Tuyau.Count <> 0 Then
                    LblTronçon.Text = "1"
                    Call Affichage_Tronçon_NON_Vierge(1)
                Else
                    Call Affichage_Tronçon_Vierge(1)
                End If
            Case 1
                If Reseau._TuyauR.Count <> 0 Then
                    LblTronçonR.Text = "1"
                    Affichage_TronçonBcl_NON_Vierge(1)
                Else
                    Call Affichage_TronçonBcl_Vierge(1)
                End If
            Case 2
                Call Affichage_PdcCommun() ' 
            Case 3
                Call Affichage_Crit_Dim() ' 

        End Select
    End Sub
    Private Sub TabControl1_Deselecting(sender As Object, e As TabControlCancelEventArgs) Handles Tc1.Deselecting

        'Dim messageBoxVB As New System.Text.StringBuilder()
        'messageBoxVB.AppendFormat("{0} = {1}", "TabPage", e.TabPage)
        'messageBoxVB.AppendLine()
        'messageBoxVB.AppendFormat("{0} = {1}", "TabPageIndex", e.TabPageIndex)
        'messageBoxVB.AppendLine()
        'messageBoxVB.AppendFormat("{0} = {1}", "Action", e.Action)
        'messageBoxVB.AppendLine()
        'messageBoxVB.AppendFormat("{0} = {1}", "Cancel", e.Cancel)
        'messageBoxVB.AppendLine()
        'MessageBox.Show(messageBoxVB.ToString(), "Deselecting Event")
        Dim Verif As Boolean = True
        Select Case e.TabPageIndex
            Case 0 'A faire avant de quitter l'onglet Géométrie Réseau
                'RAS - aucune influence sur les autres onglets
            Case 1 'A faire avant de quitter l'onglet Géométrie boucle ECS
                'RAS - aucune influence sur les autres onglets
            Case 2 'A faire avant de quitter l'onglet caractéristiques Réseau
                Try
                    Lecture_PdcCommun(Verif)
                    If Verif = False Then
                        Me.Tc1.SelectTab(2)
                        Exit Sub
                    End If
                Catch ex As Exception
                    MessageBox.Show("Erreur: " + Environment.NewLine + ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Me.Tc1.SelectTab(2)
                End Try

            Case 3 'A faire avant de quitter l'onglet Pdc Réseau
                Try
                    Lecture_Crit_Dim(Verif)
                    If Verif = False Then
                        Me.Tc1.SelectTab(3)
                        Exit Sub
                    End If
                Catch ex As Exception
                    MessageBox.Show("Erreur: " + Environment.NewLine + ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Me.Tc1.SelectTab(3)
                End Try

        End Select
    End Sub

#Region "Onglet Reseau retour Boucle"
    Private Sub BtnBclMoins_Click(sender As Object, e As EventArgs) Handles BtnBclMoins.Click
        Dim ntronçon As Integer
        Dim Tuy As New Tuyau
        Dim Verif As Boolean = True
        Call Lecture_Reseau_Collecteur_Boucle(Tuy, Verif)
        If Verif = False Then Exit Sub
        ntronçon = CInt(LblTronçonR.Text)
        With Reseau
            If ._TuyauR.Count < ntronçon Then
                ._TuyauR.Add(Tuy) 'cet exutoire n'a pas encore été renseigné
            Else
                'remplacement de l'exutoire existant
                ._TuyauR.Item(ntronçon - 1).L = Tuy.L
                ._TuyauR.Item(ntronçon - 1).PdcLoc = Tuy.PdcLoc
                ._TuyauR.Item(ntronçon - 1).Mat = Tuy.Mat
                ._TuyauR.Item(ntronçon - 1).Øimp = Tuy.Øimp
                ._TuyauR.Item(ntronçon - 1).Øint = Tuy.Øint
                ._TuyauR.Item(ntronçon - 1).Nom = Tuy.Nom
                ._TuyauR.Item(ntronçon - 1).Tronçon_Aval.Clear()
                ._TuyauR.Item(ntronçon - 1).Tronçon_Aval = Tuy.Tronçon_Aval
                ._TuyauR.Item(ntronçon - 1).Tronçon_Distrib = Tuy.Tronçon_Distrib
                ._TuyauR.Item(ntronçon - 1).Isol_ep = Tuy.Isol_ep
                ._TuyauR.Item(ntronçon - 1).Isol_λ = Tuy.Isol_λ
                ._TuyauR.Item(ntronçon - 1).Isol_T = Tuy.Isol_T
                ._TuyauR.Item(ntronçon - 1).Pth = Tuy.Pth
            End If
            ntronçon -= 1
            If ntronçon = 1 Then BtnBclMoins.Hide()
            LblTronçonR.Text = ntronçon.ToString
            Call Affichage_TronçonBcl_NON_Vierge(ntronçon)
        End With
        Tuy = Nothing
        Lbl_NbTronçonBECS.Text = "Nombre de tronçons: " & Reseau._TuyauR.Count
    End Sub
    Private Sub BtnBclPlus_Click(sender As Object, e As EventArgs) Handles BtnBclPlus.Click
        Dim ntronçon As Integer
        Dim Tuy As New Tuyau
        Dim Verif As Boolean = True
        Call Lecture_Reseau_Collecteur_Boucle(Tuy, Verif)
        If Verif = False Then Exit Sub
        ntronçon = CInt(LblTronçonR.Text)
        With Reseau
            If ._TuyauR.Count < ntronçon Then
                ._TuyauR.Add(Tuy) 'cet exutoire n'a pas encore été renseigné
                ntronçon += 1
                LblTronçonR.Text = ntronçon.ToString
                Call Affichage_TronçonBcl_Vierge(ntronçon)

            Else
                'remplacement de l'exutoire existant
                ._TuyauR.Item(ntronçon - 1).L = Tuy.L
                ._TuyauR.Item(ntronçon - 1).PdcLoc = Tuy.PdcLoc
                ._TuyauR.Item(ntronçon - 1).Mat = Tuy.Mat
                ._TuyauR.Item(ntronçon - 1).Øimp = Tuy.Øimp
                ._TuyauR.Item(ntronçon - 1).Øint = Tuy.Øint
                ._TuyauR.Item(ntronçon - 1).Nom = Tuy.Nom
                ._TuyauR.Item(ntronçon - 1).Tronçon_Aval.Clear()
                ._TuyauR.Item(ntronçon - 1).Tronçon_Aval = Tuy.Tronçon_Aval
                ._TuyauR.Item(ntronçon - 1).Tronçon_Distrib = Tuy.Tronçon_Distrib
                ._TuyauR.Item(ntronçon - 1).Isol_ep = Tuy.Isol_ep
                ._TuyauR.Item(ntronçon - 1).Isol_λ = Tuy.Isol_λ
                ._TuyauR.Item(ntronçon - 1).Isol_T = Tuy.Isol_T
                ._TuyauR.Item(ntronçon - 1).Pth = Tuy.Pth
                ntronçon += 1
                LblTronçonR.Text = ntronçon.ToString
                If ntronçon > ._TuyauR.Count Then
                    Call Affichage_TronçonBcl_Vierge(ntronçon)
                Else
                    Call Affichage_TronçonBcl_NON_Vierge(ntronçon)
                End If
            End If
        End With
        BtnBclMoins.Visible = True
        TxtNumAvalR.Focus()
        Tuy = Nothing
        Lbl_NbTronçonBECS.Text = "Nombre de tronçons: " & Reseau._TuyauR.Count
    End Sub
    Private Sub Lecture_Reseau_Collecteur_Boucle(ByRef Tuy As Tuyau, ByRef Verif As Boolean)
        Dim ntronçon As Integer
        ntronçon = CInt(LblTronçonR.Text)
        If ntronçon > 1 Then
            If gestionderreur(TxtDistrib) = True Then Tuy.Tronçon_Distrib = CInt(TxtDistrib.Text) Else Verif = False
            Tuy.Tronçon_Aval.Clear() 'il ne peut y avair qu'un seul tronçon aval
            If gestionderreur(TxtNumAvalR) = True Then Tuy.Tronçon_Aval.Add(CInt(TxtNumAvalR.Text)) Else Verif = False
        End If

        If gestionderreur(TxtLR) = True Then Tuy.L = CDbl(TxtLR.Text) Else Verif = False
        If gestionderreur(TxtPdcR) = True Then Tuy.PdcLoc = CDbl(TxtPdcR.Text) Else Verif = False
        If CbMatièreR.SelectedIndex > -1 Then
            Select Case CbMatièreR.SelectedIndex
                Case 0  'Tube en cuivre 
                    Tuy.Mat = 1
                Case 1  ' Tube en acier galvanisé 
                    Tuy.Mat = 2
                Case 2 ' Tube en PER      
                    Tuy.Mat = 3
                Case 3 ' Tube multicouche     
                    Tuy.Mat = 4
                Case 4 'Tube en PVC-C 
                    Tuy.Mat = 5
            End Select
            EP1.SetError(CbMatièreR, "") ' Clear the error.
        Else
            Verif = False
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste du matériau composant la tuyauterie.", "Onglet Réseau Boucle ECS", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            EP1.SetError(CbMatièreR, "le champ n'a pas été sélectionné!!")
            Exit Sub
        End If
        If CbMatièreR.SelectedIndex > -1 Then
            If CbTuyauterieR.SelectedIndex > -1 Then
                Select Case CbMatièreR.SelectedIndex
                    Case 0  'Tube en cuivre 
                        Dim tub As New Cuivre
                        Tuy.Øimp = tub.Øint.Item(CbTuyauterieR.SelectedIndex) : Tuy.Nom = tub.Nom.Item(CbTuyauterieR.SelectedIndex)
                    Case 1  ' Tube en acier galvanisé 
                        Dim tub As New AG
                        Tuy.Øimp = tub.Øint.Item(CbTuyauterieR.SelectedIndex) : Tuy.Nom = tub.Nom.Item(CbTuyauterieR.SelectedIndex)
                    Case 2 ' Tube en PER      
                        Dim tub As New PER
                        Tuy.Øimp = tub.Øint.Item(CbTuyauterieR.SelectedIndex) : Tuy.Nom = tub.Nom.Item(CbTuyauterieR.SelectedIndex)
                    Case 3 ' Tube multicouche     
                        Dim tub As New Multi_Couche
                        Tuy.Øimp = tub.Øint.Item(CbTuyauterieR.SelectedIndex) : Tuy.Nom = tub.Nom.Item(CbTuyauterieR.SelectedIndex)
                    Case 4 'Tube en PVC-C 
                        Dim tub As New PVC_C
                        Tuy.Øimp = tub.Øint.Item(CbTuyauterieR.SelectedIndex) : Tuy.Nom = tub.Nom.Item(CbTuyauterieR.SelectedIndex)
                End Select
                Tuy.Øint = Tuy.Øimp
            Else
                Verif = False
                MessageBox.Show("Aucun élément n'a été sélectionné dans la liste des dimensions de tuyauterie.", "Onglet Réseau Boucle ECS", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                EP1.SetError(CbTuyauterieR, "le champ n'a pas été sélectionné!!")
                Exit Sub
            End If
        Else
            Verif = False
            MessageBox.Show("Aucun élément n'a été sélectionné dans la liste du matériau composant la tuyauterie.", "Onglet Réseau Boucle ECS", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            EP1.SetError(CbMatièreR, "le champ n'a pas été sélectionné!!")
            Exit Sub
        End If
        If RbtnPthDirectResR.Checked = True Then
            If gestionderreur(TxtPthR) = True Then Tuy.Pth = CDbl(TxtPthR.Text) Else Verif = False
        ElseIf RbtnPthCalculResR.Checked = True Then
            If gestionderreur(TxtepR) = True Then Tuy.Isol_ep = (CDbl(TxtepR.Text) / 1000) Else Verif = False
            If gestionderreur(TxtLambdaR) = True Then Tuy.Isol_λ = CDbl(TxtLambdaR.Text) Else Verif = False
            If gestionderreur(TxtdTR) = True Then Tuy.Isol_T = CDbl(TxtdTR.Text) Else Verif = False
        Else
            Verif = False
            MessageBox.Show("Le mode de calcul de la perte thermique du tronçon n'a pas été sélectionné.", "Onglet Réseau Boucle ECS", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End If

    End Sub
    Private Sub Affichage_TronçonBcl_Vierge(ByVal i As Integer)
        If i = 1 Then
            lblTronCollAval.Hide() : TxtNumAvalR.Hide() : BtnBclMoins.Hide()
            LblTronDistrib.Hide() : TxtDistrib.Hide()
        Else
            lblTronCollAval.Visible = True : TxtNumAvalR.Visible = True : TxtNumAvalR.Text = String.Empty : LblTronDistrib.Visible = True : TxtDistrib.Visible = True : TxtDistrib.Text = String.Empty
        End If
        TxtLR.Text = String.Empty
        TxtPdcR.Text = String.Empty
        CbMatièreR.SelectedIndex = -1 : CbTuyauterieR.SelectedIndex = -1
        RbtnPthCalculResR.Checked = False : RbtnPthDirectResR.Checked = False
    End Sub
    Private Sub Affichage_TronçonBcl_NON_Vierge(ByVal i As Integer)
        Call Affichage_TronçonBcl_Vierge(i)
        i = i - 1 'base 0
        With Reseau
            If i = 0 Then
                lblTronCollAval.Hide() : TxtNumAvalR.Hide() : LblTronDistrib.Hide() : TxtDistrib.Hide()
            Else
                lblTronCollAval.Visible = True : TxtNumAvalR.Visible = True : TxtNumAvalR.Text = ._TuyauR.Item(i).Tronçon_Aval(0).ToString
                LblTronDistrib.Visible = True : TxtDistrib.Visible = True : TxtDistrib.Text = ._TuyauR.Item(i).Tronçon_Distrib.ToString
            End If
            TxtLR.Text = ._TuyauR.Item(i).L.ToString("#0.00")
            TxtPdcR.Text = ._TuyauR.Item(i).PdcLoc.ToString("#0.00")
            Select Case ._TuyauR.Item(i).Mat
                Case 1  'Tube en cuivre 
                    CbMatièreR.SelectedIndex = 0
                Case 2  ' Tube en acier galvanisé 
                    CbMatièreR.SelectedIndex = 1
                Case 3 ' Tube en PER      
                    CbMatièreR.SelectedIndex = 2
                Case 4 ' Tube multicouche     
                    CbMatièreR.SelectedIndex = 3
                Case 5 'Tube en PVC-C 
                    CbMatièreR.SelectedIndex = 4
            End Select
            CbTuyauterieR.Text = ._TuyauR.Item(i).Nom.ToString()  '  Cb2App.Text = Cb2App.Items(2).ToString()
            If ._TuyauR.Item(i).Isol_ep > 0.001 Then
                RbtnPthCalculResR.Checked = True
                TxtepR.Text = (._TuyauR.Item(i).Isol_ep * 1000).ToString("#0.0") : TxtLambdaR.Text = ._TuyauR.Item(i).Isol_λ.ToString("#0.000") : TxtdTR.Text = ._TuyauR.Item(i).Isol_T.ToString("#0.0")
            Else
                RbtnPthDirectResR.Checked = True
                TxtPthR.Text = ._TuyauR.Item(i).Pth.ToString("#0.00")
            End If
        End With
        Lbl_NbTronçonBECS.Text = "Nombre de tronçons: " & Reseau._TuyauR.Count
    End Sub
    Private Sub RbtnPthDirectResR_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnPthDirectResR.CheckedChanged
        If RbtnPthDirectResR.Checked = True Then
            TxtPthR.Enabled = True : TxtPthR.Focus()
            TxtepR.Enabled = False : TxtepR.Text = String.Empty : TxtLambdaR.Enabled = False : TxtLambdaR.Text = String.Empty : TxtdTR.Enabled = False : TxtdTR.Text = String.Empty
        End If
    End Sub
    Private Sub RbtnPthCalculResR_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnPthCalculResR.CheckedChanged
        If RbtnPthCalculResR.Checked = True Then
            TxtPthR.Text = String.Empty : TxtPthR.Enabled = False
            TxtepR.Enabled = True : TxtLambdaR.Enabled = True : TxtdTR.Enabled = True
            TxtepR.Focus()
        End If
    End Sub
    Private Sub CbMatièreR_SelectedIndexChanged(sender As Object, e As EventArgs) Handles CbMatièreR.SelectedIndexChanged
        If CbMatièreR.SelectedIndex > -1 Then
            EP1.SetError(CbMatière, "") ' Clear the error.
            '  If CbTuyauterie.Items.Count >= 1 Then CbTuyauterie.Items.Clear()
            Select Case CbMatièreR.SelectedIndex
                Case 0  'Tube en cuivre 
                    Dim tub As New Cuivre
                    CbTuyauterieR.DataSource = tub.Nom
                Case 1  ' Tube en acier galvanisé 
                    Dim tub As New AG
                    CbTuyauterieR.DataSource = tub.Nom
                Case 2 ' Tube en PER      
                    Dim tub As New PER
                    CbTuyauterieR.DataSource = tub.Nom
                Case 3 ' Tube multicouche     
                    Dim tub As New Multi_Couche
                    CbTuyauterieR.DataSource = tub.Nom
                Case 4 'Tube en PVC-C 
                    Dim tub As New PVC_C
                    CbTuyauterieR.DataSource = tub.Nom
            End Select
        Else
            'MessageBox.Show("Aucun élément n'a été sélectionné dans la liste du matériau composant la tuyauterie.", "Onglet Géométrie Réseau", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            'EP1.SetError(CbMatière, "le champ n'a pas été sélectionné!!")
            'Exit Sub
        End If

    End Sub
    Private Sub BtnSupprTrBECS_Click(sender As Object, e As EventArgs) Handles BtnSupprTrBECS.Click
        Dim ntype As Integer
        ntype = CInt(LblTronçonR.Text)
        If ntype <= Reseau._TuyauR.Count Then
            Reseau._TuyauR.RemoveAt(ntype - 1)
            LblTronçonR.Text = (ntype - 1).ToString
            If ntype > 1 Then Call Affichage_TronçonBcl_NON_Vierge(ntype - 1) Else Call Affichage_TronçonBcl_NON_Vierge(1)
        Else
            'dernier élément entré et non encore renseigné 
            LblTronçonR.Text = (ntype - 1).ToString
            If (ntype - 1) = 1 Then BtnBclMoins.Hide()
            Call Affichage_TronçonBcl_NON_Vierge(ntype - 1)
        End If
    End Sub
#End Region

#Region "Onglet Pdc Communes"
    Private Sub Affichage_PdcCommun()

        With Reseau
            TxtPdcVanne.Text = .PdcVanne.ToString("#0.0")
            TxtPrepECS.Text = .PdcPrepECS.ToString("#0.0")
            TxtClap.Text = .PdcClapet.ToString("#0.0")
            TxtDtECS.Text = .ΔT_ECS.ToString("#0.00")
            TxtHMVC.Text = .HMVC.ToString("#0.000")
            TxtHMVrd.Text = .HMVrd.ToString("#0.000")
            Select Case .Position_Org
                Case 1 'sur toutes les colonnes
                    RbtnRecoCSTB.Checked = True
                Case 2 'uniquement sur colonnes favorisées
                    RbtnOrgColonne.Checked = True
                Case Else
                    RbtnRecoCSTB.Checked = False
                    RbtnOrgColonne.Checked = False
            End Select
        End With
    End Sub
    Private Sub Lecture_PdcCommun(ByRef Verif As Boolean)
        With Reseau
            If gestionderreur(TxtPdcVanne) = True Then .PdcVanne = CDbl(TxtPdcVanne.Text)
            If gestionderreur(TxtPrepECS) = True Then .PdcPrepECS = CDbl(TxtPrepECS.Text)
            If gestionderreur(TxtClap) = True Then .PdcClapet = CDbl(TxtClap.Text)
            If gestionderreur(TxtDtECS) = True Then .ΔT_ECS = CDbl(TxtDtECS.Text) Else Verif = False
            If gestionderreur(TxtHMVC) = True Then .HMVC = CDbl(TxtHMVC.Text) Else Verif = False
            If gestionderreur(TxtHMVrd) = True Then .HMVrd = CDbl(TxtHMVrd.Text) Else Verif = False
            Reseau.Position_Org = 0
            If RbtnRecoCSTB.Checked = True Then Reseau.Position_Org = 1
            If RbtnOrgColonne.Checked = True Then Reseau.Position_Org = 2
        End With
    End Sub
#End Region

#Region "Onglet Critères de dimensionnement"
    Private Sub Affichage_Crit_Dim()
        With Reseau
            TxtTempProd.Text = .TprodECS.ToString("#0.0")
            TxtdTboucle.Text = .dTBoucle.ToString("#0.0")
            If .Type_dT = 2 Then RbtnProdRetour.Checked = True
            If .Type_dT = 1 Then RbtnProdExut.Checked = True
            Select Case .Qbcl_min
                Case 0
                    RbtnDebMinNul.Checked = True
                Case 80 / 3600
                    RbtnDebMinReco.Checked = True
                    CbDebit.SelectedIndex = 0
                Case 120 / 3600
                    RbtnDebMinReco.Checked = True
                    CbDebit.SelectedIndex = 1
                Case Else
                    RbtnDebMinAutre.Checked = True
                    TxtDebMin.Text = (.Qbcl_min * 3600).ToString("#0.00")
            End Select
            Select Case .Vmin
                Case 0
                    RbtnVminNul.Checked = True
                Case 0.2
                    RbtnVminReco.Checked = True
                    CbVitesse.SelectedIndex = 0
                Case Else
                    RbtnVminAutre.Checked = True
                    TxtVmin.Text = .Vmin.ToString("#0.00")
            End Select

            Select Case .Type_Org
                Case 1 'Pas de caractéristique imposée pour les organes de réglage
                    RbtnCarNul.Checked = True
                Case 2
                    RbtnCar.Checked = True
            End Select
        End With
    End Sub
    Private Sub Lecture_Crit_Dim(ByRef Verif As Boolean)
        With Reseau
            If gestionderreur(TxtTempProd) = True Then .TprodECS = CDbl(TxtTempProd.Text)
            If gestionderreur(TxtdTboucle) = True Then .dTBoucle = CDbl(TxtdTboucle.Text)
            If RbtnProdRetour.Checked = True Then .Type_dT = 2
            If RbtnProdExut.Checked = True Then .Type_dT = 1
            If RbtnDebMinNul.Checked = True Then
                .Qbcl_min = 0
            ElseIf RbtnDebMinReco.Checked = True Then
                If CbDebit.SelectedIndex = 0 Then
                    .Qbcl_min = 80 / 3600
                Else
                    .Qbcl_min = 120 / 3600
                End If
            ElseIf RbtnDebMinAutre.Checked = True Then
                If gestionderreur(TxtDebMin) = True Then .Qbcl_min = CDbl(TxtDebMin.Text)

            End If
            If RbtnVminNul.Checked = True Then
                .Vmin = 0
            ElseIf RbtnVminReco.Checked = True Then
                .Vmin = 0.2
            ElseIf RbtnVminAutre.Checked = True Then
                If gestionderreur(TxtVmin) = True Then .Vmin = CDbl(TxtVmin.Text)
            End If
            If RbtnCarNul.Checked = True Then .Type_Org = 1 'Pas de caractéristique imposée pour les organes de réglage
            If RbtnCar.Checked = True Then .Type_Org = 2 ' 
        End With
    End Sub
    Private Sub RbtnDebMinNul_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnDebMinNul.CheckedChanged
        If RbtnDebMinNul.Checked = True Then
            CbDebit.SelectedIndex = -1 : CbDebit.Enabled = False
            TxtDebMin.Text = String.Empty : TxtDebMin.Enabled = False
        End If
    End Sub

    Private Sub RbtnDebMinReco_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnDebMinReco.CheckedChanged
        If RbtnDebMinReco.Checked = True Then
            TxtDebMin.Text = String.Empty : TxtDebMin.Enabled = False
            CbDebit.SelectedIndex = 0 : CbDebit.Enabled = True
        End If
    End Sub

    Private Sub RbtnDebMinAutre_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnDebMinAutre.CheckedChanged
        If RbtnDebMinAutre.Checked = True Then
            CbDebit.SelectedIndex = -1 : CbDebit.Enabled = False
            TxtDebMin.Enabled = True : TxtDebMin.Focus()
        End If
    End Sub

    Private Sub RbtnVminNul_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnVminNul.CheckedChanged
        If RbtnVminNul.Checked = True Then
            CbVitesse.SelectedIndex = -1 : CbVitesse.Enabled = False
            TxtVmin.Text = String.Empty : TxtVmin.Enabled = False
        End If
    End Sub

    Private Sub RbtnVminReco_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnVminReco.CheckedChanged
        If RbtnVminReco.Checked = True Then
            TxtVmin.Text = String.Empty : TxtVmin.Enabled = False
            CbVitesse.SelectedIndex = 0 : CbVitesse.Enabled = True
        End If
    End Sub

    Private Sub RbtnVminAutre_CheckedChanged(sender As Object, e As EventArgs) Handles RbtnVminAutre.CheckedChanged
        If RbtnVminAutre.Checked = True Then
            CbVitesse.SelectedIndex = -1 : CbVitesse.Enabled = False
            TxtVmin.Enabled = True : TxtVmin.Focus()
        End If
    End Sub
#End Region

    Private Function gestionderreur(ByVal e As System.Windows.Forms.TextBox) As Boolean
        If e.Text = "" Then
            EP1.SetError(e, "le champ n'a pas été renseigné!!")
            gestionderreur = False
        End If
        Dim u As Double
        Try
            u = CDbl(e.Text)
        Catch ex As Exception
            EP1.SetError(e, "le champ n'est pas une valeur numérique !!")
            gestionderreur = False
            Exit Function
        End Try
        If Not IsNumeric(u) Then
            EP1.SetError(e, "le champ n'est pas une valeur numérique !!")
            gestionderreur = False
        Else
            EP1.SetError(e, "") ' Clear the error.
            gestionderreur = True
        End If
    End Function

    Private Sub BtnCalcul_Click(sender As Object, e As EventArgs) Handles BtnCalcul.Click
        Dim Verif As Boolean = True
        Try
            'Pour lecture d'une ultime modification
            Select Case Tc1.SelectedIndex
                Case 0
                    Call Lecture_Onglet_Reseau_Distrib(Verif)
                    If Verif = False Then
                        MessageBox.Show("Erreur lors de la lecture des données dans l'onglet Exutoires", "Module EFS - ECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        Exit Sub
                    End If
                Case 1
                    Call Lecture_Onglet_Reseau_Boucle_ECS(Verif)
                    If Verif = False Then
                        MessageBox.Show("Erreur lors de la lecture des données dans l'onglet Reseau", "Module EFS - ECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        Exit Sub
                    End If
                Case 2
                    Call Lecture_PdcCommun(Verif)
                    If Verif = False Then
                        MessageBox.Show("Erreur lors de la lecture des données dans l'onglet Pertes de charges communes", "Module EFS - ECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        Exit Sub
                    End If
                Case 3
                    Call Lecture_Crit_Dim(Verif)
                    If Verif = False Then
                        MessageBox.Show("Erreur lors de la lecture des données dans l'onglet Critères de dimensionnement", "Module EFS - ECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                        Exit Sub
                    End If
            End Select
            'Vérification de la cohérence géométrique du réseau renseigné
            Call Verification_Coherence_Geometrique(Verif) : If Verif = False Then Exit Sub
            Fichier_NotedeCalcul = String.Empty
            Call Calcul_Boucle_ECS(Fichier_NotedeCalcul, Verif)
            If Verif = True Then
                ' Call Affichage_Resultat(Total_Comb, Type_Comb, Result)PthBcl ,PthCol,
                Beep() 'signale la fin des calculs
                MessageBox.Show("Calcul terminé avec succés." & Environment.NewLine & "Cliquez sur le bouton Editer pour faire afficher la note de calcul.", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Information)
                ' Me.Tc1.SelectTab(3) 'Affichage de la page de résultats
            End If
        Catch ex As Exception
            MessageBox.Show("Erreur: " + Environment.NewLine + ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub Verification_Coherence_Geometrique(ByRef Verif As Boolean)
        Dim i As Integer = 0
        For Each tuy In Reseau._Tuyau
            If tuy.Tete_Colonne = True Then i += 1
        Next
        If i = 0 Then
            Verif = False
            MessageBox.Show("Incohérence dans la géométrie du réseau ECS renseigné: ce réseau ne comporte pas de tête de colonne.", "Logiciel calcul boucle ECS", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub
    Private Sub BtnFichier_Click(sender As Object, e As EventArgs) Handles BtnFichier.Click
        Dim Verif As Boolean = True
        'remise à zero générale
        Reseau = New Installation
        Aff = New clsAffaire
        Exutoires.Clear()
        Call Variables_generales()
        'Appel au nouveau fichier
        Try
            With OpenFileDialog1
                'pour démarrer toujours sur le bon répertoire
                .InitialDirectory = Aff.msgData
                'pour éviter tout affichage initial dans la boite de dialogue
                .FileName = ""
                ' Vérifie que le fichier sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .CheckFileExists = True
                ' Vérifie que le chemin sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .CheckPathExists = True
                ' Obtient ou définit une extension par défaut. N'inclut pas le "." de début.
                .DefaultExt = "txt"
                ' Retourne le fichier référencé par un lien ? Si la valeur de retour est False, retourne simplement le fichier de liaison
                ' sélectionné. Si elle est True, retourne le fichier lié au fichier LNK.
                .DereferenceLinks = True
                .Title = "Ouvrir le projet"
                ' .InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
                .FilterIndex = 1
                .Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
                .Multiselect = False
                .RestoreDirectory = True
                ' Affiche le bouton Aide et la case à cocher Lecture seule ?
                .ShowHelp = True
                .ShowReadOnly = False
                ' Commence avec la case à cocher Lecture seule activée ?
                ' Ceci n'est justifié que si ShowReadOnly a la valeur True.
                .ReadOnlyChecked = False
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    If .FileName <> "" Then
                        Aff.FileName = OpenFileDialog1.FileName
                        Dim toto As String = Aff.FileName
                        Dim Racine As String = String.Empty
                        Call Lecture_chaine(toto, racine)
                        Call DeSerializeData(2, Racine, Verif)
                        If Verif = True Then
                            'la deserialization est OK
                            Me.Text = "Dimensionnement réseau boucle eau chaude sanitaire : " & toto
                            'Affichage Onglet Exutoire
                            Tc1.SelectTab(0)
                            Call Affichage_Tronçon_NON_Vierge(1)

                        End If
                    End If
                End If
            End With
            OpenFileDialog1.Dispose() 'pour libérer la mémoire
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du fichier: " + Environment.NewLine + ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Asterisk, MessageBoxDefaultButton.Button1)
        End Try
    End Sub
    Private Sub Lecture_chaine(ByRef toto As String, ByRef Racine As String)
        'Traitement de la chaine de caractère pour pouvoir être lu par le logiciel
        Try
            Dim i, i1, position As Integer
            Dim tutu As String = String.Empty
            toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
            i = Len(toto)     'indique la longueur totale de la chaine
            i1 = i
            position = InStrRev(toto, "\")
            i = i - position
            tutu = toto
            i1 = i1 - i
            toto = Microsoft.VisualBasic.Right(toto, i)
            Racine = Microsoft.VisualBasic.Left(tutu, i1)
        Catch ex As Exception

        End Try

    End Sub

    Private Sub BtnSauvegarde_Click(sender As Object, e As EventArgs) Handles BtnSauvegarde.Click
        Dim Verif As Boolean = True

        Try
            With SaveFileDialog1
                .Title = "Enregistrer le projet sous ..."
                ' Si l'utilisateur ne spécifie pas d'extension et si la propriété AddExtension a la valeur True, utilise cette extension. La valeur par défaut est "".
                .DefaultExt = "txt"
                ' Ajoute l'extension par défaut si l'utilisateur a omis de la spécifier.
                ' La valeur par défaut est True.
                .AddExtension = True
                ' Vérifie si le chemin de sortie existe. Demande avant de créer un fichier ? Demande avant de remplacer le fichier ? 
                ' La valeur par défaut est True.
                .CheckPathExists = True
                ' La valeur par défaut est False.
                .CreatePrompt = False
                ' La valeur par défaut est True.
                .OverwritePrompt = True
                ' La valeur par défaut est True.
                .ValidateNames = True
                ' La valeur par défaut est False.
                .ShowHelp = True
                .InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
                .Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
                .FilterIndex = 1
                .RestoreDirectory = True
                If .ShowDialog = Windows.Forms.DialogResult.OK Then
                    If .FileName <> "" Then
                        Call Lecture_Onglet_Reseau_Distrib(Verif)
                        If Verif = False Then
                            MessageBox.Show("Erreur lors de la lecture des données dans l'onglet Réseau de distribution", "Module BECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                            Exit Sub
                        End If
                        Call Lecture_Onglet_Reseau_Boucle_ECS(Verif)
                        If Verif = False Then
                            MessageBox.Show("Erreur lors de la lecture des données dans l'onglet Reseau boucle ECS", "Module BECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                            Exit Sub
                        End If
                        Lecture_PdcCommun(Verif)
                        If Verif = False Then
                            MessageBox.Show("Erreur lors de la lecture des données dans l'onglet Pertes de charges communes", "Module BECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                            Exit Sub
                        End If
                        Lecture_Crit_Dim(Verif)
                        If Verif = False Then
                            MessageBox.Show("Erreur lors de la lecture des données dans l'onglet Pertes de charges communes", "Module BECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                            Exit Sub
                        End If

                        Aff.FileName = .FileName
                        Call SerializeData(2) '1 indique que la serialisation concerne un réseau d'eau froide ou d'eau chaude
                    End If
                End If
            End With
            SaveFileDialog1.Dispose() 'pour libérer la mémoire
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la sauvegarde: " + Environment.NewLine + ex.Message & ex.StackTrace, "Module BECS - Sauvegarde", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub Lecture_Onglet_Reseau_Distrib(ByRef Verif As Boolean)
        Dim ntronçon As Integer
        Dim Tuy As New Tuyau
        Lecture_Reseau_Distrib(Tuy, Verif)
        If Verif = False Then Exit Sub
        ntronçon = CInt(LblTronçon.Text)
        With Reseau
            If ._Tuyau.Count < ntronçon Then
                ._Tuyau.Add(Tuy) 'ce tronçon n'a pas encore été renseigné
            Else
                'remplacement de l'exutoire existant
                ._Tuyau.Item(ntronçon - 1).L = Tuy.L
                ._Tuyau.Item(ntronçon - 1).PdcLoc = Tuy.PdcLoc
                ._Tuyau.Item(ntronçon - 1).Mat = Tuy.Mat
                ._Tuyau.Item(ntronçon - 1).Øimp = Tuy.Øimp
                ._Tuyau.Item(ntronçon - 1).Øint = Tuy.Øint
                ._Tuyau.Item(ntronçon - 1).Nom = Tuy.Nom
                ._Tuyau.Item(ntronçon - 1).Tronçon_Amont.Clear()
                ._Tuyau.Item(ntronçon - 1).Tronçon_Amont = Tuy.Tronçon_Amont
                ._Tuyau.Item(ntronçon - 1).Isol_ep = Tuy.Isol_ep
                ._Tuyau.Item(ntronçon - 1).Isol_λ = Tuy.Isol_λ
                ._Tuyau.Item(ntronçon - 1).Isol_T = Tuy.Isol_T
                ._Tuyau.Item(ntronçon - 1).Pth = Tuy.Pth
            End If
        End With
    End Sub
    Private Sub Lecture_Onglet_Reseau_Boucle_ECS(ByRef Verif As Boolean)
        Dim ntronçon As Integer
        Dim Tuy As New Tuyau
        Call Lecture_Reseau_Collecteur_Boucle(Tuy, Verif)
        If Verif = False Then Exit Sub
        ntronçon = CInt(LblTronçonR.Text)
        With Reseau
            If ._TuyauR.Count < ntronçon Then
                ._TuyauR.Add(Tuy) 'cet exutoire n'a pas encore été renseigné

            Else
                'remplacement de l'exutoire existant
                ._TuyauR.Item(ntronçon - 1).L = Tuy.L
                ._TuyauR.Item(ntronçon - 1).PdcLoc = Tuy.PdcLoc
                ._TuyauR.Item(ntronçon - 1).Mat = Tuy.Mat
                ._TuyauR.Item(ntronçon - 1).Øimp = Tuy.Øimp
                ._TuyauR.Item(ntronçon - 1).Øint = Tuy.Øint
                ._TuyauR.Item(ntronçon - 1).Nom = Tuy.Nom
                ._TuyauR.Item(ntronçon - 1).Tronçon_Aval.Clear()
                ._TuyauR.Item(ntronçon - 1).Tronçon_Aval = Tuy.Tronçon_Aval
                ._TuyauR.Item(ntronçon - 1).Tronçon_Distrib = Tuy.Tronçon_Distrib
                ._TuyauR.Item(ntronçon - 1).Isol_ep = Tuy.Isol_ep
                ._TuyauR.Item(ntronçon - 1).Isol_λ = Tuy.Isol_λ
                ._TuyauR.Item(ntronçon - 1).Isol_T = Tuy.Isol_T
                ._TuyauR.Item(ntronçon - 1).Pth = Tuy.Pth
            End If
        End With
    End Sub

    Private Sub frmEcs_Boucle_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Me.Text = "Dimensionnement boucle réseau eau chaude sanitaire : [aucun fichier chargé ]"
        'onglet Réseau Distrib
        Call Affichage_Tronçon_Vierge(1)
        'Onglet réseau boucle ECS
        Call Affichage_TronçonBcl_Vierge(1)
        'Onglet Pdc commun
        Call Affichage_PdcCommun()
        'Onglet critères de dimensionnement
        Call Affichage_Crit_Dim()
    End Sub

    Private Sub frmEcs_Boucle_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        ' frmMenu.Visible = True
    End Sub
    Private Sub BtnEdit_Click(sender As Object, e As EventArgs) Handles BtnEdit.Click
        Try
            Select Case Aff.Editeur
                Case 1 'Editeur Interne
                    Dim frm1 As New Editeur.frmEdit
                    frm1.Affichage_frmEdit(Fichier_NotedeCalcul)
                Case 2 'éditeur WordPad
                    Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'répertoire dans lequel se trouve le logiciel  
                    Dim startInfo As New ProcessStartInfo("wordpad.exe") '("word.exe")
                    startInfo.WindowStyle = ProcessWindowStyle.Normal
                    startInfo.Arguments = Fichier_NotedeCalcul
                    Process.Start(startInfo.Arguments)
                Case 3 'éditeur Word
                    Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'répertoire dans lequel se trouve le logiciel  
                    Dim startInfo As New ProcessStartInfo("word.exe") '("word.exe")
                    startInfo.WindowStyle = ProcessWindowStyle.Normal
                    startInfo.Arguments = Fichier_NotedeCalcul
                    Process.Start(startInfo.Arguments)
            End Select
        Catch ex As Exception
            Dim msg As String
            msg = "Impossible d'afficher la note de calcul" & Environment.NewLine + "Exception: " + ex.Message & ex.StackTrace
            MessageBox.Show(msg, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

#Region "Gestion des boutons d'aide"
    Private Sub BtnHlpRECStherm_Click(sender As Object, e As EventArgs) Handles BtnHlpRECStherm.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 10
        frm1.Show()
    End Sub

    Private Sub BtnHlpPdcBoucleECS_Click(sender As Object, e As EventArgs) Handles BtnHlpPdcBoucleECS.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 1
        frm1.Show()
    End Sub

    Private Sub BtnHlpPositionOrgReglage_Click(sender As Object, e As EventArgs) Handles BtnHlpPositionOrgReglage.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 3
        frm1.Show()
    End Sub

    Private Sub BtnHlpVminBoucle_Click(sender As Object, e As EventArgs) Handles BtnHlpVminBoucle.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 2
        frm1.Show()
    End Sub

    Private Sub BtnHlpTmECS_Click(sender As Object, e As EventArgs) Handles BtnHlpTmECS.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 12
        frm1.Show()
    End Sub

    Private Sub BtnHlpHMVC_Click(sender As Object, e As EventArgs) Handles BtnHlpHMVC.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 13
        frm1.Show()
    End Sub

    Private Sub BtnHlpHMVrd_Click(sender As Object, e As EventArgs) Handles BtnHlpHMVrd.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 13
        frm1.Show()
    End Sub
#End Region

#Region "Gestion des textbox"

    Private Sub TxtPth_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtPth.KeyPress
        Call Gestion_Keypress(e, TxtPth, True, False)
    End Sub

    Private Sub TxtepR_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtepR.KeyPress
        Call Gestion_Keypress(e, TxtepR, True, False)
    End Sub

    Private Sub TxtClap_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtClap.KeyPress
        Call Gestion_Keypress(e, TxtClap, True, False)
    End Sub

    Private Sub TxtDebMin_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtDebMin.KeyPress
        Call Gestion_Keypress(e, TxtDebMin, True, False)
    End Sub

    Private Sub TxtDistrib_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtDistrib.KeyPress
        Call Gestion_Keypress(e, TxtDistrib, True, False)
    End Sub

    Private Sub TxtdT_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtdT.KeyPress
        Call Gestion_Keypress(e, TxtdT, True, False)
    End Sub

    Private Sub TxtdTboucle_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtdTboucle.KeyPress
        Call Gestion_Keypress(e, TxtdTboucle, True, False)
    End Sub

    Private Sub TxtDtECS_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtDtECS.KeyPress
        Call Gestion_Keypress(e, TxtDtECS, True, False)
    End Sub

    Private Sub TxtdTR_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtdTR.KeyPress
        Call Gestion_Keypress(e, TxtdTR, True, False)
    End Sub

    Private Sub Txtep_KeyPress(sender As Object, e As KeyPressEventArgs) Handles Txtep.KeyPress
        Call Gestion_Keypress(e, Txtep, True, False)
    End Sub

    Private Sub TxtHMVC_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtHMVC.KeyPress
        Call Gestion_Keypress(e, TxtHMVC, True, False)
    End Sub

    Private Sub TxtHMVrd_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtHMVrd.KeyPress
        Call Gestion_Keypress(e, TxtHMVrd, True, False)
    End Sub

    Private Sub TxtL_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtL.KeyPress
        Call Gestion_Keypress(e, TxtL, True, False)
    End Sub

    Private Sub TxtLambda_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtLambda.KeyPress
        Call Gestion_Keypress(e, TxtLambda, True, False)
    End Sub

    Private Sub TxtLambdaR_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtLambdaR.KeyPress
        Call Gestion_Keypress(e, TxtLambdaR, True, False)
    End Sub

    Private Sub TxtLR_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtLR.KeyPress
        Call Gestion_Keypress(e, TxtLR, True, False)
    End Sub

    Private Sub TxtNumAvalR_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtNumAvalR.KeyPress
        Call Gestion_Keypress(e, TxtNumAvalR, True, True)
    End Sub

    Private Sub TxtPdcLocal_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtPdcLocal.KeyPress
        Call Gestion_Keypress(e, TxtPdcLocal, True, False)
    End Sub

    Private Sub TxtPdcR_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtPdcR.KeyPress
        Call Gestion_Keypress(e, TxtPdcR, True, False)
    End Sub

    Private Sub TxtPdcVanne_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtPdcVanne.KeyPress
        Call Gestion_Keypress(e, TxtPdcVanne, True, False)
    End Sub

    Private Sub TxtPrepECS_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtPrepECS.KeyPress
        Call Gestion_Keypress(e, TxtPrepECS, True, False)
    End Sub

    Private Sub TxtPthR_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtPthR.KeyPress
        Call Gestion_Keypress(e, TxtPthR, True, False)
    End Sub

    Private Sub TxtTempProd_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTempProd.KeyPress
        Call Gestion_Keypress(e, TxtTempProd, True, False)
    End Sub

    Private Sub TxtTrAmont_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTrAmont.KeyPress
        Call Gestion_Keypress(e, TxtTrAmont, True, False)
    End Sub

    Private Sub TxtVmin_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtVmin.KeyPress
        Call Gestion_Keypress(e, TxtVmin, True, False)
    End Sub

#End Region


End Class