﻿Imports System.IO
Public Class frmEvacEU
    ' Private note_de_calcul As String
    Dim Fichier_NotedeCalcul As String = String.Empty
#Region "Onglets 1, 2 et 3"
    Private Sub BtnTb1Affichage_Click(sender As System.Object, e As System.EventArgs) Handles BtnTb1Affichage.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 4
        frm1.Show()
    End Sub
    Private Sub BtnTB2Affichage_Click(sender As System.Object, e As System.EventArgs) Handles BtnTB2Affichage.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 5
        frm1.Show()
    End Sub
    Private Sub BtnTB3Affichage_Click(sender As System.Object, e As System.EventArgs) Handles BtnTB3Affichage.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 6
        frm1.Show()
    End Sub
#End Region

    Private Sub BtnTb4Calcul_Click(sender As System.Object, e As System.EventArgs) Handles BtnTb4Calcul.Click
        Dim Editeur As Boolean = False
        Dim Verif As Boolean = True
        Call Calcul_Collecteur(Editeur, Verif)
    End Sub
    Private Sub Calcul_Collecteur(ByVal Editeur As Boolean, ByRef Verif As Boolean)

        Try
            Fichier_NotedeCalcul = String.Empty
            Dim Diam_Col(5), debEP, Debit, PenteCollecteur, V_col(5) As Double ' SurfPlan, SurfBrute, PenteCouv, 
            Dim Pente_Impose As Boolean = False
            Dim Unitaire As Boolean = False

            Dim Nb_lavabo, Nb_lavaboColl, Nb_Baignoire, Nb_Douche, Nb_WCdirect, Nb_WCsiphon, Nb_bidet, Nb_Bonde, Nb_Bac, Nb_Urinoir, Nb_urinoirSiphon, Nb_MalLinge, Nb_MalVaisselle, Nb_Evier As Integer

            Lecture_Collecteur(Nb_lavabo, Nb_Baignoire, Nb_Douche, Nb_WCdirect, Nb_WCsiphon, Nb_bidet, Nb_Bonde, Nb_Bac, Nb_Urinoir, Nb_urinoirSiphon, Nb_MalLinge, Nb_MalVaisselle,
                                Nb_Evier, Nb_lavaboColl, debEP, Unitaire, Pente_Impose, PenteCollecteur, Verif)
            If Verif = False Then
                MessageBox.Show("Erreur: problème lecture", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End If
            Verification_Collecteur(PenteCollecteur, Verif)
            If Verif = False Then
                MessageBox.Show("Erreur: problème lecture", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Sub
            End If
            Call Calcul_Collecteur_EU(Nb_lavabo, Nb_Baignoire, Nb_Douche, Nb_WCdirect, Nb_WCsiphon, Nb_bidet, Nb_Bonde, Nb_Bac, Nb_Urinoir, Nb_urinoirSiphon, Nb_MalLinge,
                                      Nb_MalVaisselle, Nb_Evier, Nb_lavaboColl, debEP, Unitaire, Pente_Impose, PenteCollecteur, Diam_Col, Debit, V_col, Editeur, Fichier_NotedeCalcul, Verif)
            If Verif = True Then
                Call Affichage_Resultats_Collecteur(Pente_Impose, PenteCollecteur, Debit, Diam_Col, V_col)
                Beep() 'signale la fin des calculs
            End If
        Catch ex As Exception
            MessageBox.Show("Erreur: " & Environment.NewLine & ex.Message & ex.StackTrace, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub
    Private Sub BtnTb4Edit_Click(sender As System.Object, e As System.EventArgs) Handles BtnTb4Edit.Click
        Dim Editeur As Boolean = True
        Dim Verif As Boolean = True

        Call Calcul_Collecteur(Editeur, Verif)
        If Verif = True Then
            Try
                Select Case Aff.Editeur
                    Case 1 'Editeur Interne
                        Dim frm1 As New Editeur.frmEdit
                        frm1.Affichage_frmEdit(Fichier_NotedeCalcul)
                    Case 2 'éditeur WordPad
                        Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'répertoire dans lequel se trouve le logiciel Poutre BA
                        Dim startInfo As New ProcessStartInfo("wordpad.exe") '("word.exe")
                        startInfo.WindowStyle = ProcessWindowStyle.Normal
                        startInfo.Arguments = Fichier_NotedeCalcul
                        Process.Start(startInfo.Arguments)
                    Case 3 'éditeur Word
                        Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'répertoire dans lequel se trouve le logiciel Poutre BA
                        Dim startInfo As New ProcessStartInfo("word.exe") '("word.exe")
                        startInfo.WindowStyle = ProcessWindowStyle.Normal
                        startInfo.Arguments = Fichier_NotedeCalcul
                        Process.Start(startInfo.Arguments)
                End Select
            Catch ex As Exception
                Dim msg As String
                msg = "Impossible d'afficher la note de calcul" & Environment.NewLine + "Exception: " + ex.Message & ex.StackTrace
                MessageBox.Show(msg, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End Try
        End If

    End Sub

    Private Sub Lecture_Collecteur(ByRef Nb_lavabo As Integer, ByRef Nb_Baignoire As Integer, ByRef Nb_Douche As Integer, ByRef Nb_WCdirect As Integer, ByRef Nb_WCsiphon As Integer,
                                   ByRef Nb_bidet As Integer, ByRef Nb_Bonde As Integer, ByRef Nb_Bac As Integer, ByRef Nb_Urinoir As Integer, ByRef Nb_urinoirSiphon As Integer,
                                   ByRef Nb_MalLinge As Integer, ByRef Nb_MalVaisselle As Integer, ByRef Nb_Evier As Integer, ByRef Nb_lavaboColl As Integer, ByRef DebEP As Double, ByRef Unitaire As Boolean,
                                   ByRef Pente_Impose As Boolean, ByRef PenteConduit As Double, ByRef Verif As Boolean)
        If gestionderreur(TxtTb4Lavabo, True) = True Then Nb_lavabo = CInt(TxtTb4Lavabo.Text) Else Verif = False
        If gestionderreur(TxtTb4Baignoire, True) = True Then Nb_Baignoire = CInt(TxtTb4Baignoire.Text) Else Verif = False
        If gestionderreur(TxtTb4Douche, True) = True Then Nb_Douche = CInt(TxtTb4Douche.Text) Else Verif = False
        If gestionderreur(TxtTb4WCdirect, True) = True Then Nb_WCdirect = CInt(TxtTb4WCdirect.Text) Else Verif = False
        If gestionderreur(TxtTb4WCsiphon, True) = True Then Nb_WCsiphon = CInt(TxtTb4WCsiphon.Text) Else Verif = False
        If gestionderreur(TxtTb4Bidet, True) = True Then Nb_bidet = CInt(TxtTb4Bidet.Text) Else Verif = False
        If gestionderreur(TxtTb4Bonde, True) = True Then Nb_Bonde = CInt(TxtTb4Bonde.Text) Else Verif = False
        If gestionderreur(TxtTb4Bac, True) = True Then Nb_Bac = CInt(TxtTb4Bac.Text) Else Verif = False
        If gestionderreur(TxtTb4Urinoir, True) = True Then Nb_Urinoir = CInt(TxtTb4Urinoir.Text) Else Verif = False
        If gestionderreur(TxtTb4UrinoirSiphon, True) = True Then Nb_urinoirSiphon = CInt(TxtTb4UrinoirSiphon.Text) Else Verif = False
        If gestionderreur(TxtTb4MalLinge, True) = True Then Nb_MalLinge = CInt(TxtTb4MalLinge.Text) Else Verif = False
        If gestionderreur(TxtTb4MalVaisselle, True) = True Then Nb_MalVaisselle = CInt(TxtTb4MalVaisselle.Text) Else Verif = False
        If gestionderreur(TxtTb4Evier, True) = True Then Nb_Evier = CInt(TxtTb4Evier.Text) Else Verif = False
        If gestionderreur(TxtTb4LavaboColl, True) = True Then Nb_lavaboColl = CInt(TxtTb4LavaboColl.Text) Else Verif = False

        If RbtnTB4Unitaire.Checked = True Then
            If gestionderreur(TxtTb4DebEP, False) = True Then DebEP = CDbl(TxtTb4DebEP.Text) : Call gestionDebit(CbTb4debit, DebEP) Else Verif = False
            Unitaire = True
        ElseIf RbtnTB4Separatif.Checked = True Then
            Unitaire = False
        Else
            MsgBox("Erreur: " & Environment.NewLine & "La typologie du réseau n'a pas été renseignée.", MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            Verif = False
        End If
        If RbtnTb4PenteImpose.Checked = True Then
            If gestionderreur(TxtTb4PenteConduit, False) = True Then
                PenteConduit = CDbl(TxtTb4PenteConduit.Text)
                Pente_Impose = True
            Else
                Verif = False
            End If
        ElseIf RbtnTb4ValLibre.Checked = True Then
            Pente_Impose = False : PenteConduit = 0
        Else
            MsgBox("Erreur: " & Environment.NewLine & "La pente du réseau n'a pas été renseignée.", MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            Verif = False
        End If
        With Reseau
            If RbtnCoefSimultDTU.Checked = True Then
                If RbtnCoefHotel.Checked = True Then .Ycoef = 1.25
                If RbtnCoefHabitation.Checked = True Then .Ycoef = 1
                If RbtnCoefSimultAutre.Checked = True Then
                    If gestionderreur(TxtCoefCorrectAutre) = True Then .Ycoef = CDbl(TxtCoefCorrectAutre.Text) Else Verif = False
                End If
            Else

            End If
        End With
    End Sub
    Private Function gestionderreur(ByVal e As System.Windows.Forms.TextBox) As Boolean
        If e.Text = "" Then
            EP1.SetError(e, "le champ n'a pas été renseigné!!")
            gestionderreur = False
        ElseIf Not IsNumeric(CDbl(e.Text)) Then
            EP1.SetError(e, "le champ n'est pas une valeur numérique !!")
            gestionderreur = False
        Else
            EP1.SetError(e, "") ' Clear the error.
            gestionderreur = True
        End If
    End Function
    Private Function gestionderreur(ByVal e As System.Windows.Forms.TextBox, ByVal Vide As Boolean) As Boolean
        If e.Text = "" Then
            If Vide = True Then
                e.Text = "0"
                gestionderreur = True
            Else
                EP1.SetError(e, "le champ n'a pas été renseigné!!")
                gestionderreur = False
            End If
        ElseIf Not IsNumeric(CDbl(e.Text)) Then
            EP1.SetError(e, "le champ n'est pas une valeur numérique !!")
            gestionderreur = False
        Else
            EP1.SetError(e, "") ' Clear the error.
            gestionderreur = True
        End If
    End Function
    Private Sub gestionDebit(ByVal e As System.Windows.Forms.ComboBox, ByRef Var1 As Double)
        Select Case e.SelectedIndex
            Case 0 'en l/mn - 
                Var1 = Var1 / (60 * 1000) 'conversion en m3/s
            Case 1 'en l/s
                Var1 = Var1 / 1000 'conversion en m3/s
            Case 2 'm3/s
                Var1 = Var1 'pas de modif
        End Select
    End Sub
    Private Sub Verification_Collecteur(ByVal PenteConduit As Double, ByRef Verif As Boolean)
        If RbtnTb4PenteImpose.Checked = True And PenteConduit < 1 Then
            MessageBox.Show("Erreur: " & Environment.NewLine & "La pente du collecteur doit être supérieure à 1 cm/m.", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
            Verif = False
        End If
    End Sub
    Private Sub Affichage_Resultats_Collecteur(ByVal pente_impose As Boolean, ByVal penteconduit As Double, ByVal debit As Double, ByVal Diam_col() As Double, ByVal V_col() As Double)
        Dim i As Integer
        PnTb4.Visible = True

        Dgv1.Rows.Clear() 'efface toutes les lignes sauf l'entète
        Dgv1.Columns.Clear()
        With Dgv1
            .ColumnCount = 5
            .ColumnHeadersDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
            .Columns(0).Name = "Pente" & Environment.NewLine & "(cm/m)"
            .Columns(0).Width = 70
            .Columns(1).Name = "Débit" & Environment.NewLine & "(L/s)"
            .Columns(1).Width = 70
            .Columns(2).Name = "Diamètre collecteur" & Environment.NewLine & "(mm)"
            .Columns(2).Width = 110
            .Columns(3).Name = "Vitesse d'écoulement" & Environment.NewLine & "(m/s)"
            .Columns(3).Width = 110
            .Columns(4).Name = "Tube PVC" & Environment.NewLine & "retenu"
            .Columns(4).Width = 110
            .RowHeadersVisible = False
        End With
        If pente_impose = True Then
            'affichage sur une seule ligne
            With Dgv1
                .RowCount = 1
                .RowsDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
                .Item(0, 0).Value = penteconduit.ToString("#,##0.0")
                .Item(1, 0).Value = debit.ToString("#0.00")
                .Item(2, 0).Value = (Diam_col(0) * 1000).ToString("#,##0")
                .Item(3, 0).Value = V_col(0).ToString("#,##0.0")
                .Item(4, 0).Value = libel_diametre_PVC(Diam_col(0)).ToString
            End With
        Else
            'affichage sur 5 ligne
            With Dgv1
                .RowCount = 5
                .RowsDefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
                .RowsDefaultCellStyle.BackColor = Color.White
                .AlternatingRowsDefaultCellStyle.BackColor = Color.AliceBlue
                For i = 0 To 4
                    .Item(0, i).Value = (i + 1).ToString
                    .Item(1, i).Value = debit.ToString("#0.00")
                    .Item(2, i).Value = (Diam_col(i + 1) * 1000).ToString("#,##0")
                    .Item(3, i).Value = V_col(i + 1).ToString("#,##0.0")
                    .Item(4, i).Value = libel_diametre_PVC(Diam_col(i + 1)).ToString
                Next


            End With
        End If
    End Sub

    Private Sub frmEvacEU_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        'Onglet Collecteur EP
        TxtTb4Lavabo.Text = ""
        TxtTb4Baignoire.Text = ""
        TxtTb4Douche.Text = ""
        TxtTb4WCdirect.Text = ""
        TxtTb4WCsiphon.Text = ""
        TxtTb4Bidet.Text = ""
        TxtTb4Bonde.Text = ""
        TxtTb4Bac.Text = ""
        TxtTb4Urinoir.Text = ""
        TxtTb4UrinoirSiphon.Text = ""
        TxtTb4MalLinge.Text = ""
        TxtTb4MalVaisselle.Text = ""
        TxtTb4Evier.Text = ""
        TxtTb4LavaboColl.Text = ""
        RbtnTB4Unitaire.Checked = False : TxtTb4DebEP.Text = "" : TxtTb4DebEP.Enabled = False
        RbtnTB4Separatif.Checked = False
        RbtnTb4PenteImpose.Checked = False : TxtTb4PenteConduit.Text = "" : TxtTb4PenteConduit.Enabled = False
        RbtnTb4ValLibre.Checked = False
        PnTb4.Visible = False

    End Sub

#Region "Type et pente du collecteur"
    Private Sub RbtnTB4Unitaire_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnTB4Unitaire.CheckedChanged
        If RbtnTB4Unitaire.Checked = True Then
            TxtTb4DebEP.Enabled = True : TxtTb4DebEP.Focus()
        End If
    End Sub
    Private Sub RbtnTB4Separatif_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnTB4Separatif.CheckedChanged
        If RbtnTB4Separatif.Checked = True Then
            TxtTb4DebEP.Text = "" : TxtTb4DebEP.Enabled = False
        End If
    End Sub
    Private Sub RbtnTb4PenteImpose_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnTb4PenteImpose.CheckedChanged
        If RbtnTb4PenteImpose.Checked = True Then
            TxtTb4PenteConduit.Enabled = True : TxtTb4PenteConduit.Focus()
        End If
    End Sub
    Private Sub RbtnTb4ValLibre_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnTb4ValLibre.CheckedChanged
        If RbtnTb4ValLibre.Checked = True Then
            TxtTb4PenteConduit.Text = "" : TxtTb4PenteConduit.Enabled = False
        End If
    End Sub
#End Region

#Region "Coefficient de simultanéité"
    Private Sub RbtnCoefSimultDTU_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnCoefSimultDTU.CheckedChanged
        If RbtnCoefSimultDTU.Checked = True Then
            GbCoefSimultDTU.Enabled = True
        Else
            GbCoefSimultDTU.Enabled = False
        End If
    End Sub
    Private Sub RbtnCoefSimultAutre_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnCoefSimultAutre.CheckedChanged
        If RbtnCoefSimultAutre.Checked = True Then
            GbCoefSimultDTU.Enabled = False
        Else
            GbCoefSimultDTU.Enabled = True
        End If
    End Sub
    Private Sub RbtnCoefHabitation_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnCoefHabitation.CheckedChanged
        If RbtnCoefHabitation.Checked = True Then
            Reseau.Ycoef = 1
            TxtCoefCorrectAutre.Text = "" : TxtCoefCorrectAutre.Enabled = False
        End If
    End Sub
    Private Sub RbtnCoefHotel_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnCoefHotel.CheckedChanged
        If RbtnCoefHotel.Checked = True Then
            Reseau.Ycoef = 1.25
            TxtCoefCorrectAutre.Text = "" : TxtCoefCorrectAutre.Enabled = False
        End If
    End Sub
    Private Sub RbtnCoefEcole_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RbtnCoefEcole.CheckedChanged
        If RbtnCoefEcole.Checked = True Then
            TxtCoefCorrectAutre.Enabled = True : TxtCoefCorrectAutre.Focus()
        End If
    End Sub
#End Region

#Region " gestion des textbox"
    Private Sub TxtTb4Lavabo_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTb4Lavabo.KeyPress
        Call Gestion_Keypress(e, TxtTb4Lavabo, True, True)
    End Sub
    Private Sub TxtTb4Baignoire_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTb4Baignoire.KeyPress
        Call Gestion_Keypress(e, TxtTb4Lavabo, True, True)
    End Sub
    Private Sub TextBox12_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TextBox12.KeyPress
        Call Gestion_Keypress(e, TxtTb4Baignoire, True, True)
    End Sub
    Private Sub TxtTb4LavaboColl_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTb4LavaboColl.KeyPress
        Call Gestion_Keypress(e, TxtTb4LavaboColl, True, True)
    End Sub
    Private Sub TxtTb4Evier_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTb4Evier.KeyPress
        Call Gestion_Keypress(e, TxtTb4Evier, True, True)
    End Sub
    Private Sub TxtTb4MalVaisselle_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTb4MalVaisselle.KeyPress
        Call Gestion_Keypress(e, TxtTb4MalVaisselle, True, True)
    End Sub
    Private Sub TxtTb4MalLinge_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTb4MalLinge.KeyPress
        Call Gestion_Keypress(e, TxtTb4MalLinge, True, True)
    End Sub
    Private Sub TxtTb4UrinoirSiphon_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTb4UrinoirSiphon.KeyPress
        Call Gestion_Keypress(e, TxtTb4UrinoirSiphon, True, True)
    End Sub
    Private Sub TxtTb4Urinoir_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTb4Urinoir.KeyPress
        Call Gestion_Keypress(e, TxtTb4Urinoir, True, True)
    End Sub
    Private Sub TxtTb4Bac_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTb4Bac.KeyPress
        Call Gestion_Keypress(e, TxtTb4Bac, True, True)
    End Sub
    Private Sub TxtTb4Bonde_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTb4Bonde.KeyPress
        Call Gestion_Keypress(e, TxtTb4Bonde, True, True)
    End Sub
    Private Sub TxtTb4Bidet_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTb4Bidet.KeyPress
        Call Gestion_Keypress(e, TxtTb4Bidet, True, True)
    End Sub
    Private Sub TxtTb4WCsiphon_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTb4WCsiphon.KeyPress
        Call Gestion_Keypress(e, TxtTb4WCsiphon, True, True)
    End Sub
    Private Sub TxtTb4WCdirect_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTb4WCdirect.KeyPress
        Call Gestion_Keypress(e, TxtTb4WCdirect, True, True)
    End Sub
    Private Sub TxtTb4Douche_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTb4Douche.KeyPress
        Call Gestion_Keypress(e, TxtTb4Douche, True, True)
    End Sub
    Private Sub TxtTb4PenteConduit_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTb4PenteConduit.KeyPress
        Call Gestion_Keypress(e, TxtTb4PenteConduit, True, False)
    End Sub
    Private Sub TxtTb4DebEP_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtTb4DebEP.KeyPress
        Call Gestion_Keypress(e, TxtTb4DebEP, True, False)
    End Sub
    Private Sub TxtCoefCorrectAutre_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TxtCoefCorrectAutre.KeyPress
        Call Gestion_Keypress(e, TxtCoefCorrectAutre, True, False)
    End Sub
#End Region

#Region "Gestion des Aides"
    Private Sub BtnHlpdtu1988CoefCorrecteur_Click(sender As Object, e As EventArgs) Handles BtnHlpdtu1988CoefCorrecteur.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 9
        frm1.Show()
    End Sub

    Private Sub BtnHlpEvacAppareil_Click(sender As Object, e As EventArgs) Handles BtnHlpEvacAppareil.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 21
        frm1.Show()
    End Sub
    Private Sub BtnHlpGeneral_Click(sender As Object, e As EventArgs) Handles BtnHlpGeneral.Click
        Dim frm1 As frmAide
        frm1 = New frmAide
        FichierAide = 22
        frm1.Show()
    End Sub
#End Region

    Private Sub BtnSauvegarde_Click(sender As Object, e As EventArgs) Handles BtnSauvegarde.Click
        Dim filename As String
        Dim Verif As Boolean = True
        Dim Pente_Impose As Boolean = False
        Dim Unitaire As Boolean = False

        Dim Nb_lavabo, Nb_lavaboColl, Nb_Baignoire, Nb_Douche, Nb_WCdirect, Nb_WCsiphon, Nb_bidet, Nb_Bonde, Nb_Bac, Nb_Urinoir, Nb_urinoirSiphon, Nb_MalLinge, Nb_MalVaisselle, Nb_Evier As Integer
        Dim debEP, PenteCollecteur As Double
        Try
            With SaveFileDialog1
                .Title = "Enregistrer le projet sous ..."
                ' Si l'utilisateur ne spécifie pas d'extension et si la propriété AddExtension a la valeur True, utilise cette extension. La valeur par défaut est "".
                .DefaultExt = "txt"
                ' Ajoute l'extension par défaut si l'utilisateur a omis de la spécifier.
                ' La valeur par défaut est True.
                .AddExtension = True
                ' Vérifie si le chemin de sortie existe. Demande avant de créer un fichier ? Demande avant de remplacer le fichier ? 
                ' La valeur par défaut est True.
                .CheckPathExists = True
                ' La valeur par défaut est False.
                .CreatePrompt = False
                ' La valeur par défaut est True.
                .OverwritePrompt = True
                ' La valeur par défaut est True.
                .ValidateNames = True
                ' La valeur par défaut est False.
                .ShowHelp = True
                .InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
                .Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
                .FilterIndex = 1
                .RestoreDirectory = True
                If .ShowDialog = System.Windows.Forms.DialogResult.OK Then
                    If .FileName <> "" Then
                        Call Lecture_Donnees(Nb_lavabo, Nb_Baignoire, Nb_Douche, Nb_WCdirect, Nb_WCsiphon, Nb_bidet, Nb_Bonde, Nb_Bac, Nb_Urinoir, Nb_urinoirSiphon, Nb_MalLinge, Nb_MalVaisselle,
                            Nb_Evier, Nb_lavaboColl, debEP, Unitaire, Pente_Impose, PenteCollecteur, Verif)
                        If Verif = False Then Exit Sub
                        filename = .FileName
                        Call Ecriture_Fichier(filename, Nb_lavabo, Nb_Baignoire, Nb_Douche, Nb_WCdirect, Nb_WCsiphon, Nb_bidet, Nb_Bonde, Nb_Bac, Nb_Urinoir, Nb_urinoirSiphon, Nb_MalLinge, Nb_MalVaisselle,
                            Nb_Evier, Nb_lavaboColl, debEP, Unitaire, Pente_Impose, PenteCollecteur)
                    End If
                End If
            End With
            SaveFileDialog1.Dispose() 'pour libérer la mémoire
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la sauvegarde: " & Environment.NewLine & ex.Message & ex.StackTrace, "Module écriture fichier", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub Lecture_Donnees(ByRef Nb_lavabo As Integer, ByRef Nb_Baignoire As Integer, ByRef Nb_Douche As Integer, ByRef Nb_WCdirect As Integer, ByRef Nb_WCsiphon As Integer,
                                   ByRef Nb_bidet As Integer, ByRef Nb_Bonde As Integer, ByRef Nb_Bac As Integer, ByRef Nb_Urinoir As Integer, ByRef Nb_urinoirSiphon As Integer,
                                   ByRef Nb_MalLinge As Integer, ByRef Nb_MalVaisselle As Integer, ByRef Nb_Evier As Integer, ByRef Nb_lavaboColl As Integer, ByRef DebEP As Double, ByRef Unitaire As Boolean,
                                   ByRef Pente_Impose As Boolean, ByRef PenteCollecteur As Double, ByRef Verif As Boolean)

        Call Lecture_Collecteur(Nb_lavabo, Nb_Baignoire, Nb_Douche, Nb_WCdirect, Nb_WCsiphon, Nb_bidet, Nb_Bonde, Nb_Bac, Nb_Urinoir, Nb_urinoirSiphon, Nb_MalLinge, Nb_MalVaisselle,
                            Nb_Evier, Nb_lavaboColl, DebEP, Unitaire, Pente_Impose, PenteCollecteur, Verif)
        If Verif = False Then
            MessageBox.Show("Erreur: problème lecture", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End If
    End Sub
    Private Sub Ecriture_Fichier(ByVal filename As String, ByVal Nb_lavabo As Integer, ByVal Nb_Baignoire As Integer, ByVal Nb_Douche As Integer, ByVal Nb_WCdirect As Integer, ByVal Nb_WCsiphon As Integer, ByVal Nb_bidet As Integer,
                                 ByVal Nb_Bonde As Integer, ByVal Nb_Bac As Integer, ByVal Nb_Urinoir As Integer, ByVal Nb_urinoirSiphon As Integer, ByVal Nb_MalLinge As Integer, ByVal Nb_MalVaisselle As Integer, ByVal Nb_Evier As Integer,
                                 ByVal Nb_lavaboColl As Integer, ByVal DebEP As Double, ByVal Unitaire As Boolean, ByVal Pente_Impose As Boolean, ByVal PenteCollecteur As Double)
        Dim i As Integer
        Dim myStreamWriter As StreamWriter

        Try
            ' Create a StreamWriter using a Shared (static) File class.
            myStreamWriter = File.CreateText(filename)
            myStreamWriter.WriteLine("Fichier de sauvegarde de données pour le calcul d'un collecteur EU/EV/EP")
            myStreamWriter.WriteLine(Aff.Redacteur)
            myStreamWriter.WriteLine(Aff.Chantier)
            'appareils
            myStreamWriter.WriteLine(Nb_lavabo & " " & Nb_Baignoire & " " & Nb_Douche & " " & Nb_WCdirect & " " & Nb_WCsiphon & " " & Nb_bidet & " " & Nb_lavaboColl)
            myStreamWriter.WriteLine(Nb_Bonde & " " & Nb_Bac & " " & Nb_Urinoir & " " & Nb_urinoirSiphon & " " & Nb_MalLinge & " " & Nb_MalVaisselle & " " & Nb_Evier)
            myStreamWriter.WriteLine(DebEP & " " & Unitaire & " " & Pente_Impose & " " & PenteCollecteur)

            myStreamWriter.Flush() ' Obligatoire - Vide le tampon pour être sûr que tout soit écrit dans le fichier

        Catch exc As Exception
            MessageBox.Show("Le fichier n'a pas pu être ouvert ou écrit" & Environment.NewLine & "Vérifiez que le nom du fichier et son chemin d'accès soient exact" & Environment.NewLine & Environment.NewLine &
                 "Exception: " & exc.Message, "Module écriture fichier", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Finally
            ' Close the object if it has been created.
            If Not myStreamWriter Is Nothing Then myStreamWriter.Close()
        End Try

    End Sub

    Private Sub BtnFichier_Click(sender As Object, e As EventArgs) Handles BtnFichier.Click
        Dim filename As String
        Dim Verif As Boolean = True
        Dim Pente_Impose As Boolean = False
        Dim Unitaire As Boolean = False

        Dim Nb_lavabo, Nb_lavaboColl, Nb_Baignoire, Nb_Douche, Nb_WCdirect, Nb_WCsiphon, Nb_bidet, Nb_Bonde, Nb_Bac, Nb_Urinoir, Nb_urinoirSiphon, Nb_MalLinge, Nb_MalVaisselle, Nb_Evier As Integer
        Dim debEP, PenteCollecteur As Double
        Try
            With OpenFileDialog1
                If Aff.msgData <> String.Empty Then
                    .InitialDirectory = Aff.msgData
                Else
                    .InitialDirectory = My.Computer.FileSystem.SpecialDirectories.MyDocuments
                End If
                'pour éviter tout affichage initial dans la boite de dialogue
                .FileName = ""
                ' Vérifie que le fichier sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .CheckFileExists = True
                ' Vérifie que le chemin sélectionné existe. Sinon, la boîte de dialogue affiche un avertissement.
                .CheckPathExists = True
                ' Obtient ou définit une extension par défaut. N'inclut pas le "." de début.
                .DefaultExt = "txt"
                ' Retourne le fichier référencé par un lien ? Si la valeur de retour est False, retourne simplement le fichier de liaison
                ' sélectionné. Si elle est True, retourne le fichier lié au fichier LNK.
                .DereferenceLinks = True
                .Title = "Ouvrir le projet"
                ' .InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
                .FilterIndex = 1
                .Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
                .Multiselect = False
                .RestoreDirectory = True
                ' Affiche le bouton Aide et la case à cocher Lecture seule ?
                .ShowHelp = True
                .ShowReadOnly = False
                ' Commence avec la case à cocher Lecture seule activée ?
                ' Ceci n'est justifié que si ShowReadOnly a la valeur True.
                .ReadOnlyChecked = False
                If .ShowDialog = System.Windows.Forms.DialogResult.OK Then
                    If .FileName <> "" Then
                        filename = .FileName
                        Call Lecture_chaine(filename, Nb_lavabo, Nb_Baignoire, Nb_Douche, Nb_WCdirect, Nb_WCsiphon, Nb_bidet, Nb_Bonde, Nb_Bac, Nb_Urinoir, Nb_urinoirSiphon, Nb_MalLinge, Nb_MalVaisselle,
                            Nb_Evier, Nb_lavaboColl, debEP, Unitaire, Pente_Impose, PenteCollecteur, Verif)
                        If Verif = False Then Exit Sub
                        Call Affichage_Collecteur(Nb_lavabo, Nb_Baignoire, Nb_Douche, Nb_WCdirect, Nb_WCsiphon, Nb_bidet, Nb_Bonde, Nb_Bac, Nb_Urinoir, Nb_urinoirSiphon, Nb_MalLinge, Nb_MalVaisselle,
                            Nb_Evier, Nb_lavaboColl, DebEP, Unitaire, Pente_Impose, PenteCollecteur)
                    End If
                End If
            End With
            OpenFileDialog1.Dispose() 'pour libérer la mémoire
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du fichier: " & Environment.NewLine & ex.Message & ex.StackTrace, "Module lecture fichier", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
    Private Sub Lecture_chaine(ByVal filename As String, ByRef Nb_lavabo As Integer, ByRef Nb_Baignoire As Integer, ByRef Nb_Douche As Integer, ByRef Nb_WCdirect As Integer, ByRef Nb_WCsiphon As Integer,
                                   ByRef Nb_bidet As Integer, ByRef Nb_Bonde As Integer, ByRef Nb_Bac As Integer, ByRef Nb_Urinoir As Integer, ByRef Nb_urinoirSiphon As Integer,
                                   ByRef Nb_MalLinge As Integer, ByRef Nb_MalVaisselle As Integer, ByRef Nb_Evier As Integer, ByRef Nb_lavaboColl As Integer, ByRef DebEP As Double, ByRef Unitaire As Boolean,
                                   ByRef Pente_Impose As Boolean, ByRef PenteCollecteur As Double, ByRef Verif As Boolean)
        Dim myStreamReader As StreamReader
        Dim toto, titi(30) As String
        Dim j As Integer
        Verif = True

        Try
            myStreamReader = File.OpenText(filename)
            toto = myStreamReader.ReadLine 'on n'affecte aucune valeur sur la première ligne
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Aff.Redacteur = CStr(titi(1))
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi) 'ligne suivante
            Aff.Chantier = CStr(titi(1))
            'appareils
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
            Nb_lavabo = CInt(titi(1)) : Nb_Baignoire = CInt(titi(2)) : Nb_Douche = CInt(titi(3)) : Nb_WCdirect = CInt(titi(4)) : Nb_WCsiphon = CInt(titi(5)) : Nb_bidet = CInt(titi(6)) : Nb_lavaboColl = CInt(titi(7))
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
            Nb_Bonde = CInt(titi(1)) : Nb_Bac = CInt(titi(2)) : Nb_Urinoir = CInt(titi(3)) : Nb_urinoirSiphon = CInt(titi(4)) : Nb_MalLinge = CInt(titi(5)) : Nb_MalVaisselle = CInt(titi(6)) : Nb_Evier = CInt(titi(7))
            toto = myStreamReader.ReadLine : Call LectureGen(toto, titi)
            debEP = CDbl(titi(1)) : Unitaire = CBool(titi(2)) : Pente_Impose = CBool(titi(3)) : PenteCollecteur = CDbl(titi(4))

        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du fichier: " & Environment.NewLine & ex.Message & ex.StackTrace, "Module lecture fichier", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Verif = False
        Finally
            If Not myStreamReader Is Nothing Then myStreamReader.Close() ' Close the object if it has been created.
        End Try
    End Sub
    Private Sub LectureGen(ByVal toto As String, ByRef titi() As String)
        Dim blanc(45), i, j, position As Integer
        Dim tutu As String
        'toto = LCase(toto) 'transforme la chaine en minuscule, permet dans le fichier original d'écrire en minuscule ou en majuscule
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        toto = toto.Replace(vbTab, " ") 'remplace tous les caractères de tabulation par un blanc
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'détermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0
        'Suppression des points dans les nombres décimaux et remplacement par des virgules sinon plantage
        For i = 0 To j
            position = InStr(1, titi(i), ".")
            If position <> 0 Then Mid(titi(i), position) = ","
        Next
        Erase blanc
    End Sub

    Private Sub Affichage_Collecteur(ByVal Nb_lavabo As Integer, ByVal Nb_Baignoire As Integer, ByVal Nb_Douche As Integer, ByVal Nb_WCdirect As Integer, ByVal Nb_WCsiphon As Integer, ByVal Nb_bidet As Integer,
                                 ByVal Nb_Bonde As Integer, ByVal Nb_Bac As Integer, ByVal Nb_Urinoir As Integer, ByVal Nb_urinoirSiphon As Integer, ByVal Nb_MalLinge As Integer, ByVal Nb_MalVaisselle As Integer, ByVal Nb_Evier As Integer,
                                 ByVal Nb_lavaboColl As Integer, ByVal DebEP As Double, ByVal Unitaire As Boolean, ByVal Pente_Impose As Boolean, ByVal PenteCollecteur As Double)
        For Each TB As Control In Me.Controls
            If TypeOf (TB) Is TextBox Then TB.Text = ""
        Next

        TxtTb4Lavabo.Text = Nb_lavabo.ToString("#")
        TxtTb4Baignoire.Text = Nb_Baignoire.ToString("#")
        TxtTb4Douche.Text = Nb_Douche.ToString("#")
        TxtTb4WCdirect.Text = Nb_WCdirect.ToString("#")
        TxtTb4WCsiphon.Text = Nb_WCsiphon.ToString("#")
        TxtTb4Bidet.Text = Nb_bidet.ToString("#")
        TxtTb4Bonde.Text = Nb_Bonde.ToString("#")
        TxtTb4Bac.Text = Nb_Bac.ToString("#")
        TxtTb4Urinoir.Text = Nb_Urinoir.ToString("#")
        TxtTb4UrinoirSiphon.Text = Nb_urinoirSiphon.ToString("#")
        TxtTb4MalLinge.Text = Nb_MalLinge.ToString("#")
        TxtTb4MalVaisselle.Text = Nb_MalVaisselle.ToString("#")
        TxtTb4Evier.Text = Nb_Evier.ToString("#")
        TxtTb4LavaboColl.Text = Nb_lavaboColl.ToString("#")

        If Unitaire = True Then
            RbtnTB4Unitaire.Checked = True
            TxtTb4DebEP.Text = DebEP.ToString("#0.00")
        Else
            RbtnTB4Separatif.Checked = True
        End If

        If Pente_Impose = True Then
            RbtnTb4PenteImpose.Checked = True
            TxtTb4PenteConduit.Text = PenteCollecteur.ToString("#0.00")
        Else
            RbtnTb4ValLibre.Checked = True
        End If
        'With Reseau
        '    If RbtnCoefSimultDTU.Checked = True Then
        '        If RbtnCoefHotel.Checked = True Then .Ycoef = 1.25
        '        If RbtnCoefHabitation.Checked = True Then .Ycoef = 1
        '        If RbtnCoefSimultAutre.Checked = True Then
        '            If gestionderreur(TxtCoefCorrectAutre) = True Then .Ycoef = CDbl(TxtCoefCorrectAutre.Text) Else Verif = False
        '        End If
        '    Else

        '    End If
        'End With
    End Sub
End Class