Imports System.IO
Public Class frmMenu

    Public Affichage As Integer

    Private Sub frmMenu_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Dim reponse As Integer
        reponse = MsgBox("Voulez-vous quitter l'application ?", MsgBoxStyle.YesNo Or MsgBoxStyle.Exclamation Or MsgBoxStyle.DefaultButton1, "Calculette Plomberie")
        If reponse = 6 Then
            e.Cancel = False
            '  End
        Else
            e.Cancel = True
        End If
    End Sub
    Private Sub frmMenu_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim filename As String = String.Empty
        'Lecteur_Pdf = "acroRd32.exe" 'Acrobat reader provisoire
        'MnuNoteDeCalcul.Enabled = False : MnuGrapDef.Enabled = False
        Dim Verif As Boolean = True
        'Dim Q_Name(24) As String
        'Dim Q_EF(24), Q_EC(24), Di_EF(24), Di_EC(24), Y_App(24) As Double
        Try
            If My.Computer.FileSystem.DirectoryExists(Directory.GetCurrentDirectory.ToString() & "\data") = False Then
                My.Computer.FileSystem.CreateDirectory(Directory.GetCurrentDirectory.ToString() & "\data")
            End If
            If My.Computer.FileSystem.DirectoryExists(Directory.GetCurrentDirectory.ToString() & "\Note_de_calcul") = False Then
                My.Computer.FileSystem.CreateDirectory(Directory.GetCurrentDirectory.ToString() & "\Note_de_calcul")
            End If
            '--> cration du rpertoire  Aide si n'existe pas
            'ce qui est le cas lors de l'installation du logiciel
            If My.Computer.FileSystem.DirectoryExists(Directory.GetCurrentDirectory.ToString() & "\Aide") = False Then
                Try
                    '  Dim startPath As String = Directory.GetCurrentDirectory.ToString() ' & ".\start"
                    Dim zipPath As String = Directory.GetCurrentDirectory.ToString() & "\Aide.zip"
                    My.Computer.FileSystem.CreateDirectory(Directory.GetCurrentDirectory.ToString() & "\Aide")
                    Dim extractPath As String = Directory.GetCurrentDirectory.ToString() & "\Aide"
                    '   System.IO.Compression.ZipFile.CreateFromDirectory(startPath, zipPath)
                    System.IO.Compression.ZipFile.ExtractToDirectory(zipPath, extractPath)

                Catch ex As Exception
                    MessageBox.Show("Problme de dcompression du fichier Aide.zip" & Environment.NewLine & "Exception: " + ex.Message, Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                End Try
            End If
            filename = Directory.GetCurrentDirectory.ToString() & "\cfg_EF_ECS.ini"
            If File.Exists(filename) = False Then
                Call Variables_generales() 'Q_Name, Q_EF, Q_EC, Di_EF, Di_EC, Y_App) 'appel au modules contenant les variables par defaut
                frmConfig.Ecriture_fichier_Cfg_Ini(filename) ', Q_Name, Q_EF, Q_EC, Di_EF, Di_EC, Y_App) 'creation du fichier lors de l'installation du logiciel
            Else

                'Affichage des valeurs en cours
                Try
                    'Certaines variables gnrales ne peuvent pas tre modifies par le fichier Config.ini d'ou l'appel  Variables Gnrales
                    Call Variables_generales() 'Q_Name, Q_EF, Q_EC, Di_EF, Di_EC, Y_App) 'lecture variables par defaut
                    Call Lecture_fichier_Ini(filename, Verif) 'Initialisation du logiciel avec les prfrences de l'utilisateur
                    If Verif = False Then
                        Call Variables_generales() 'Q_Name, Q_EF, Q_EC, Di_EF, Di_EC, Y_App) 'appel aux variables gnrales inscrites en dur dans le logiciel
                        MessageBox.Show("Appel  la configuration par dfaut", "Module dmarrage", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    End If
                Catch exc As Exception
                    MessageBox.Show("Erreur lors du chargement du logiciel:" + Environment.NewLine + "Exception: " + exc.Message, "Module gnral", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    Call Variables_generales() 'Q_Name, Q_EF, Q_EC, Di_EF, Di_EC, Y_App) 'appel aux variables gnrales inscrites en dur dans le logiciel
                    MessageBox.Show("Appel  la configuration par dfaut", "Module dmarrage", MessageBoxButtons.OK, MessageBoxIcon.Information)
                End Try
            End If
        Catch ex As Exception
            MessageBox.Show("Erreur lors de la lecture du fichier de configuration: " & Environment.NewLine & ex.Message & Environment.NewLine & ex.StackTrace, "Calculette plomberie", MessageBoxButtons.OK, MessageBoxIcon.Error,
                            MessageBoxDefaultButton.Button1)
        End Try

    End Sub

    Private Sub BtnDimEC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDimEC.Click
        '  Me.Hide() 'le prog tourne en tache de fond, vite de le rappeler
        Dim frm1 As New frmReseau_EF_ECS
        Affichage = 1
        Reseau.Modele_Calcul = 2
        frm1.Show()
        frm1 = Nothing 'pour librer la mmoire
    End Sub
    Private Sub BtnDimEF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDimEF.Click
        '  Me.Hide() 'le prog tourne en tache de fond, vite de le rappeler
        Dim frm1 As New frmReseau_EF_ECS
        Affichage = 1
        Reseau.Modele_Calcul = 1
        frm1.Show()
        frm1 = Nothing 'pour librer la mmoire
    End Sub
    Private Sub BtnBclEC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnBclEC.Click
        '   Me.Hide() 'le prog tourne en tache de fond, vite de le rappeler
        Dim frm1 As New frmEcs_Boucle
        Affichage = 1
        '   Modele_Calcul = 3
        frm1.Show()
        frm1 = Nothing 'pour librer la mmoire
    End Sub
    Private Sub BtnConfig_Click(sender As System.Object, e As System.EventArgs) Handles BtnConfig.Click
        '    Me.Hide() 'le prog tourne en tache de fond, vite de le rappeler
        Dim frm1 As New frmConfig
        Affichage = 1
        frm1.Show()
        frm1 = Nothing 'pour librer la mmoire
    End Sub
    Private Sub BtnApropos1_Click(sender As System.Object, e As System.EventArgs) Handles BtnApropos.Click
        Dim frm1 As New frmSplash
        frm1.Show()
        frm1 = Nothing 'pour librer la mmoire
    End Sub

    Private Sub BtnConversion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnConversion.Click
        'Me.Hide() 'le prog tourne en tache de fond, vite de le rappeler
        Dim frm1 As New frmConversion
        frm1.Show()
        frm1 = Nothing 'pour librer la mmoire
    End Sub
    Private Sub BtnVanneRegulation_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnVanneRegulation.Click
        ' Me.Hide() 'le prog tourne en tache de fond, vite de le rappeler
        Dim frm1 As New frmVanneRegulation
        Affichage = 1
        frm1.Show()
        frm1 = Nothing 'pour librer la mmoire
    End Sub
    Private Sub BtnDebProba_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDebProba.Click
        'Me.Hide() 'le prog tourne en tache de fond, vite de le rappeler
        Dim frm1 As New frmDebitProbable
        Affichage = 1
        frm1.Show()
        frm1 = Nothing 'pour librer la mmoire
    End Sub
    Private Sub BtnEvacEP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnEvacEP.Click
        'Me.Hide() 'le prog tourne en tache de fond, vite de le rappeler
        Dim frm1 As New frmEvacEP
        frm1.Show()
        frm1 = Nothing 'pour librer la mmoire
    End Sub

    Private Sub BtnEvacEU_EV_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnEvacEU_EV.Click
        ' Me.MinimumSize 'le prog tourne en tache de fond
        Dim frm1 As New frmEvacEU
        frm1.Show()
        frm1 = Nothing 'pour librer la mmoire
    End Sub
    Private Sub BtnDebitVitesse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDebitVitesse.Click
        ' Me.Hide() 'le prog tourne en tache de fond, vite de le rappeler
        Dim frm1 As New frmDebitVitesse
        frm1.Show()
        frm1 = Nothing 'pour librer la mmoire
    End Sub
    Private Sub BtnProdECS_Click(sender As System.Object, e As System.EventArgs) Handles BtnProdECS.Click
        'Me.Hide() 'le prog tourne en tache de fond, vite de le rappeler
        Dim frm1 As New frmProdECS
        Affichage = 1
        frm1.Show()
    End Sub
    Private Sub BtnLoiMelange_Click(sender As System.Object, e As System.EventArgs) Handles BtnLoiMelange.Click
        'Me.Hide() 'le prog tourne en tache de fond, vite de le rappeler
        Dim frm1 As New frmLoiMelange
        Affichage = 1
        frm1.Show()
    End Sub
End Class
